SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Fakes'!
SystemOrganization addCategory: #'Monticello2-Info'!
SystemOrganization addCategory: #'Monticello2-Repositories'!
SystemOrganization addCategory: #'Monticello2-Slices'!
SystemOrganization addCategory: #'Monticello2-Squeak'!
SystemOrganization addCategory: #'Monticello2-Tests'!
SystemOrganization addCategory: #'Monticello2-UI'!
SystemOrganization addCategory: #'Monticello2-Utilities'!
SystemOrganization addCategory: #'Monticello2-Versions'!

!Set class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:15'!
materializeWith: aMarshal
	^ aMarshal readSetOfClass: self! !

!Set methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:40'!
serializeWith: aMarshal
	aMarshal writeSet: self! !

!MethodReference methodsFor: '*monticello2' stamp: 'cwp 3/3/2005 02:15'!
asElement
	^ MDMethodElement 
		className: classSymbol 
		selector: methodSymbol
		classIsMeta: classIsMeta! !

!Boolean class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:52'!
materializeWith: aMarshal
	^ aMarshal readBooleanOfClass: self! !

!Boolean methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:50'!
serializeWith: aMarshal
	aMarshal writeBoolean: self! !

!Symbol class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:03'!
materializeWith: aMarshal
	^ aMarshal readSymbol! !

Object subclass: #MDByteIndex
	instanceVariableNames: 'keySize valueSize streamSize stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2005 03:08'!
stream: aStream keySize: keyNumber valueSize: valueNumber
	^ self stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: aStream size! !

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/19/2005 02:41'!
stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	^ self basicNew setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray
	^ self at: keyArray ifAbsent: [self error: 'Could not find key ', keyArray printString]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray ifAbsent: errorBlock
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	^ self basicAt: keyArray ifAbsent: errorBlock! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:37'!
at: keyArray put: valueArray
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	valueArray size = valueSize ifFalse: [self error: 'Value must be exactly ', valueSize asString, ' bytes'].
	^ self basicAt: keyArray put: valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:34'!
basicAt: keyArray ifAbsent: errorBlock
	| i key |
	i _ self scanFor: keyArray.
	key _ self keyBytesAtIndex: i.
	^ key = keyArray
		ifTrue: [self valueBytesAtIndex: i]
		ifFalse: errorBlock! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
basicAt: keyArray put: valueArray
	| i key |
	i _ self scanFor: keyArray.
	key _ self keyBytesAtIndex: i.
	key = keyArray ifFalse:
		[self writeTally: self tally + 1.
		self writeKeyBytes: keyArray atIndex: i].
	self writeValueBytes: valueArray atIndex: i.
	^ valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:45'!
hash: keyArray
	^ keyArray hash! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:38'!
keyBytesAtIndex: i
	self seekTo: i.
	^ stream atEnd
		ifTrue: [ByteArray new: keySize]
		ifFalse: [stream next: keySize]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
keySize
	^ keySize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:07'!
maxIndex
	^ streamSize - 4 // self recordSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:43'!
recordSize
	^ keySize + valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:33'!
scanFor: keyArray
	| start |
	start _ (self hash: keyArray) \\ self maxIndex.
	start to: self maxIndex do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	0 to: start - 1 do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	
	self error: 'Index is full'! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:29'!
scanFor: keyArray at: i
	| key |
	key _ self keyBytesAtIndex: i.
	^ key = keyArray or: [key allSatisfy: [:b | b = 0]]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
seekTo: i
	stream position: i * self recordSize + 4! !

!MDByteIndex methodsFor: 'initialize-release' stamp: 'avi 3/19/2005 02:41'!
setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	keySize _ keyNumber.
	valueSize _ valueNumber.
	streamSize _ streamNumber.
	stream _ aStream.
	stream binary! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/19/2005 02:51'!
streamSize
	^ streamSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/15/2005 03:23'!
tally
	stream reset.
	^ stream atEnd
		ifTrue: [0]
		ifFalse: [stream nextInt32]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:41'!
valueBytesAtIndex: i
	self seekTo: i.
	stream skip: keySize.
	^ stream next: valueSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
valueSize
	^ valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeKeyBytes: keyBytes atIndex: i
	self seekTo: i.
	stream nextPutAll: keyBytes! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
writeTally: aNumber
	stream reset.
	stream nextInt32Put: aNumber! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeValueBytes: valueBytes atIndex: i
	self seekTo: i.
	stream skip: keySize.
	stream nextPutAll: valueBytes! !

Object subclass: #MDElementDefinition
	instanceVariableNames: 'element properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementDefinition class methodsFor: 'instance creation' stamp: 'cwp 11/28/2004 12:52'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDElementDefinition methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:22'!
autoMergeWithDefinition: anElementDefinition in: anImageProxy
	| newDefinition |
	newDefinition _ self copy.
	element
		merge: anElementDefinition properties
		into: newDefinition properties
		in: anImageProxy
		onFailure: [^ nil].
	^ newDefinition! !

!MDElementDefinition methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:25'!
autoMergeWithRemoval: anElementRemoval in: anImageProxy
	element alwaysPreferRemoval ifTrue: [^ anElementRemoval].
	element alwaysPreferDefinition ifTrue: [^ self].
	^ nil! !

!MDElementDefinition methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:03'!
autoMergeWith: aSnapshot in: anImageProxy
	^ aSnapshot autoMergeWithDefinition: self in: anImageProxy! !

!MDElementDefinition methodsFor: 'copying' stamp: 'avi 11/29/2004 14:16'!
copy
	| new |
	new _ self species forElement: element.
	properties keysAndValuesDo:
		[:k :v|
		new properties at: k put: v].
	^ new! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 5/24/2005 07:42'!
displayFor: anImageProxy
	^ self element display: properties for: anImageProxy! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'cwp 11/28/2004 12:56'!
element
	^ element! !

!MDElementDefinition methodsFor: 'initialize-release' stamp: 'cwp 11/29/2004 00:50'!
initializeWithElement: anElement
	element _ anElement.
	properties _ MDPropertyDictionary new! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:41'!
isLoadableInto: anImageProxy
	^ element isLoadable: properties into: anImageProxy! !

!MDElementDefinition methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ false! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 3/2/2005 23:44'!
isUpToDateFor: anImageProxy
	^ (anImageProxy hasElement: element)
		and: [element is: properties upToDateFor: anImageProxy]! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:54'!
loadInto: anImageProxy
	element load: properties into: anImageProxy! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'avi 12/2/2004 01:53'!
updateFrom: anImageProxy
	(anImageProxy hasElement: element) ifFalse: [^ MDElementRemoval forElement: element].
	element update: properties from: anImageProxy.
	^ self! !

!MDElementDefinition methodsFor: 'comparing' stamp: 'cwp 3/7/2005 17:22'!
= other
	^ self species = other species
		and: [self element = other element]
		and: [self properties = other properties]! !

Object subclass: #MDElementRemoval
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementRemoval class methodsFor: 'as yet unclassified' stamp: 'avi 12/2/2004 01:23'!
forElement: anImageElement
	^ self basicNew initializeWithElement: anImageElement! !

!MDElementRemoval methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:16'!
autoMergeWithDefinition: anElementDefinition in: anImageProxy
	^ anElementDefinition autoMergeWithRemoval: self in: anImageProxy! !

!MDElementRemoval methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:04'!
autoMergeWith: aSnapshot in: anImageProxy
	^ aSnapshot autoMergeWithRemoval: self in: anImageProxy! !

!MDElementRemoval methodsFor: 'image proxy' stamp: 'cwp 5/24/2005 07:44'!
displayFor: anImageProxy
	^ '-- removed --'! !

!MDElementRemoval methodsFor: 'accessing' stamp: 'avi 12/2/2004 01:54'!
element
	^ element! !

!MDElementRemoval methodsFor: 'comparing' stamp: 'cwp 3/7/2005 17:21'!
hash
	^ element hash! !

!MDElementRemoval methodsFor: 'initialize-release' stamp: 'avi 12/2/2004 01:23'!
initializeWithElement: anImageElement
	element _ anImageElement! !

!MDElementRemoval methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:52'!
isLoadableInto: anImageProxy
	"Removals are always loadable."
	
	^ true! !

!MDElementRemoval methodsFor: 'testing' stamp: 'avi 12/2/2004 01:51'!
isRemoval
	^ true! !

!MDElementRemoval methodsFor: 'testing' stamp: 'avi 12/2/2004 01:56'!
isUpToDateFor: anImageProxy
	^ (anImageProxy hasElement: element) not! !

!MDElementRemoval methodsFor: 'image proxy' stamp: 'avi 12/2/2004 01:27'!
loadInto: anImageProxy
	element removeFrom: anImageProxy! !

!MDElementRemoval methodsFor: 'image proxy' stamp: 'avi 12/2/2004 01:51'!
updateFrom: anImageProxy
	^ (MDElementDefinition forElement: element) updateFrom: anImageProxy! !

!MDElementRemoval methodsFor: 'comparing' stamp: 'cwp 3/7/2005 17:20'!
= other
	^ self species = other species and: [self element = other element]! !

Object subclass: #MDFakeClassDescription
	instanceVariableNames: 'superclass methodDict format instanceVariables organization name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

MDFakeClassDescription subclass: #MDFakeClass
	instanceVariableNames: 'subclasses classPool sharedPools environement category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeClass class methodsFor: 'instance creation' stamp: 'cwp 8/27/2005 11:50'!
basedOn: aClass
	^ self new initializeFromClass: aClass theNonMetaClass! !

!MDFakeClass methodsFor: 'mutation' stamp: 'cwp 8/27/2005 10:37'!
addClassVarName: aString
	classPool at: aString asSymbol put: nil! !

!MDFakeClass methodsFor: 'mutation' stamp: 'cwp 8/28/2005 16:11'!
addSharedPool: aSharedPool 
	(self sharedPools includes: aSharedPool)
		ifTrue: [^self error: 'This is already in my shared pool list'].
	sharedPools == nil
		ifTrue: [sharedPools _ OrderedCollection with: aSharedPool]
		ifFalse: [sharedPools add: aSharedPool]! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
category
	^category! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
category: anObject
	category := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
classPool
	^classPool! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
classPool: anObject
	classPool := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 10:48'!
classVarNames
	^ classPool keys! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
environement
	^environement! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
environement: anObject
	environement := anObject! !

!MDFakeClass methodsFor: 'initialize-release' stamp: 'cwp 8/28/2005 16:43'!
initializeFromClass: aClass
	superclass _ aClass superclass.
	methodDict _ aClass methodDict copy.
	format _ aClass format.
	name _ aClass name.
	organization _ aClass organization copy.
	instanceVariables _ aClass instVarNames.
	classPool _ aClass classPool copy.
	sharedPools _ aClass sharedPools copy.
	! !

!MDFakeClass methodsFor: 'testing' stamp: 'cwp 8/27/2005 12:50'!
isMeta
	^ false! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
sharedPools
	^sharedPools! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
sharedPools: anObject
	sharedPools := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
subclasses
	^subclasses! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/26/2005 18:35'!
subclasses: anObject
	subclasses := anObject! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theMetaClass
	^MDFakeMetaclass basedOn: self theRealClass class! !

!MDFakeClass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:52'!
theNonMetaClass
	^ self! !

!MDFakeClassDescription methodsFor: 'mutation' stamp: 'cwp 8/27/2005 11:36'!
addInstVarName: aString
	instanceVariables _ instanceVariables copyWith: aString! !

!MDFakeClassDescription methodsFor: 'copying' stamp: 'cwp 8/27/2005 11:36'!
copy
	^ self class basedOn: self! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
format
	^format! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
format: anObject
	format := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
instVarNames
	^ instanceVariables! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
instVarNames: anArray
	instanceVariables _ anArray! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
methodDict
	^methodDict! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:37'!
methodDict: anObject
	methodDict := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:38'!
name
	^ name! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:38'!
name: aSymbol
	name _ aSymbol! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
organization
	^organization! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
organization: anObject
	organization := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
superclass
	^superclass! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:39'!
superclass: anObject
	superclass := anObject! !

!MDFakeClassDescription methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theRealClass
	^Smalltalk classNamed: name! !

MDFakeClassDescription subclass: #MDFakeMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeMetaclass class methodsFor: 'as yet unclassified' stamp: 'cwp 8/27/2005 11:56'!
basedOn: aMetaclass
	^ self new initializeFromMetaclass: aMetaclass theMetaClass! !

!MDFakeMetaclass methodsFor: 'initialize-release' stamp: 'cwp 8/27/2005 11:53'!
initializeFromMetaclass: aMetaclass
	superclass _ aMetaclass superclass.
	methodDict _ aMetaclass methodDict copy.
	format _ aMetaclass format.
	name _ aMetaclass theNonMetaClass name.
	organization _ aMetaclass organization copy.
	instanceVariables _ aMetaclass instVarNames.
! !

!MDFakeMetaclass methodsFor: 'testing' stamp: 'cwp 8/27/2005 12:50'!
isMeta
	^ true! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:53'!
name
	^ name, ' class'! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:52'!
theMetaClass
	^ self! !

!MDFakeMetaclass methodsFor: 'accessing' stamp: 'cwp 8/27/2005 11:55'!
theNonMetaClass
	^ MDFakeClass basedOn: self theRealClass! !

Object subclass: #MDFakeElementAdaptor
	instanceVariableNames: 'image element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/4/2005 00:35'!
forElement: anElement inImage: aDictionary
	^ self new setImage: aDictionary element: anElement! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:29'!
checkDependencies
	self isLoadable ifFalse: [self error: 'Unmet dependency']! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 5/24/2005 07:54'!
display: properties
	^ properties one asString! !

!MDFakeElementAdaptor methodsFor: 'private' stamp: 'cwp 2/13/2005 19:31'!
isLoadable
	| required |
	(element name includes: $/) ifFalse: [^ true].
	required := element name copyUpTo: $/.
	^ image keys anySatisfy: [:ea | ea name = required]
! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/13/2005 19:44'!
isLoadable: properties
	^ self isLoadable! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:36'!
isPresent
	^ image includesKey: element! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:39'!
isUpToDate: properties
	properties keysAndValuesDo: 
		[:key :value |
		(self properties at: key ifAbsent: [^ false]) = value ifFalse: [^ false]].
	^ true
	! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 3/25/2005 22:03'!
load: properties 
	self checkDependencies.
	self properties.
	properties keysAndValuesDo: [:key :value | self properties at: key put: value]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'avi 3/16/2005 12:33'!
merge: aPropertyDictionary into: otherPropertyDictionary onFailure: aBlock
	^ aBlock value! !

!MDFakeElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/13/2005 18:17'!
properties
	^ image at: element ifAbsentPut: [Dictionary new]! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:40'!
remove
	image removeKey: element ifAbsent: []! !

!MDFakeElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 2/4/2005 00:34'!
setImage: aFakeImageProxy element: anElement
	image _ aFakeImageProxy.
	element _ anElement! !

!MDFakeElementAdaptor methodsFor: 'public' stamp: 'cwp 2/4/2005 00:33'!
update: properties
	self properties keysAndValuesDo: [:key :value | properties at: key put: value]! !

Object subclass: #MDHashedObject
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDHashedObject class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:51'!
extension
	self subclassResponsibility! !

!MDHashedObject class methodsFor: 'serialization' stamp: 'cwp 8/9/2005 21:01'!
materializeWith: aMarshall
	^ aMarshall readHashedObject: self basicNew! !

!MDHashedObject methodsFor: 'accessing' stamp: 'cwp 8/9/2005 21:43'!
hashstamp
	^ cache! !

!MDHashedObject methodsFor: 'initialize-release' stamp: 'cwp 8/9/2005 21:44'!
initHashstamp
	cache _ MDHashstamp 
					forObject: self 
					timestamp: cache! !

!MDHashedObject methodsFor: 'initialize-release' stamp: 'cwp 8/9/2005 21:44'!
initialize
	cache _ MDTimestamp now.! !

!MDHashedObject methodsFor: 'serialization' stamp: 'cwp 8/9/2005 20:44'!
serializeWith: aMarshall
	aMarshall writeHashedObject: self! !

!MDHashedObject methodsFor: 'accessing' stamp: 'cwp 8/9/2005 21:44'!
timestamp
	^ cache timestamp! !

MDHashedObject subclass: #MDSnapshot
	instanceVariableNames: 'meta contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDSnapshot class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:52'!
extension
	^ 'snap'! !

!MDSnapshot class methodsFor: 'instance creation' stamp: 'cwp 3/23/2005 22:52'!
withVersions: versions
	^ self new setVersions: versions! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 3/27/2005 22:39'!
contents
	^ contents! !

!MDSnapshot methodsFor: 'repository' stamp: 'cwp 3/27/2005 22:38'!
getVersionsFrom: aRepository
	^ meta, contents collect: [:ea | aRepository get: ea]! !

!MDSnapshot methodsFor: 'comparing' stamp: 'cwp 4/10/2005 12:43'!
hash
	^ self meta hash bitXor: self contents hash! !

!MDSnapshot methodsFor: 'accessing' stamp: 'cwp 3/27/2005 22:39'!
meta
	^ meta! !

!MDSnapshot methodsFor: 'initialize-release' stamp: 'cwp 8/9/2005 20:57'!
setVersions: aSet
	meta _ Set new.
	contents _ Set new.
	aSet do: [:ea | ea element isMeta 
					ifTrue: [meta add: ea hashstamp] 
					ifFalse: [contents add: ea hashstamp]].
	self initHashstamp.! !

!MDSnapshot methodsFor: 'comparing' stamp: 'cwp 4/10/2005 12:43'!
= other
	^ self species = other species 
		and: [self meta = other meta]
		and: [self contents = other contents]! !

MDHashedObject subclass: #MDVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

MDVersion subclass: #MDElementVersion
	instanceVariableNames: 'snapshot ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDElementVersion class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:56'!
snapshot: anElementSnapshot
	^ self snapshot: anElementSnapshot ancestry: Set new! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 05:19'!
snapshot: anElementSnapshot ancestry: aSet
	^ self 
		snapshot: anElementSnapshot
		ancestry: aSet
		timestamp: MDTimestamp now! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'cwp 4/3/2005 04:19'!
snapshot: anElementSnapshot ancestry: aSet timestamp: aTimeStamp
	^ self basicNew 
		setSnapshot: anElementSnapshot 
		ancestry: aSet
		timestamp: aTimeStamp! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:53'!
ancestry
	^ ancestry! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:39'!
element
	^ snapshot element! !

!MDElementVersion methodsFor: 'accessing' stamp: 'cwp 3/23/2005 23:15'!
fullAncestry
	^ancestry copyWith: self hashstamp! !

!MDElementVersion methodsFor: 'comparing' stamp: 'cwp 3/23/2005 23:15'!
precedes: aVersion 
	^aVersion ancestry includes: self hashstamp! !

!MDElementVersion methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:01'!
resolveConflictWith: aVersion in: anImageProxy using: twoArgBlock
	(self snapshot autoMergeWith: aVersion snapshot in: anImageProxy) ifNotNilDo: [:snap | ^ snap].
	^ twoArgBlock value: self value: aVersion! !

!MDElementVersion methodsFor: 'initialize-release' stamp: 'cwp 8/9/2005 21:44'!
setSnapshot: elementSnapshot ancestry: aCollection timestamp: aTimestamp
	snapshot _ elementSnapshot.
	ancestry _ aCollection.
	cache _ aTimestamp.
	self initHashstamp! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:17'!
snapshot
	^ snapshot! !

MDVersion subclass: #MDNullVersion
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDNullVersion class methodsFor: 'as yet unclassified' stamp: 'cwp 2/27/2005 21:31'!
forElement: anElement
	^ self new setElement: anElement! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
ancestry
	^ Set new! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:36'!
element
	^ element! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 22:24'!
fullAncestry
	^ Set new! !

!MDNullVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
precedes: anElementVersion 
	^true! !

!MDNullVersion methodsFor: 'initialize-release' stamp: 'cwp 8/9/2005 20:57'!
setElement: anElement
	element _ anElement.
	self initHashstamp! !

!MDNullVersion methodsFor: 'accessing' stamp: 'cwp 2/27/2005 21:35'!
snapshot
	^ MDElementRemoval forElement: element! !

!MDVersion class methodsFor: 'serialization' stamp: 'avi 3/12/2005 02:53'!
extension
	^ 'vers'! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 3/2/2005 22:22'!
conflictsWith: other
	^ ((self precedes: other) or: [self succeeds: other]) not! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 4/10/2005 12:41'!
hash
	^self hashstamp hash! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 2/28/2005 21:47'!
succeeds: anElementVersion 
	^anElementVersion precedes: self! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 3/17/2005 23:24'!
successor: other 
	(self succeeds: other) ifTrue: [^ self].
	(other succeeds: self) ifTrue: [^ other].
	^ nil! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 3/2/2005 23:55'!
successor: other onConflict: aBlock
	(self succeeds: other) ifTrue: [^ self].
	(other succeeds: self) ifTrue: [^ other].
	^ MDElementVersion
		snapshot: aBlock value
		ancestry: (self fullAncestry, other fullAncestry).! !

!MDVersion methodsFor: 'comparing' stamp: 'cwp 4/10/2005 12:41'!
= other
	^ self species = other species and: [self hashstamp = other hashstamp]! !

Object subclass: #MDImageElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDImageElement subclass: #MDClassCommentElement
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassCommentElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol 
	^ self basicNew setClassName: aSymbol! !

!MDClassCommentElement methodsFor: 'adapting' stamp: 'cwp 2/12/2005 14:03'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassCommentElement: self! !

!MDClassCommentElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 02:05'!
hash
	^ theClassName hash! !

!MDClassCommentElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:07'!
isIncludedInSlice: aSlice
	^ aSlice includesClassComment: self! !

!MDClassCommentElement methodsFor: 'printing' stamp: 'cwp 9/3/2005 22:44'!
printDebugIdOn: aStream
	aStream
		nextPutAll: theClassName;
		nextPut: $-;
		nextPutAll: 'comment'! !

!MDClassCommentElement methodsFor: 'initialize-release' stamp: 'cwp 3/3/2005 02:05'!
setClassName: aSymbol 
	theClassName := aSymbol! !

!MDClassCommentElement methodsFor: 'accessing' stamp: 'cwp 3/3/2005 02:05'!
theClassName
	^ theClassName! !

!MDClassCommentElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 02:03'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]! !

MDImageElement subclass: #MDClassElement
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol
	^ self basicNew setClassName: aSymbol! !

!MDClassElement methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:20'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassElement: self! !

!MDClassElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 00:56'!
hash
	^ theClassName hash! !

!MDClassElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:10'!
isIncludedInSlice: aSlice
	^ aSlice includesClass: self! !

!MDClassElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:04'!
printDebugIdOn: aStream
	aStream nextPutAll: theClassName! !

!MDClassElement methodsFor: 'initialize-release' stamp: 'cwp 2/5/2005 21:27'!
setClassName: aSymbol 
	theClassName := aSymbol! !

!MDClassElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 21:28'!
theClassName
	^ theClassName! !

!MDClassElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 00:56'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]! !

MDImageElement subclass: #MDClassVarElement
	instanceVariableNames: 'theClassName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassVarElement class methodsFor: 'intance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aSymbol name: aString
	^ self basicNew setClassName: aSymbol name: aString! !

!MDClassVarElement methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:31'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassVarElement: self! !

!MDClassVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:39'!
hash
	^ theClassName hash bitXor: name hash! !

!MDClassVarElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:14'!
isIncludedInSlice: aSlice
	^ aSlice includesClassVar: self! !

!MDClassVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 13:52'!
name
	^ name! !

!MDClassVarElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:08'!
printDebugIdOn: aStream
	^ self printStdIdOn: aStream with: '%'! !

!MDClassVarElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 13:48'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

!MDClassVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 13:52'!
theClassName
	^ theClassName! !

!MDClassVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:38'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]
		and: [self name = other name]! !

MDImageElement subclass: #MDFakeElement
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeElement class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 19:02'!
named: aSymbol
	^ self new name: aSymbol! !

!MDFakeElement methodsFor: 'public' stamp: 'cwp 2/5/2005 19:03'!
adaptedFor: anImageProxy 
	^ anImageProxy adaptorForElement: self! !

!MDFakeElement methodsFor: 'printing' stamp: 'cwp 4/25/2005 04:11'!
displayOn: aStream
	aStream nextPutAll: name! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
hash
	^ name hash! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name
	^ name! !

!MDFakeElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 18:58'!
name: aSymbol
	name _ aSymbol! !

!MDFakeElement methodsFor: 'printing' stamp: 'cwp 4/25/2005 04:10'!
printOn: aStream
	self printNameOn: aStream during: [aStream nextPutAll: name]! !

!MDFakeElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 19:27'!
= other
	self species = other species ifFalse: [^ false].
	^ self name = other name! !

!MDImageElement methodsFor: 'adapting' stamp: 'cwp 2/3/2005 23:54'!
adaptedFor: anImageProxy
	self subclassResponsibility! !

!MDImageElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:27'!
alwaysPreferDefinition
	^ false! !

!MDImageElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:27'!
alwaysPreferRemoval
	^ false! !

!MDImageElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:43'!
displayClassName
	^ 'Element'! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 5/24/2005 07:43'!
display: properties for: anImageProxy
	^ (self adaptedFor: anImageProxy) display: properties! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/13/2005 19:42'!
isLoadable: properties into: anImageProxy
	^ (self adaptedFor: anImageProxy) isLoadable: properties
! !

!MDImageElement methodsFor: 'testing' stamp: 'cwp 3/27/2005 22:26'!
isMeta
	^ false! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
is: properties upToDateFor: anImageProxy
	^ (self adaptedFor: anImageProxy) isUpToDate: properties! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
load: properties into: anImageProxy
	^ (self adaptedFor: anImageProxy) load: properties
! !

!MDImageElement methodsFor: 'conflicts' stamp: 'avi 3/16/2005 12:22'!
merge: aPropertyDictionary into: otherPropertyDictionary in: anImageProxy onFailure: aBlock
	^ (self adaptedFor: anImageProxy)
		merge: aPropertyDictionary
		into: otherPropertyDictionary
		onFailure: aBlock! !

!MDImageElement methodsFor: 'printing' stamp: 'cwp 8/20/2005 18:51'!
printDebugIdOn: aStream
	aStream print: self identityHash! !

!MDImageElement methodsFor: 'printing' stamp: 'cwp 9/3/2005 22:46'!
printOn: aStream
	aStream nextPut: $<.
	self printDebugIdOn: aStream.
	aStream nextPut: $>! !

!MDImageElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:07'!
printStdIdOn: aStream with: aString
	aStream
		nextPutAll: self theClassName;
		nextPutAll: aString;
		nextPutAll: self name! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
removeFrom: anImageProxy
	^ (self adaptedFor: anImageProxy) remove! !

!MDImageElement methodsFor: 'image proxy' stamp: 'cwp 2/3/2005 23:53'!
update: properties from: anImageProxy
	^ (self adaptedFor: anImageProxy) update: properties! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

MDImageElement subclass: #MDInstVarElement
	instanceVariableNames: 'theClassName name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDInstVarElement subclass: #MDClassInstVarElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDClassInstVarElement methodsFor: 'as yet unclassified' stamp: 'cwp 3/4/2005 14:48'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForClassInstVarElement: self! !

!MDClassInstVarElement methodsFor: 'as yet unclassified' stamp: 'cwp 8/29/2005 01:17'!
isIncludedInSlice: aSlice
	^ aSlice includesClassInstVar: self! !

!MDClassInstVarElement methodsFor: 'as yet unclassified' stamp: 'cwp 8/28/2005 17:12'!
printDebugIdOn: aStream
	self printStdIdOn: aStream with: '$'! !

!MDInstVarElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:18'!
className: aSymbol name: aString
	^ self basicNew setClassName: aSymbol name: aString! !

!MDInstVarElement methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:28'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForInstVarElement: self! !

!MDInstVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:32'!
hash
	^ theClassName hash bitXor: name hash! !

!MDInstVarElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:15'!
isIncludedInSlice: aSlice
	^ aSlice includesInstVar: self! !

!MDInstVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:52'!
name
	^ name! !

!MDInstVarElement methodsFor: 'printing' stamp: 'cwp 8/27/2005 12:47'!
printDebugIdOn: aStream
	aStream
		nextPutAll: theClassName;
		nextPut: $@;
		nextPutAll: name! !

!MDInstVarElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 12:27'!
setClassName: aSymbol name: aString
	theClassName := aSymbol.
	name := aString! !

!MDInstVarElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:49'!
theClassName
	^ theClassName! !

!MDInstVarElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:32'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]
		and: [self name = other name]! !

MDImageElement subclass: #MDMethodElement
	instanceVariableNames: 'theClassName selector classIsMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:17'!
className: aString selector: aSymbol 
	^self className: aString selector: aSymbol classIsMeta: false! !

!MDMethodElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:16'!
className: aString selector: aSymbol classIsMeta: aBoolean
	^self basicNew setClassName: aString selector: aSymbol classIsMeta: aBoolean! !

!MDMethodElement methodsFor: 'adapting' stamp: 'cwp 2/3/2005 22:09'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForMethodElement: self! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:25'!
classIsMeta
	^ classIsMeta! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 2/5/2005 21:22'!
hash
	^(theClassName , '|' , selector) hash! !

!MDMethodElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:18'!
isIncludedInSlice: aSlice
	^ aSlice includesMethod: self! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 8/28/2005 17:15'!
name
	^ selector! !

!MDMethodElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:14'!
printDebugIdOn: aStream
	self
		printStdIdOn: aStream
		with: (classIsMeta 
				ifTrue: ['*']
				ifFalse: ['#'])
	! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'cwp 2/12/2005 15:15'!
setClassName: aString selector: aSymbol classIsMeta: aBoolean
	theClassName := aString.
	selector := aSymbol.
	classIsMeta := aBoolean! !

!MDMethodElement methodsFor: 'accessing' stamp: 'cwp 2/5/2005 21:22'!
theClassName
	^theClassName! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:08'!
= other 
	^ (self species = other species) 
		and: [self theClassName = other theClassName]
		and: [self selector = other selector]! !

MDImageElement subclass: #MDPoolImportElement
	instanceVariableNames: 'theClassName poolName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPoolImportElement class methodsFor: 'instance creation' stamp: 'cwp 4/2/2005 23:49'!
className: aSymbol name: aString
	^ self className: aSymbol poolName: aString! !

!MDPoolImportElement class methodsFor: 'instance creation' stamp: 'cwp 2/12/2005 15:18'!
className: classNameSymbol poolName: poolNameSymbol
	^ self basicNew setClassName: classNameSymbol poolName: poolNameSymbol! !

!MDPoolImportElement methodsFor: 'converting' stamp: 'cwp 2/7/2005 00:01'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForPoolImportElement: self! !

!MDPoolImportElement methodsFor: 'comparing' stamp: 'cwp 3/3/2005 01:57'!
hash
	^ theClassName hash bitXor: poolName hash! !

!MDPoolImportElement methodsFor: 'adapting' stamp: 'cwp 8/29/2005 01:31'!
isIncludedInSlice: aSlice 
	^ aSlice includesPoolImport: self! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 8/28/2005 17:18'!
name
	^ poolName! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 23:36'!
poolName
	^ poolName! !

!MDPoolImportElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:20'!
printDebugIdOn: aStream
	self printStdIdOn: aStream with: '&'! !

!MDPoolImportElement methodsFor: 'initialize-release' stamp: 'cwp 2/6/2005 23:13'!
setClassName: classNameSymbol poolName: poolNameSymbol
	theClassName := classNameSymbol.
	poolName := poolNameSymbol! !

!MDPoolImportElement methodsFor: 'accessing' stamp: 'cwp 2/6/2005 23:36'!
theClassName
	^ theClassName! !

!MDPoolImportElement methodsFor: 'comparing' stamp: 'cwp 8/21/2005 11:53'!
= other
	^ (self species = other species)
		and: [self theClassName = other theClassName]
		and: [self poolName = other poolName]! !

MDImageElement subclass: #MDSliceElement
	instanceVariableNames: 'sliceName sliceType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDSliceElement subclass: #MDLogElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDLogElement methodsFor: 'adapting' stamp: 'cwp 3/22/2005 23:10'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForLogElement: self! !

MDSliceElement subclass: #MDMetadataElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMetadataElement methodsFor: 'adapting' stamp: 'cwp 3/22/2005 23:12'!
adaptedFor: anImageProxy
	^ anImageProxy adaptorForMetadataElement: self! !

!MDSliceElement class methodsFor: 'as yet unclassified' stamp: 'cwp 3/15/2005 22:31'!
forSlice: aSlice
	^ self basicNew setName: aSlice name type: aSlice type! !

!MDSliceElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:44'!
displayClassName
	^ self className allButFirst: 2! !

!MDSliceElement methodsFor: 'comparing' stamp: 'cwp 3/16/2005 01:10'!
hash
	^ sliceName hash bitXor: sliceType hash! !

!MDSliceElement methodsFor: 'testing' stamp: 'cwp 3/27/2005 22:26'!
isMeta
	^ true! !

!MDSliceElement methodsFor: 'printing' stamp: 'cwp 8/28/2005 17:48'!
printDebugIdOn: aStream
	aStream
		nextPutAll: sliceType;
		nextPut: $-;
		nextPutAll: sliceName! !

!MDSliceElement methodsFor: 'initialize-release' stamp: 'cwp 3/15/2005 22:32'!
setName: aString type: aSymbol
	sliceName _ aString.
	sliceType _ aSymbol! !

!MDSliceElement methodsFor: 'accessing' stamp: 'cwp 3/16/2005 01:12'!
sliceName
	^sliceName! !

!MDSliceElement methodsFor: 'accessing' stamp: 'cwp 3/16/2005 01:13'!
sliceType
	^sliceType! !

!MDSliceElement methodsFor: 'comparing' stamp: 'cwp 3/16/2005 01:11'!
= other
	^ self species = other species 
		and: [self sliceName = other sliceName]
		and: [self sliceType = other sliceType]! !

Object subclass: #MDImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDImageProxy subclass: #MDFakeImageProxy
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/12/2005 14:04'!
adaptorForClassCommentElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:18'!
adaptorForClassElement: aClassElement 
	^ self adaptorForElement: aClassElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 3/4/2005 14:46'!
adaptorForClassInstVarElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:29'!
adaptorForClassVarElement: anClassVarElement
	^ self adaptorForElement: anClassVarElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForElement: anElement 
	^ MDFakeElementAdaptor
		forElement: anElement
		inImage: dict! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/6/2005 22:29'!
adaptorForInstVarElement: anInstVarElement
	^ self adaptorForElement: anInstVarElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 3/15/2005 22:36'!
adaptorForLogElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 3/22/2005 23:13'!
adaptorForMetadataElement: anElement
	^ self adaptorForElement: anElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/5/2005 19:05'!
adaptorForMethodElement: aMethodElement 
	^ self adaptorForElement: aMethodElement! !

!MDFakeImageProxy methodsFor: 'adapting' stamp: 'cwp 2/7/2005 00:01'!
adaptorForPoolImportElement: aPoolImportElement 
	^ self adaptorForElement: aPoolImportElement! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/5/2005 16:08'!
at: anElement
	^ dict at: anElement ifAbsentPut: [Dictionary new]
! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:28'!
includesKey: anElement 
	^ dict includesKey: anElement! !

!MDFakeImageProxy methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:23'!
initialize
	dict _ Dictionary new! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 2/4/2005 00:23'!
removeKey: anElement
	dict removeKey: anElement! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 5/24/2005 08:00'!
display: anElementSnapshot
	^ anElementSnapshot displayFor: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/3/2005 23:56'!
hasElement: anElement
	^ (anElement adaptedFor: self) isPresent! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/13/2005 19:39'!
isLoadable: anElementSnapshot
	^ anElementSnapshot isLoadableInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/29/2004 13:26'!
isUpToDate: anElementSnapshot
	^ anElementSnapshot isUpToDateFor: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 3/4/2005 15:56'!
loadSnapshot: anElementSnapshot
	anElementSnapshot loadInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'cwp 2/27/2005 22:00'!
updateSnapshot: anElementSnapshot
	^ anElementSnapshot updateFrom: self! !

MDImageProxy subclass: #MDSqueakImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/12/2005 14:06'!
adaptorForClassCommentElement: anElement
	^ MDSqueakClassCommentAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForClassElement: anElement
	^ MDSqueakClassAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/4/2005 14:50'!
adaptorForClassInstVarElement: anElement
	^ MDSqueakClassInstVarAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForClassVarElement: anElement
	^ MDSqueakClassVarAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForInstVarElement: anElement
	^ MDSqueakInstVarAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/15/2005 22:38'!
adaptorForLogElement: anElement
	^ MDSqueakLogAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 3/22/2005 23:16'!
adaptorForMetadataElement: anElement
	^ MDSqueakMetadataAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/6/2005 22:35'!
adaptorForMethodElement: anElement
	^ MDSqueakMethodAdaptor forElement: anElement! !

!MDSqueakImageProxy methodsFor: 'adaptors' stamp: 'cwp 2/7/2005 00:00'!
adaptorForPoolImportElement: anElement
	^ MDSqueakPoolImportAdaptor forElement: anElement! !

Object subclass: #MDKeyedStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDKeyedStream class methodsFor: 'as yet unclassified' stamp: 'avi 4/17/2005 01:19'!
on: aStream
	^ self basicNew initializeWithStream: aStream! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:18'!
appendKey: keyBytes value: valueBytes 
	self assert: [keyBytes size = self keySize].
	stream
		position: stream size;
		nextPutAll: keyBytes;
		nextInt32Put: valueBytes size;
		nextPutAll: valueBytes! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:58'!
flush
	stream flush! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/19/2005 01:49'!
fromPosition: aNumber keysValuesAndPositionsDo: aBlock 
	| position key |
	stream position: aNumber.
	[stream atEnd] whileFalse: 
			[key := stream next: self keySize.
			position := stream position.
			aBlock
				value: key
				value: self readValue
				value: position]! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'avi 4/17/2005 01:19'!
initializeWithStream: aPositionableStream
	stream _ aPositionableStream.
	stream binary! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 15:14'!
keySize
	^ 24! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 02:11'!
keysValuesAndPositionsDo: aBlock 
	self fromPosition: 0 keysValuesAndPositionsDo: aBlock
			! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:38'!
nextValuePosition
	^ stream size + self keySize! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 4/10/2005 17:29'!
position
	^ stream position! !

!MDKeyedStream methodsFor: 'private' stamp: 'avi 4/17/2005 01:29'!
readValue
	| length |
	length := stream nextInt32.
	^ stream next: length.
	! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'avi 4/19/2005 01:42'!
reopen
	stream name = 'a stream' ifFalse:
		[stream close.
		stream _ FileStream fileNamed: stream name.
		stream binary]! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 14:53'!
stream
	^ stream! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:28'!
valueAtPosition: anInteger
	stream position: anInteger.
	^ self readValue! !

Object subclass: #MDMarshal
	instanceVariableNames: 'stream'
	classVariableNames: 'ClassMap InverseClassMap'
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDMarshal commentStamp: 'cwp 3/9/2005 22:40' prior: 0!
I am used to serialize versioning objects - Elements, ElementDefinitions, ElementRemovals, ElementVersions and Snapshots - both for persistence and hashing. My serialization scheme is remeniscent of that used by DataStream, but it has the following differences:

Rather than type codes, I use class ids. This is because I don't have to be able to handle any object, but only those classes mentioned above. I encode class ids as a single byte, but only 22 classes are used so far, so there is room to add more if need be. 

Also, I'm more verbose than a ReferenceStream, but this is unavoidable, since I must always produce a canonical serialization of any object in the tree, not just one that can reproduce the original root object. 

Finally, I'm less flexible than DataStream, since I provide no hooks to allow objects to customize how they are serialized. I use double dispatch to find appropriate encoding and decoding methods for objects.
!

!MDMarshal class methodsFor: 'public' stamp: 'avi 4/19/2005 01:46'!
classFor: aByteArray
	^ self classFromId: aByteArray first! !

!MDMarshal class methodsFor: 'class ids' stamp: 'cwp 3/7/2005 16:10'!
classFromId: anInteger
	^ ClassMap at: anInteger! !

!MDMarshal class methodsFor: 'class ids' stamp: 'cwp 3/11/2005 23:23'!
classIdForObject: anObject 
	^ InverseClassMap
		at: anObject class
		ifAbsent: [self error: 'Unrecognized object class']! !

!MDMarshal class methodsFor: 'initialize-release' stamp: 'cwp 3/20/2005 01:16'!
initialize
	ClassMap := MDPlatform current serializationClassMap.
	InverseClassMap := Dictionary new.
	ClassMap withIndexDo: [:ea :i | InverseClassMap at: ea put: i]! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 6/18/2005 16:04'!
materializeFrom: aWriteStram
	| instance |
	instance := self on: aWriteStram.
	^ instance materialize! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 3/9/2005 00:00'!
materialize: aByteArray
	^ self materializeFrom: aByteArray readStream! !

!MDMarshal class methodsFor: 'instance creation' stamp: 'cwp 3/7/2005 21:35'!
on: aStream
	^ self new setStream: aStream! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 3/8/2005 23:59'!
serialize: anObject
	| byteStream |
	byteStream _ (ByteArray new: 100) writeStream.
	self serialize: anObject on: byteStream.
	^ byteStream contents
! !

!MDMarshal class methodsFor: 'public' stamp: 'cwp 6/18/2005 16:04'!
serialize: anObject on: aWriteStream
	|  instance |
	instance := self on: aWriteStream.
	instance serialize: anObject.
	^ aWriteStream contents! !

!MDMarshal methodsFor: 'private' stamp: 'cwp 3/7/2005 21:53'!
classFromId: anInteger
	^ ClassMap at: anInteger! !

!MDMarshal methodsFor: 'private' stamp: 'avi 3/12/2005 04:08'!
classIdOfObject: anObject
	^ self class classIdForObject: anObject! !

!MDMarshal methodsFor: 'public' stamp: 'cwp 3/9/2005 20:51'!
materialize
	| class |
	class _ MDMarshal classFromId: stream next.
	^ class materializeWith: self! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:52'!
readBooleanOfClass: aClass
	^ aClass initializedInstance! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 4/18/2005 13:40'!
readBytes: aByteObject
	1 to: aByteObject size do: [:i | aByteObject byteAt: i put: stream next].
	^ aByteObject! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:59'!
readDictionaryOfClass: aClass
	| size dictionary |
	size _ stream next.
	dictionary _ aClass new: size.
	size timesRepeat:
		[dictionary 
			at: self materialize 
			put: self materialize].
	^ dictionary
! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 8/9/2005 21:20'!
readHashedObject: anObject
	self readObject: anObject.
	anObject initHashstamp.
	^ anObject! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:00'!
readObject: anObject
	1
		to: anObject class instSize 
		do: [:i | anObject instVarAt: i put: (self materialize)].
	^ anObject! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:15'!
readSetOfClass: aClass
	| size set |
	size _ self readSmallInteger.
	set _ aClass new: size.
	size timesRepeat: [set add: self materialize].
	^ set! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 21:04'!
readSmallInteger
	| integer |
	integer _ stream next bitShift: 24.
	integer _ integer bitOr: (stream next bitShift: 16).
	integer _ integer bitOr: (stream next bitShift: 8).
	^ integer bitOr: stream next! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 20:50'!
readStringOfClass: aClass
	| size bytes |
	size _ (stream next bitShift: 8) bitOr: stream next.
	bytes _ stream next: size.
	^ aClass fromByteArray: bytes! !

!MDMarshal methodsFor: 'reading' stamp: 'cwp 3/9/2005 20:57'!
readSymbol
	^ (self readStringOfClass: String) asSymbol! !

!MDMarshal methodsFor: 'public' stamp: 'cwp 3/9/2005 20:37'!
serialize: anObject
	stream nextPut: (self classIdOfObject: anObject).
	anObject serializeWith: self! !

!MDMarshal methodsFor: 'initialize-release' stamp: 'cwp 3/7/2005 21:34'!
setStream: aStream
	stream _ aStream! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 21:49'!
writeBoolean: aBoolean! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 4/18/2005 13:44'!
writeBytes: aByteObject
	1 to: aByteObject byteSize do: [:i | stream nextPut: (aByteObject byteAt: i)]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:44'!
writeDictionary: aDictionary
	stream nextPut: aDictionary size.
	aDictionary keysAndValuesDo:
		[:key :value |
		self serialize: key.
		self serialize: value]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 8/9/2005 21:16'!
writeHashedObject: anObject
	self serialize: anObject timestamp.
	2 to: anObject class instSize do: [:i | self serialize: (anObject instVarAt: i)]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:18'!
writeObject: anObject
	1 to: anObject class instSize do: [:i | self serialize: (anObject instVarAt: i)]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:39'!
writeSet: aSet
	self writeSmallInteger: aSet size.
	aSet do: [:ea | self serialize: ea]! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 23:51'!
writeSmallInteger: aSmallInteger
	stream 
		nextPut: (aSmallInteger bitShift: -24);
		nextPut: ((aSmallInteger bitShift: -16) bitAnd: 16rFF);
		nextPut: ((aSmallInteger bitShift: -8) bitAnd: 16rFF);
		nextPut: (aSmallInteger bitAnd: 16rFF)! !

!MDMarshal methodsFor: 'writing' stamp: 'cwp 3/9/2005 20:12'!
writeString: aString
	aString size > 16rFFFF ifTrue: [aString error: 'String too long to serialize'].
	stream
		nextPut: (aString byteSize bitShift: -8);
		nextPut: (aString byteSize bitAnd: 16rFF).
	1 to: aString byteSize do: [:i | stream nextPut: (aString byteAt: i)]! !

Object subclass: #MDMerge
	instanceVariableNames: 'wc local remote resolution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDMerge class methodsFor: 'instance creation' stamp: 'cwp 3/25/2005 21:51'!
toInclude: anElementVersion in: aWorkingCopy 
	^self basicNew setWorkingCopy: aWorkingCopy version: anElementVersion! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 3/25/2005 21:33'!
apply
	wc 
		includeVersion: resolution 
		onConflict: [:l :r | r snapshot]! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 3/17/2005 23:27'!
chooseLocal
	resolution _ local! !

!MDMerge methodsFor: 'operations' stamp: 'cwp 3/17/2005 23:29'!
chooseRemote
	resolution _ remote! !

!MDMerge methodsFor: 'printing' stamp: 'cwp 4/25/2005 04:02'!
displayOn: aStream
	self remote element displayOn: aStream! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:21'!
isConflict
	^ remote conflictsWith: local! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:16'!
isLocal
	^ resolution == local! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 3/17/2005 23:19'!
isRemote
	^ resolution == remote! !

!MDMerge methodsFor: 'testing' stamp: 'cwp 6/9/2005 09:01'!
isResolved
	^ resolution notNil! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
local
	^ local! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
remote
	^ remote! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 3/17/2005 23:28'!
resolution
	^ resolution! !

!MDMerge methodsFor: 'initialize-release' stamp: 'cwp 3/25/2005 21:27'!
setWorkingCopy: aWorkingCopy version: anElementVersion
	wc _ aWorkingCopy.
	local _ wc versionForElement: anElementVersion element.
	remote _ anElementVersion.
	resolution _ local successor: remote! !

!MDMerge methodsFor: 'accessing' stamp: 'cwp 5/24/2005 07:57'!
workingCopy
	^ wc! !

Object subclass: #MDMergeTool
	instanceVariableNames: 'merges selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-UI'!

!MDMergeTool class methodsFor: 'instance creation' stamp: 'cwp 4/25/2005 03:59'!
on: anArray 
	^ self new merges: anArray! !

!MDMergeTool class methodsFor: 'opening' stamp: 'cwp 4/24/2005 23:02'!
openOn: anArray 
	^ ToolBuilder open: (self on: anArray)! !

!MDMergeTool methodsFor: 'interface' stamp: 'cwp 6/19/2005 19:47'!
addChooseLocalTo: aMenuSpec 
	aMenuSpec 
		add: 'choose local'
		target: self
		selector: #resolveUsing:
		argumentList: (Array with: #chooseLocal)! !

!MDMergeTool methodsFor: 'interface' stamp: 'cwp 6/19/2005 19:48'!
addChooseRemoteTo: aMenuSpec 
	^aMenuSpec 
		add: 'choose remote'
		target: self
		selector: #resolveUsing:
		argumentList: (Array with: #chooseRemote)! !

!MDMergeTool methodsFor: 'interface' stamp: 'cwp 6/9/2005 00:24'!
buildWith: aBuilder 
	| windowSpec listSpec textSpec |
	windowSpec := aBuilder pluggableWindowSpec new.
	windowSpec
		model: self;
		name: 'window';
		label: 'Monticello Merge Tool';
		extent: 800 @ 600;
		children: OrderedCollection new.
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: 'elements';
		list: #elementList;
		menu: #elementListMenu:;
		getIndex: #elementListIndex;
		setIndex: #elementListIndex:;
		keyPress: nil;
		autoDeselect: false;
		frame: (0 @ 0 corner: 0.5 @ 0.5).
	windowSpec children add: listSpec.
	textSpec := aBuilder pluggableTextSpec new.
	textSpec
		model: self;
		name: 'local';
		getText: #localText;
		selection: #localSelection;
		setText: #localText:;
		frame: (0.5 @ 0 corner: 1 @ 0.5).
	windowSpec children add: textSpec.
	textSpec := aBuilder pluggableTextSpec new.
	textSpec
		model: self;
		name: 'remote';
		getText: #remoteText;
		selection: #remoteSelection;
		setText: #remoteText:;
		frame: (0 @ 0.5 corner: 0.5 @ 1).
	windowSpec children add: textSpec.
	textSpec := aBuilder pluggableTextSpec new.
	textSpec
		model: self;
		name: 'resolved';
		getText: #resolvedText;
		selection: #resolvedSelection;
		setText: #resolvedText:;
		frame: (0.5 @ 0.5 corner: 1 @ 1).
	windowSpec children add: textSpec.
	^aBuilder build: windowSpec! !

!MDMergeTool methodsFor: 'interface' stamp: 'cwp 4/24/2005 23:17'!
defaultBackgroundColor
	^ (Color r: 0.627 g: 0.69 b: 0.976)! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/9/2005 09:02'!
elementList
	^ merges collect: [:ea | ea isResolved 
							ifFalse: [ea displayString asText allBold]
							ifTrue: [ea displayString]]! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 5/26/2005 09:06'!
elementListIndex
	^ selection ifNil: [0]! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 5/30/2005 23:15'!
elementListIndex: anInteger 
	selection _ anInteger.
	self changed: #elementListIndex.
	self changed: #localText.
	self changed: #remoteText.
	self changed: #resolvedText.! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/19/2005 19:51'!
elementListMenu: aMenuSpec 
	aMenuSpec 
		add: 'merge resolved'
		target: self
		selector: #mergeResolved
		argumentList: #().
	self withSelectionDo: 
			[:sel | 
			sel isLocal ifFalse: [self addChooseLocalTo: aMenuSpec].
			sel isRemote ifFalse: [self addChooseRemoteTo: aMenuSpec]]
		ifNil: [].
	^aMenuSpec! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 4/25/2005 02:43'!
localSelection
	^ 1 to: 0! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 5/24/2005 08:10'!
localText
	^ self textFor: #local! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/15/2005 08:17'!
localText: aText
	self changed: #localText! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/19/2005 20:38'!
mergeResolved
	| resolved |
	resolved := self merges select: [:ea | ea isResolved].
	resolved do: [:ea | ea apply].
	self merges: (self merges copyWithoutAll: resolved).
	selection _ 0.
	self changed: #elementList.
	self changed: #localText.
	self changed: #remoteText.
	self changed: #resolvedText.! !

!MDMergeTool methodsFor: 'accessing' stamp: 'cwp 4/25/2005 04:00'!
merges
	^merges! !

!MDMergeTool methodsFor: 'accessing' stamp: 'cwp 6/3/2005 08:39'!
merges: aCollection
	merges := (aCollection asSortedCollection: [:a :b | a isConflict]) asArray! !

!MDMergeTool methodsFor: 'private' stamp: 'cwp 6/17/2005 22:41'!
perform: aSelector orSendTo: anObject
	(self respondsTo: aSelector)
		ifTrue: [self perform: aSelector]
		ifFalse: [anObject perform: aSelector]! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/3/2005 08:20'!
remoteSelection
	^ 1 to: 0! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 5/24/2005 08:10'!
remoteText
	^ self textFor: #remote! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/15/2005 08:22'!
remoteText: aText
	self changed: #remoteText! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 4/25/2005 02:47'!
resolvedSelection
	^ 1 to: 0! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 5/30/2005 23:22'!
resolvedText
	^ (self textFor: #resolution) ifNil: ['-- unresolved conflict --']! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/15/2005 08:26'!
resolvedText: aText
	self changed: #resolvedText! !

!MDMergeTool methodsFor: 'callbacks' stamp: 'cwp 6/9/2005 08:55'!
resolveUsing: aSelector
	self selectedMerge perform: aSelector.
	self changed: #resolvedText.
	self changed: #elementList.! !

!MDMergeTool methodsFor: 'accessing' stamp: 'cwp 6/19/2005 20:39'!
selectedMerge
	^ merges at: (selection ifNil: [^ nil]) ifAbsent: [^ nil]! !

!MDMergeTool methodsFor: 'private' stamp: 'cwp 5/30/2005 23:41'!
textFor: aSelector 
	^self withSelectionDo: 
			[:merge | 
			merge workingCopy displayVersion: ((merge perform: aSelector) ifNil: [^nil])]
		ifNil: ['']! !

!MDMergeTool methodsFor: 'testing' stamp: 'cwp 5/30/2005 23:27'!
withSelectionDo: aMonadicValuable ifNil: aValuable 
	^self selectedMerge ifNil: aValuable ifNotNilDo: aMonadicValuable! !

Object subclass: #MDMockPgConnection
	instanceVariableNames: 'snapshots elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMockPgConnection class methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2005 21:06'!
createConnection
	^ self new! !

!MDMockPgConnection methodsFor: 'mocking' stamp: 'cwp 8/21/2005 23:35'!
execute: aByteString 
	(aByteString beginsWith: 'SELECT hashstamp') 
		ifTrue: [^ self pvtSelectHashstamp: aByteString].
	(aByteString beginsWith: 'SELECT data')
		ifTrue: [^ self pvtSelectData: aByteString].
	(aByteString beginsWith: 'INSERT')
		ifTrue: [^ self pvtInsert: aByteString]! !

!MDMockPgConnection methodsFor: 'mocking' stamp: 'cwp 8/21/2005 22:36'!
isConnected
	^snapshots notNil! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 22:33'!
pvtEmptyResult
	^ (PGResult on: self)
		addResultSet;
		yourself! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 22:58'!
pvtExtractHashstampFrom: aByteString
	^ aByteString 
		copyFrom: aByteString size - 32
		to: aByteString size - 1.! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 23:20'!
pvtInsert: aByteString 
	| stream hashstamp isSnapshot data |
	stream := aByteString readStream.
	stream skip: 30.
	hashstamp := stream next: 32.
	stream skip: 2.
	isSnapshot := (Boolean readFrom: (stream upTo: $,) readStream).
	stream skip: 2.
	data := stream upTo: $'.
	(isSnapshot
		ifTrue: [snapshots]
		ifFalse: [elements])
			at: hashstamp
			put: data.! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 23:15'!
pvtResultWith: anArray
	| result row |
	result := PGResult on: self.
	result addResultSet.
	row := PGAsciiRow new.
	row rawData addAll: anArray.
	result rows: (Array with: row).
	^ result
	! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 23:30'!
pvtSelectData: aByteString 
	| hashstamp |
	hashstamp := self pvtExtractHashstampFrom: aByteString.
	(elements includesKey: hashstamp)
		ifTrue: [^ self pvtResultWith: (Array with: (elements at: hashstamp))].
	(snapshots includesKey: hashstamp)
		ifTrue: [^ self pvtResultWith: (Array with: (snapshots at: hashstamp))].
	^ self pvtEmptyResult! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 23:35'!
pvtSelectHashstamp: aByteString 
	| hashstamp |
	hashstamp := self pvtExtractHashstampFrom: aByteString.
	^ (hashstamp endsWith: ' tru')
		ifTrue: [self pvtResultWith: (Array with: snapshots keys anyOne)]
		ifFalse: [(snapshots includesKey: hashstamp) 
					ifTrue: [self pvtResultWith: (Array with: hashstamp)]
					ifFalse: [self pvtEmptyResult]]! !

!MDMockPgConnection methodsFor: 'mocking' stamp: 'cwp 8/21/2005 22:57'!
startup
	snapshots := Dictionary new.
	elements := Dictionary new! !

!MDMockPgConnection methodsFor: 'mocking' stamp: 'cwp 8/21/2005 22:57'!
terminate
	snapshots := nil.
	elements := nil! !

Object subclass: #MDPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Info'!

!MDPlatform class methodsFor: 'as yet unclassified' stamp: 'cwp 3/20/2005 01:12'!
current
	^ self new! !

!MDPlatform methodsFor: 'time' stamp: 'cwp 6/18/2005 20:30'!
clockOffset
	^ -2498169600! !

!MDPlatform methodsFor: 'time' stamp: 'cwp 6/18/2005 20:29'!
secondClock
	^ Time primSecondsClock! !

!MDPlatform methodsFor: 'constructing' stamp: 'cwp 8/6/2005 20:23'!
serializationClassMap
	| map |
	map := Array new: 25. 
	map
		at: 1 put: True;
		at: 2 put: False;
		at: 3 put: SmallInteger;
		at: 4 put: ByteSymbol;
		at: 5 put: ByteString;
		at: 6 put: WideString;
		at: 7 put: Set;
		at: 8 put: MDTimestamp;
		at: 9 put: MDClassCommentElement;
		at: 10 put: MDClassElement;
		at: 11 put: MDClassInstVarElement;
		at: 12 put: MDClassVarElement;
		at: 13 put: MDElementDefinition;
		at: 14 put: MDElementRemoval;
		at: 15 put: MDElementVersion;
		at: 16 put: MDFakeElement;
		at: 17 put: MDHashstamp;
		at: 18 put: MDInstVarElement;
		at: 19 put: MDLogElement;
		at: 20 put: MDMetadataElement;
		at: 21 put: MDMethodElement;
		at: 22 put: MDNullVersion;
		at: 23 put: MDPoolImportElement;
		at: 24 put: MDPropertyDictionary;
		at: 25 put: MDSnapshot.
	^ map! !

Object subclass: #MDRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

MDRepository subclass: #MDFileRepository
	instanceVariableNames: 'dataStream index snapshotHashstamps lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDFileRepository class methodsFor: 'accessing' stamp: 'cwp 10/12/2005 21:30'!
extension
	^ '.mcr'! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'cwp 10/12/2005 21:30'!
named: aString
	^ self on: (StandardFileStream fileNamed: aString, self extension)! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'avi 4/17/2005 01:20'!
on: aFileStream
	^ self basicNew initializeWithStream: aFileStream! !

!MDFileRepository class methodsFor: 'saving' stamp: 'cwp 10/13/2005 08:16'!
saveSlice: aSlice as: aString
	| fileStream repo |
	fileStream := StandardFileStream newFileNamed: aString, self extension.
	repo := MDFileRepository on: fileStream.
	aSlice saveFrom: MDWorkingCopy default to: repo.
	fileStream close.! !

!MDFileRepository methodsFor: 'public' stamp: 'avi 4/19/2005 01:50'!
get: aHashstamp 
	| key bytes position |
	key := aHashstamp bytes.
	position := index at: key ifAbsent: [^self rescanData ifTrue: [self get: aHashstamp]].
	bytes := dataStream valueAtPosition: position.
	^MDMarshal materialize: bytes! !

!MDFileRepository methodsFor: 'initialize-release' stamp: 'avi 4/19/2005 01:50'!
initializeWithStream: aFileStream
	dataStream _ MDKeyedStream on: aFileStream.
	lastPosition _ 0.
	index _ Dictionary new.
	snapshotHashstamps _ Set new.
	self rescanData! !

!MDFileRepository methodsFor: 'public' stamp: 'avi 4/17/2005 01:58'!
put: aHashedObject
	| key value |
	key _ aHashedObject hashstamp bytes.
	index at: key ifAbsent:
		[value _ MDMarshal serialize: aHashedObject.
		index at: key put: dataStream nextValuePosition.
		dataStream appendKey: key value: value.
		dataStream flush]! !

!MDFileRepository methodsFor: 'private' stamp: 'avi 4/19/2005 01:50'!
rescanData
	dataStream reopen.
	dataStream fromPosition: lastPosition keysValuesAndPositionsDo:  
		[:key :val :pos |
		index at: key put: pos.
		(MDMarshal classFor: val) = MDSnapshot ifTrue:
			[snapshotHashstamps add: (MDHashstamp fromBytes: key)]].
	dataStream position = lastPosition
		ifTrue: [^ false]
		ifFalse: [lastPosition _ dataStream position. ^ true]! !

!MDFileRepository methodsFor: 'public' stamp: 'avi 4/19/2005 01:50'!
snapshotHashstampsDo: aBlock
	self rescanData.
	snapshotHashstamps do: aBlock! !

MDRepository subclass: #MDMemoryRepository
	instanceVariableNames: 'versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 3/10/2005 20:20'!
get: aHashstamp
	^ versions at: aHashstamp! !

!MDMemoryRepository methodsFor: 'initialize-release' stamp: 'cwp 2/21/2005 20:20'!
initialize
	versions _ Dictionary new.! !

!MDMemoryRepository methodsFor: 'public' stamp: 'cwp 3/10/2005 20:20'!
put: anElementVersion
	versions at: anElementVersion hashstamp put: anElementVersion! !

!MDMemoryRepository methodsFor: 'public' stamp: 'avi 4/17/2005 02:19'!
snapshotHashstampsDo: aBlock
	versions keysAndValuesDo:
		[:hashstamp :version |
		(version isKindOf: MDSnapshot)
			ifTrue: [aBlock value: hashstamp]]! !

!MDMemoryRepository methodsFor: 'accessing' stamp: 'cwp 8/7/2005 21:57'!
versions
	^ versions! !

MDRepository subclass: #MDPostgresRepository
	instanceVariableNames: 'connectionArgs connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

!MDPostgresRepository class methodsFor: 'as yet unclassified' stamp: 'avi 6/20/2005 13:13'!
connectionArgs: aConnectionArgs
	^ self basicNew initializeWithConnectionArgs: aConnectionArgs! !

!MDPostgresRepository methodsFor: 'private' stamp: 'avi 6/20/2005 13:14'!
close
	connection ifNotNil: [connection terminate]! !

!MDPostgresRepository methodsFor: 'private' stamp: 'cwp 8/21/2005 21:05'!
ensureConnection
	(connection isNil or: [connection isConnected not]) ifTrue:
		[connection _ connectionArgs createConnection.
		connection startup].
	^ connection! !

!MDPostgresRepository methodsFor: 'public' stamp: 'avi 6/20/2005 13:12'!
get: aHashstamp
	| result byteStream |
	result _ self ensureConnection execute: 'SELECT data FROM versions WHERE hashstamp = ', aHashstamp asString printString.
	result rows size = 1 ifFalse: [^ nil].
	byteStream _ Base64MimeConverter mimeDecodeToBytes: result rows first rawData first readStream.
	^ MDMarshal materializeFrom: byteStream! !

!MDPostgresRepository methodsFor: 'private' stamp: 'cwp 8/21/2005 22:23'!
includesHashstamp: aHashstamp
	| result |
	result _ self ensureConnection execute: 'SELECT hashstamp FROM versions WHERE hashstamp = ', aHashstamp asString printString.
	^ result rows size = 1! !

!MDPostgresRepository methodsFor: 'private' stamp: 'avi 6/20/2005 12:55'!
initializeWithConnectionArgs: aConnectionArgs
	connectionArgs _ aConnectionArgs! !

!MDPostgresRepository methodsFor: 'public' stamp: 'avi 6/20/2005 13:22'!
put: aHashedObject
	| key isSnapshot value |
	(self includesHashstamp: aHashedObject hashstamp) ifTrue: [^ self].
	key _ aHashedObject hashstamp asString.
	isSnapshot _ aHashedObject isKindOf: MDSnapshot.
	value _ (Base64MimeConverter mimeEncode: (MDMarshal serialize: aHashedObject) readStream) contents.
	self ensureConnection execute:
		'INSERT INTO versions VALUES (', key printString, ', ', isSnapshot asString, ', ', value printString, ')'! !

!MDPostgresRepository methodsFor: 'private' stamp: 'cwp 8/14/2005 15:15'!
resetConnection
	connection _ nil.
	self ensureConnection! !

!MDPostgresRepository methodsFor: 'public' stamp: 'avi 6/20/2005 13:16'!
snapshotHashstampsDo: aBlock
	| result |
	result _ self ensureConnection execute: 'SELECT hashstamp from versions where is_snapshot = true'.
	result rows do:
		[:ea |
		aBlock value: (MDHashstamp fromString: ea rawData first)]! !

!MDRepository methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2005 18:07'!
snapshotsAndMetaDo: aBlock
	| snapshot meta |
	self snapshotHashstampsDo: 
		[:ea |
		snapshot := self get: ea.
		meta := snapshot meta collect: [:m | self get: m].
		aBlock value: snapshot value: meta]! !

Object subclass: #MDSlice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

MDSlice subclass: #MDExplicitSlice
	instanceVariableNames: 'name elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'cwp 3/15/2005 22:24'!
basedOn: aSlice
	^ self basicNew 
			setName: aSlice name 
			elements: aSlice elements! !

!MDExplicitSlice class methodsFor: 'instance creation' stamp: 'cwp 3/15/2005 22:25'!
named: aString
	^ self basicNew setName: aString! !

!MDExplicitSlice class methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:33'!
type
	^ #Explicit! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 18:54'!
addElement: anElement
	elements add: anElement! !

!MDExplicitSlice methodsFor: 'enumerating' stamp: 'cwp 3/22/2005 22:50'!
do: aBlock	
	aBlock value: (MDLogElement forSlice: self).
	elements do: aBlock.! !

!MDExplicitSlice methodsFor: 'testing' stamp: 'cwp 8/28/2005 23:34'!
includes: anElement
	^ elements includes: anElement! !

!MDExplicitSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:26'!
name
	^ name! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'cwp 3/16/2005 00:24'!
setName: aString
	name _ aString.
	elements _ Set new. ! !

!MDExplicitSlice methodsFor: 'initialize-release' stamp: 'cwp 3/15/2005 22:24'!
setName: aString elements: aSet
	name _ aString.
	elements _ aSet! !

MDSlice subclass: #MDPackageSlice
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Slices'!

!MDPackageSlice class methodsFor: 'instance creation' stamp: 'cwp 3/3/2005 00:49'!
forPackage: aPackage
	^ self basicNew setPackage: aPackage! !

!MDPackageSlice class methodsFor: 'instance creation' stamp: 'cwp 8/28/2005 18:02'!
named: aString
	^ self forPackage: (PackageInfo named: aString)! !

!MDPackageSlice class methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:34'!
type
	^ #Package! !

!MDPackageSlice methodsFor: 'private' stamp: 'cwp 3/4/2005 15:26'!
class: aClass do: aBlock
	aBlock value: (MDClassElement className: aClass name).
	aClass hasComment ifTrue:
		[aBlock value: (MDClassCommentElement className: aClass name)].
	self 
		names: aClass instVarNames 
		collect: [:name | MDInstVarElement className: aClass name name: name]
		into: aBlock.
	self 
		names: aClass classVarNames
		collect: [:name | MDClassVarElement className: aClass name name: name]
		into: aBlock.
	self 
		names: aClass class instVarNames
		collect: [:name | MDClassInstVarElement className: aClass name name: name]
		into: aBlock.
	self
		names: aClass sharedPools
		collect: [:pool | MDPoolImportElement className: aClass name poolName: pool name]
		into: aBlock! !

!MDPackageSlice methodsFor: 'enumerating' stamp: 'cwp 3/22/2005 22:50'!
do: aBlock
	aBlock value: (MDLogElement forSlice: self).
	package classes do: [:class | self class: class do: aBlock].
	package methods do: [:ea | aBlock value: ea asElement].! !

!MDPackageSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:09'!
includesClassComment: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:17'!
includesClassInstVar: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:15'!
includesClassVar: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:10'!
includesClass: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:16'!
includesInstVar: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:24'!
includesMethod: anElement
	| ref |
	ref _ MethodReference new.
	ref 
		setClassSymbol: anElement theClassName
		classIsMeta: anElement classIsMeta
		methodSymbol: anElement selector
		stringVersion: ''.
	^ package includesMethodReference: ref! !

!MDPackageSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:32'!
includesPoolImport: anElement
	^ package includesClassNamed: anElement theClassName! !

!MDPackageSlice methodsFor: 'testing' stamp: 'cwp 8/29/2005 01:06'!
includes: anElement
	^ anElement isIncludedInSlice: self! !

!MDPackageSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:26'!
name
	^ package packageName! !

!MDPackageSlice methodsFor: 'private' stamp: 'cwp 3/3/2005 01:48'!
names: aCollection collect: mapBlock into: doBlock
	| elements |
	elements := aCollection collect: mapBlock.
	elements do: doBlock. 
		! !

!MDPackageSlice methodsFor: 'initialize-release' stamp: 'cwp 3/3/2005 00:49'!
setPackage: aPackage
	package _ aPackage! !

!MDSlice class methodsFor: 'as yet unclassified' stamp: 'cwp 3/15/2005 22:33'!
type
	self subclassResponsibility! !

!MDSlice methodsFor: 'converting' stamp: 'cwp 3/14/2005 22:28'!
asExplicitSlice
	^ MDExplicitSlice basedOn: self! !

!MDSlice methodsFor: 'enumerating' stamp: 'cwp 2/27/2005 22:54'!
do: aBlock
	self subclassResponsibility! !

!MDSlice methodsFor: 'accessing' stamp: 'cwp 2/27/2005 19:08'!
elements
	| result |
	result _ Set new.
	self do: [:ea | result add: ea].
	^ result! !

!MDSlice methodsFor: 'private' stamp: 'cwp 2/27/2005 21:31'!
expandVersions: versions
	| existingElements result |
	existingElements _ versions collect: [:ea | ea element]. 
	result _ versions copy.
	self do: [:el | (existingElements includes: el) 
					ifFalse: [result add: (MDNullVersion forElement: el)]].
	^ result! !

!MDSlice methodsFor: 'public' stamp: 'cwp 3/13/2005 00:37'!
include: aSnapshot
	^ self include: aSnapshot from: MDStore default in: MDWorkingCopy default! !

!MDSlice methodsFor: 'public' stamp: 'cwp 3/25/2005 22:23'!
include: aSnapshot from: aRepository in: aWorkingCopy
	| versions |
	versions _ aSnapshot getVersionsFrom: aRepository.
	MDMergeRequest
		includeAll: (self expandVersions: versions)
		in: aWorkingCopy! !

!MDSlice methodsFor: 'public' stamp: 'cwp 3/13/2005 00:36'!
load: aSnapshot
	^ self load: aSnapshot from: MDStore default to: MDWorkingCopy default! !

!MDSlice methodsFor: 'public' stamp: 'cwp 9/3/2005 20:29'!
load: aSnapshot from: aRepository to: aWorkingCopy
	self 
		withCursor: Cursor read 
		do: [(self expandVersions: (aSnapshot getVersionsFrom: aRepository))
				do: [:ea | aWorkingCopy loadVersion: ea]]! !

!MDSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:32'!
name
	^ self subclassResponsibility! !

!MDSlice methodsFor: 'public' stamp: 'cwp 3/13/2005 00:35'!
save
	^ self saveFrom: MDWorkingCopy default to: MDStore default! !

!MDSlice methodsFor: 'public' stamp: 'cwp 9/4/2005 00:21'!
saveFrom: aWorkingCopy to: aRepository
	| versions snapshot |
	self 
		withCursor: Cursor write 
		do: [versions _ Set new.	
			self do: 
				[:ea | | version |
				version _ aWorkingCopy versionForElement: ea.
				aRepository put: version.
				versions add: version].
			snapshot _ MDSnapshot withVersions: versions.
			aRepository put: snapshot].
	^ snapshot! !

!MDSlice methodsFor: 'accessing' stamp: 'cwp 3/15/2005 22:32'!
type
	^ self class type! !

!MDSlice methodsFor: 'private' stamp: 'cwp 9/4/2005 00:23'!
withCursor: aCursor do: aBlock
	ActiveHand showTemporaryCursor: aCursor.
	aBlock ensure: [ActiveHand showTemporaryCursor: nil]! !

Object subclass: #MDSlicePanel
	instanceVariableNames: 'stati index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-UI'!

!MDSlicePanel class methodsFor: 'instance creation' stamp: 'cwp 8/29/2005 01:49'!
withAllPackages
	| inst slices |
	slices _ PackageInfo allPackages collect: [:ea | MDPackageSlice forPackage: ea].
	inst _ self new.
	slices sort: [:a :b | a name <= b name].
	slices do: [:ea | inst addSlice: ea].
	^ inst! !

!MDSlicePanel methodsFor: 'accessing' stamp: 'cwp 8/24/2005 21:54'!
addSlice: aSlice
	^ self addSlice: aSlice of: MDWorkingCopy default! !

!MDSlicePanel methodsFor: 'accessing' stamp: 'cwp 8/24/2005 22:44'!
addSlice: aSlice of: aWorkingCopy 
	stati add: (MDSliceStatus forSlice: aSlice of: aWorkingCopy)! !

!MDSlicePanel methodsFor: 'accessing' stamp: 'cwp 8/24/2005 22:44'!
addStatus: aSliceStatus 
	stati add: aSliceStatus! !

!MDSlicePanel methodsFor: 'building' stamp: 'cwp 8/22/2005 23:58'!
buildWith: aBuilder
		| windowSpec listSpec |
	windowSpec := aBuilder pluggableWindowSpec new.
	windowSpec
		model: self;
		name: 'window';
		label: 'Monticello Slices';
		extent: 250 @ 400;
		children: OrderedCollection new.
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: 'slices';
		list: #sliceList;
		menu: #sliceListMenu:;
		getIndex: #sliceListIndex;
		setIndex: #sliceListIndex:;
		keyPress: nil;
		autoDeselect: false;
		frame: (0 @ 0 corner: 1 @ 1).
	windowSpec children add: listSpec.
	^ aBuilder build: windowSpec.! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 9/5/2005 17:29'!
classCommented: anEvent
	stati do: [:ea | ea isDirty ifFalse: [ea classCommented: anEvent]].
	self changed: #sliceList! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/28/2005 19:19'!
classModified: anEvent
	stati do: [:ea | ea isDirty ifFalse: [ea classModified: anEvent]].
	self changed: #sliceList! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 9/5/2005 17:27'!
classMoved: anEvent
	self classModified: anEvent! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 9/5/2005 17:28'!
classRemoved: anEvent
	^ self classModified: anEvent! !

!MDSlicePanel methodsFor: 'initialize-release' stamp: 'cwp 8/24/2005 22:44'!
initialize
	stati := OrderedCollection new.
	index := 0! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/29/2005 01:41'!
methodModified: anEvent
	stati do: [:ea | ea isDirty ifFalse: [ea methodModified: anEvent]].
	self changed: #sliceList! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/28/2005 19:15'!
methodMoved: anEvent
	self methodModified: anEvent! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/28/2005 19:12'!
methodRemoved: anEvent
	self methodModified: anEvent! !

!MDSlicePanel methodsFor: 'building' stamp: 'cwp 8/28/2005 19:17'!
open
	self register.
	ToolBuilder open: self! !

!MDSlicePanel methodsFor: 'actions' stamp: 'cwp 9/6/2005 00:24'!
perform: aSelector orSendTo: anObject
	(self respondsTo: aSelector)
		ifTrue: [self perform: aSelector]
		ifFalse: [anObject perform: aSelector]! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 9/5/2005 17:26'!
register
	SystemChangeNotifier uniqueInstance
		notify: self ofSystemChangesOfItem: #class change: #Added using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Modified using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Renamed using: #classModified:;
		notify: self ofSystemChangesOfItem: #class change: #Commented using: #classCommented:;
		notify: self ofSystemChangesOfItem: #class change: #Recategorized using: #classMoved:;	
		notify: self ofSystemChangesOfItem: #class change: #Removed using: #classRemoved:;
		notify: self ofSystemChangesOfItem: #method change: #Added using: #methodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #methodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Recategorized using: #methodMoved:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #methodRemoved:! !

!MDSlicePanel methodsFor: 'actions' stamp: 'cwp 9/4/2005 00:44'!
save
	self selection 
		save;
		 beClean.
	self changed: #sliceList! !

!MDSlicePanel methodsFor: 'accessing' stamp: 'cwp 8/29/2005 21:48'!
selection
	^ stati at: index! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 8/24/2005 22:55'!
sliceList
	^stati collect: [:ea | ea displayString]! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 8/22/2005 23:57'!
sliceListIndex
	^ index! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 8/24/2005 21:35'!
sliceListIndex: anInteger 
	index _ anInteger.
	self changed: #sliceListIndex! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 9/4/2005 00:45'!
sliceListMenu: aMenuSpec
	^ aMenuSpec
		add: 'save' action: #save;
		yourself! !

!MDSlicePanel methodsFor: 'system changes' stamp: 'cwp 8/28/2005 19:07'!
unregister
	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self! !

!MDSlicePanel methodsFor: 'callbacks' stamp: 'cwp 8/28/2005 19:17'!
windowIsClosing
	self unregister
! !

Object subclass: #MDSliceStatus
	instanceVariableNames: 'slice wc isDirty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-UI'!

!MDSliceStatus class methodsFor: 'as yet unclassified' stamp: 'cwp 8/24/2005 21:55'!
forSlice: aSlice of: aWorkingCopy
	^ self new setSlice: aSlice wc: aWorkingCopy! !

!MDSliceStatus methodsFor: 'accessing' stamp: 'cwp 8/25/2005 23:16'!
beClean
	^ isDirty _ false.! !

!MDSliceStatus methodsFor: 'accessing' stamp: 'cwp 8/25/2005 23:16'!
beDirty
	^ isDirty _ true! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/28/2005 16:57'!
check: aSelector inEvent: anEvent as: aClass

	self 
		check: aSelector
		inEvent: anEvent
		as: aClass
		using: #yourself! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/28/2005 16:57'!
check: aSelector inEvent: anEvent as: aClass using: nameSelector

	| changed element |
	changed := (anEvent oldItem perform: aSelector)
				 disjoin: (anEvent item perform: aSelector).
	changed do: [:ea | 
				element := aClass 
							className: anEvent itemClass theNonMetaClass name
							name: (ea perform: nameSelector).
				(self eventWithElement: element) ifTrue: [^ self]].
! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 9/5/2005 20:26'!
classCommented: anEvent
	self eventWithElement: (MDClassCommentElement className: anEvent item name)! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'avi 9/5/2005 19:57'!
classModified: anEvent 
	| element |
	anEvent itemClass isMeta ifTrue: [^self metaclassModified: anEvent].
	element := MDClassElement className: anEvent itemClass name.
	(self eventWithElement: element) ifTrue: [^self].
	anEvent isModified ifFalse: [^ self].
	self
		check: #instVarNames
			inEvent: anEvent
			as: MDInstVarElement;
		check: #classVarNames
			inEvent: anEvent
			as: MDClassVarElement;
		check: #sharedPools
			inEvent: anEvent
			as: MDPoolImportElement
			using: #name! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/28/2005 18:57'!
classMoved: anEvent
	! !

!MDSliceStatus methodsFor: 'accessing' stamp: 'cwp 8/24/2005 23:13'!
displayString
	^( self isDirty
		ifTrue: ['* ']
		ifFalse: ['  ']), self name! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/29/2005 01:37'!
eventWithElement: element
	(slice includes: element) ifTrue: [^ self beDirty].
	^ false! !

!MDSliceStatus methodsFor: 'testing' stamp: 'cwp 8/24/2005 23:16'!
isDirty
	^ isDirty! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 9/4/2005 00:41'!
metaclassModified: anEvent 
	self 
		check: #instVarNames
		inEvent: anEvent
		as: MDClassInstVarElement! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/29/2005 19:47'!
methodModified: anEvent
	| element |
	element := MDMethodElement 
				className: anEvent itemClass theNonMetaClass name 
				selector: anEvent itemSelector
				classIsMeta: anEvent itemClass isMeta.
	self eventWithElement: element.! !

!MDSliceStatus methodsFor: 'system changes' stamp: 'cwp 8/28/2005 18:56'!
methodRemoved: anEvent 
	self methodModified: anEvent! !

!MDSliceStatus methodsFor: 'accessing' stamp: 'cwp 8/24/2005 21:57'!
name
	^ slice name! !

!MDSliceStatus methodsFor: 'actions' stamp: 'cwp 9/4/2005 00:26'!
save
	slice save.
	self beClean! !

!MDSliceStatus methodsFor: 'initialize-release' stamp: 'cwp 8/24/2005 23:16'!
setSlice: aSlice wc: aWorkingCopy
	slice _ aSlice.
	wc _ aWorkingCopy.
	isDirty _ false.! !

Object subclass: #MDSqueakElementAdaptor
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

MDSqueakElementAdaptor subclass: #MDSqueakClassAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
category
	^ self elementClass category! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
classVariablesString
	^ self send: #classVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:39'!
elementClass
	^ Smalltalk at: element theClassName ifAbsent: [nil]! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:39'!
format
	^ self elementClass typeOfClass! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:30'!
instanceVariablesString
	^ self send: #instanceVariablesString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:31'!
isLoadable: properties 
	self superclassFrom: properties ifAbsent: [^ false].
	^ true! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 21:23'!
isPresent
	^ (Smalltalk at: element theClassName ifAbsent: [^ false])
		isKindOf: Class! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 22:25'!
load: properties
	| superClass |
	superClass _ Smalltalk at: properties superclassName.
	ClassBuilder new
		name: element theClassName 
		inEnvironment: superClass environment 
		subclassOf: superClass
		type: properties format 
		instanceVariableNames: self instanceVariablesString 
		classVariableNames: self classVariablesString 
		poolDictionaries: self sharedPoolsString
		category: properties category
! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/5/2005 23:02'!
propertyNames
	^ #(category format superclassName)! !

!MDSqueakClassAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 12:39'!
remove
	self elementClass ifNotNilDo: [:class | class removeFromSystem]! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:39'!
send: aSelector toClassIfNil: aBlock
	| class |
	class := self elementClass.
	^ class 
		ifNotNil: [class perform: aSelector]
		ifNil: aBlock! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:31'!
sharedPoolsString
	^ self send: #sharedPoolsString toClassIfNil: ['']! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/15/2005 15:05'!
superclassFrom: properties ifAbsent: absentBlock 
	| global |
	global _ Smalltalk 
				at: properties superclassName 
				ifAbsent: [^ absentBlock value].
	^ (global isKindOf: Class)
		ifTrue: [global]
		ifFalse: absentBlock! !

!MDSqueakClassAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:40'!
superclassName
	^ self elementClass superclass name! !

!MDSqueakClassAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 22:32'!
theClass
	^ Smalltalk at: element theClassName ifAbsent: [nil]! !

MDSqueakElementAdaptor subclass: #MDSqueakClassCommentAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:22'!
isPresent
	^ self elementClass hasComment! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:55'!
load: properties
	self elementClass
		classComment: properties text
		stamp: (self stampFromProperties: properties)! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:29'!
propertyNames
	^ #(text author timeStamp)! !

!MDSqueakClassCommentAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:59'!
remove
	self elementClass organization classComment: nil stamp: nil.
! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:34'!
stamp
	^ self elementClass organization commentStamp! !

!MDSqueakClassCommentAdaptor methodsFor: 'properties' stamp: 'cwp 3/11/2005 21:02'!
text
	^ self elementClass comment asString! !

MDSqueakElementAdaptor subclass: #MDSqueakClassVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:49'!
isPresent
	^ self elementClass classVarNames includes: element name! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 14:00'!
load: properties
	self isPresent ifFalse: [self elementClass addClassVarName: element name]! !

!MDSqueakClassVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:59'!
remove
	self isPresent ifTrue: [self elementClass removeClassVarName: element name]! !

!MDSqueakElementAdaptor class methodsFor: 'instance creation' stamp: 'cwp 2/5/2005 20:56'!
forElement: anElement
	^ self new setElement: anElement! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 3/11/2005 23:11'!
author
	| author |
	author _ self stamp copyUpTo: $ .
	^ author isEmpty ifFalse: [author] ifTrue: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:44'!
elementClass
	^ self elementClassIfAbsent: [nil]! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 2/6/2005 12:44'!
elementClassIfAbsent: aBlock
	^ Smalltalk at: element theClassName ifAbsent: aBlock! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/15/2005 15:47'!
isLoadable: properties
	self elementClassIfAbsent: [^ false].
	^ true! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/5/2005 21:40'!
isUpToDate: properties 
	self propertyNames
		do: [:property | (self is: property upToDateIn: properties) ifFalse: [^ false]].
	^ true
! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 2/5/2005 21:40'!
is: name upToDateIn: properties
	^ (properties at: name ifAbsent: [^ true]) = (self perform: name)
	! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
load: properties
	self subclassResponsibility! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'avi 3/16/2005 12:21'!
merge: aPropertyDictionary into: otherPropertyDictionary onFailure: aBlock
	^ aBlock value! !

!MDSqueakElementAdaptor methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:39'!
propertyNames
	^ #()! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 2/12/2005 14:08'!
remove
	self subclassResponsibility! !

!MDSqueakElementAdaptor methodsFor: 'initialize-release' stamp: 'cwp 2/5/2005 16:55'!
setElement: anElement
	element _ anElement! !

!MDSqueakElementAdaptor methodsFor: 'private' stamp: 'cwp 8/20/2005 19:32'!
stampFromProperties: properties
	| author timestamp |
	author _ properties at: #author ifAbsent: ['<nobody>'].
	timestamp _ properties at: #timeStamp ifAbsent: [^ '<no timestamp>'].
	^ timestamp printFormat: author, ' %l/%e/%Y %H:%M'
	! !

!MDSqueakElementAdaptor methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:46'!
timeStamp
	| stamp |
	stamp := self stamp.
	^ (stamp = '<historical>' or: [stamp = ''])
		ifFalse: [MDTimestamp fromSqueakMethodStamp: stamp]
		ifTrue: [nil]
! !

!MDSqueakElementAdaptor methodsFor: 'public' stamp: 'cwp 3/11/2005 22:50'!
update: properties
	self propertyNames do: 
		[:name | (self perform: name) ifNotNilDo: 
			[:value | properties at: name put: value]]! !

MDSqueakElementAdaptor subclass: #MDSqueakInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

MDSqueakInstVarAdaptor subclass: #MDSqueakClassInstVarAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakClassInstVarAdaptor methodsFor: 'accessing' stamp: 'cwp 3/4/2005 15:04'!
elementClassIfAbsent: aBlock
	^ (super elementClassIfAbsent: aBlock) class! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 8/20/2005 18:21'!
isPresent
	^ (self elementClassIfAbsent: [^ false])
		instVarNames includes: element name! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 13:56'!
load: properties
	self isPresent ifFalse: [self elementClass addInstVarName: element name]! !

!MDSqueakInstVarAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:56'!
remove
	self isPresent ifTrue: [self elementClass removeInstVarName: element name]! !

MDSqueakElementAdaptor subclass: #MDSqueakLogAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/15/2005 23:00'!
isLoadable: properties
	^ true! !

!MDSqueakLogAdaptor methodsFor: 'testing' stamp: 'cwp 3/15/2005 22:39'!
isPresent
	^ true! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/15/2005 23:16'!
isUpToDate: properties
	^ false! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/15/2005 22:58'!
load: properties! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/23/2005 22:15'!
merge: properties into: other onFailure: aBlock
	other keys do: [:ea | other removeKey: ea].
	^ other! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/15/2005 23:07'!
remove! !

!MDSqueakLogAdaptor methodsFor: 'public' stamp: 'cwp 3/15/2005 23:38'!
update: properties
	MDLogMessageRequest update: properties! !

MDSqueakElementAdaptor subclass: #MDSqueakMetadataAdaptor
	instanceVariableNames: ''
	classVariableNames: 'ImageMetadata'
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:37'!
atElement: anElement
	^ ImageMetadata at: anElement ifAbsent: [nil]! !

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:30'!
atElement: anElement putProperties: properties
	ImageMetadata at: anElement put: properties! !

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:38'!
elementIsPresent: anElement
	^ (self atElement: anElement) notNil! !

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:32'!
initialize
	ImageMetadata _ Dictionary new! !

!MDSqueakMetadataAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/22/2005 23:36'!
removeElement: anElement
	^ ImageMetadata removeKey: anElement ifAbsent: [nil]! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:42'!
isLoadable: properties
	^ true! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:42'!
isPresent
	^ self class elementIsPresent: element! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:50'!
isUpToDate: properties
	(self class atElement: element)
		keysAndValuesDo: [:key :value | (properties at: key) = value ifFalse: [^ false]].
	^ true! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/23/2005 00:13'!
load: properties
	| copy |
	copy _ properties copy.
	copy versionNumber: copy versionNumber + 1.
	self class atElement: element putProperties: copy! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/23/2005 22:30'!
merge: properties into: other onFailure: aBlock
	properties branch = other branch ifFalse: [^ aBlock value].
	properties versionNumber > other versionNumber
		ifTrue: [other versionNumber: properties versionNumber].! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:46'!
remove
	self class removeElement: element! !

!MDSqueakMetadataAdaptor methodsFor: 'public' stamp: 'cwp 3/22/2005 23:48'!
update: properties
	(self class atElement: element)
		keysAndValuesDo: [:key :value | properties at: key put: value]! !

MDSqueakElementAdaptor subclass: #MDSqueakMethodAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:06'!
category
	^ self elementClass organization categoryOfElement: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 12:44'!
compiledMethod 
	^ self elementClass compiledMethodAt: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 15:24'!
elementClassIfAbsent: aBlock
	| nonMetaClass |
	nonMetaClass := super elementClassIfAbsent: aBlock.
	^ element classIsMeta
		ifTrue: [nonMetaClass class]
		ifFalse: [nonMetaClass]! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 2/3/2005 23:22'!
isPresent
	^ self elementClass includesSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/14/2005 18:36'!
isUpToDate: aPropertyDictionary
	aPropertyDictionary localReference ifNotNilDo:
		[:compiledMethod |
		compiledMethod = self compiledMethod ifTrue: [^ true]].
	^ super isUpToDate: aPropertyDictionary! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/14/2005 18:11'!
load: properties
	| selector |
	selector _ self elementClass
					compile: (properties at: #source ifAbsent: [self source])
					classified: (properties at: #category ifAbsent: [self category])
					withStamp: (self stampFromProperties: properties)
					notifying: nil
					logSource: true.

	properties localReference: (self elementClass compiledMethodAt: selector)! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/3/2005 23:12'!
propertyNames
	^ #(author timeStamp category source)! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'cwp 8/14/2005 19:57'!
remove
	(self elementClassIfAbsent: [^ self])
		removeSelector: element selector! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 3/11/2005 20:44'!
source
	^ (self elementClass sourceCodeAt: (element selector)) asString.! !

!MDSqueakMethodAdaptor methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:30'!
stamp
	^self compiledMethod timeStamp! !

!MDSqueakMethodAdaptor methodsFor: 'public' stamp: 'avi 3/14/2005 18:32'!
update: aPropertyDictionary
	super update: aPropertyDictionary.
	aPropertyDictionary localReference: self compiledMethod! !

MDSqueakElementAdaptor subclass: #MDSqueakPoolImportAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Squeak'!

!MDSqueakPoolImportAdaptor methodsFor: 'private' stamp: 'cwp 2/6/2005 23:41'!
importedPool
	^ Smalltalk at: element poolName! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:34'!
isPresent
	^ self elementClass sharedPools anySatisfy: [:ea | ea name = element poolName]! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:41'!
load: properties
	self elementClass addSharedPool: self importedPool! !

!MDSqueakPoolImportAdaptor methodsFor: 'public' stamp: 'cwp 2/6/2005 23:44'!
remove
	"Work around a bug in Class>>removeSharedPool:"
	
	self elementClass sharedPools remove: self importedPool ifAbsent: []! !

Object subclass: #MDStore
	instanceVariableNames: 'repositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Repositories'!

MDStore class
	instanceVariableNames: 'default'!

!MDStore class methodsFor: 'private' stamp: 'cwp 4/18/2005 12:29'!
createDefault
	| store |
	store _ self new.
	store addRepository: (MDFileRepository named: 'repository').
	^ store! !

!MDStore class methodsFor: 'accessing' stamp: 'cwp 3/13/2005 01:07'!
default
	^ default ifNil: [default _ self createDefault]! !

!MDStore class methodsFor: 'accessing' stamp: 'cwp 3/13/2005 01:11'!
resetDefault
	default _ nil! !

!MDStore methodsFor: 'accessing' stamp: 'cwp 3/13/2005 00:26'!
addRepository: aRepository
	repositories add: aRepository! !

!MDStore methodsFor: 'repository' stamp: 'cwp 3/13/2005 00:28'!
get: aHashstamp
	^ repositories do: [:ea | (ea get: aHashstamp) ifNotNilDo: [:object | ^ object]]! !

!MDStore methodsFor: 'initialize-release' stamp: 'cwp 3/13/2005 00:25'!
initialize
	repositories _ OrderedCollection new! !

!MDStore methodsFor: 'repository' stamp: 'cwp 3/13/2005 00:26'!
put: anObject
	repositories do: [:ea | ea put: anObject]! !

!MDStore methodsFor: 'accessing' stamp: 'cwp 8/7/2005 21:58'!
repositories
	^ repositories! !

!MDStore methodsFor: 'repository' stamp: 'avi 4/17/2005 02:18'!
snapshotHashstampsDo: aBlock
	repositories do: [:ea | ea snapshotHashstampsDo: aBlock]! !

Object subclass: #MDTimestampPrinter
	instanceVariableNames: 'year month day hours minutes seconds'
	classVariableNames: 'Map MonthNames'
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDTimestampPrinter commentStamp: 'cwp 4/9/2005 04:06' prior: 0!
%V - If the week containing 1 January has four or more days in the new year, then it is considered week 1. Otherwise, it is the last week of the previous year, and the next week is week 1.
%W - the week number of the year (Monday as the first day of the week) as a decimal number [00,53]. All days in a new year preceding the first Monday are considered to be in week 0.!

!MDTimestampPrinter class methodsFor: 'as yet unclassified' stamp: 'cwp 4/9/2005 04:15'!
initialize
	MonthNames _ #(January February March April May June 
					July August September Ocober November December).
	Map _ Dictionary new.
	Map
		at: $a put: #abbreviatedWeekdayName:;
		at: $A put: #fullWeekdayName:;
		at: $b put: #abbreviatedMonthName:;
		at: $B put: #fullMonthName:;
		at: $C put: #centuryNumber:;
		at: $d put: #paddedDay:;
		at: $D put: #usDate:;
		at: $e put: #unpaddedDay:;
		at: $h put: #unpaddedHour24;
		at: $H put: #paddedHour24:;
		at: $i put: #unpaddedHour12:;
		at: $I put: #paddedHour12:;
		at: $j put: #dayOfYear:;
		at: $l put: #unpaddedMonth:;
		at: $m put: #paddedMonth:;
		at: $M put: #paddedMinute:;
		at: $n put: #newline:;
		at: $p put: #ampm:;
		at: $S put: #paddedSecond:;
		at: $t put: #tab:;
		at: $u put: #weekDayMonday:;
		at: $U put: #weekNumberSunday:;
		at: $V put: #weekNumberMonday:;
		at: $w put: #weekDaySunday:;
		at: $W put: #weekNumberMonday2:;
		at: $y put: #yearShort:;
		at: $Y put: #yearLong:;
		at: $% put: #percent:! !

!MDTimestampPrinter class methodsFor: 'as yet unclassified' stamp: 'cwp 4/9/2005 03:03'!
year: year month: month day: day hours: hours minutes: minutes seconds: seconds
	^ self new
		year: year;
		month: month;
		day: day;
		hours: hours;
		minutes: minutes;
		seconds: seconds;
		yourself! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:22'!
ampm: aStream
	aStream nextPutAll: (hours > 12 ifFalse: ['am'] ifTrue: ['pm'])! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:07'!
day
	^day! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:07'!
day: anObject
	day := anObject! !

!MDTimestampPrinter methodsFor: 'errors' stamp: 'cwp 4/9/2005 03:43'!
doesNotUnderstand: aMessage
	(Map values includes: aMessage selector)
		ifTrue: [self error: 'Unimplemented specifier'].
	^ super doesNotUnderstand: aMessage! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:17'!
fullMonthName: aStream
	aStream nextPutAll: (MonthNames at: month)! !

!MDTimestampPrinter methodsFor: 'private' stamp: 'cwp 4/9/2005 04:19'!
hour12
	| int |
	int _ hours \\ 12.
	int = 0 ifTrue: [int _ 12].
	^ int! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
hours
	^hours! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
hours: anObject
	hours := anObject! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
minutes
	^minutes! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
minutes: anObject
	minutes := anObject! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
month
	^month! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
month: anObject
	month := anObject! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:52'!
paddedDay: aStream
	self pad: day on: aStream.
	self unpaddedDay: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:19'!
paddedHour12: aStream
	| int |
	int _ self hour12.
	self pad: int on: aStream.
	int printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:58'!
paddedHour24: aStream
	self pad: hours on: aStream.
	hours printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:57'!
paddedMinute: aStream
	self pad: minutes on: aStream.
	minutes printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:51'!
paddedMonth: aStream
	self pad: month on: aStream.
	self unpaddedMonth: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:21'!
paddedSecond: aStream
	self pad: seconds on: aStream.
	seconds printOn: aStream! !

!MDTimestampPrinter methodsFor: 'private' stamp: 'cwp 4/9/2005 03:52'!
pad: anInteger on: aStream
	anInteger < 10 ifTrue: [aStream nextPut: $0]! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 4/9/2005 03:08'!
printFormat: aString
	| stream |
	stream _ (String new: 10) writeStream.
	self printOn: stream format: aString.
	^ stream contents! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 4/9/2005 03:17'!
printOn: aStream format: aString
	| specification char |
	specification _ aString readStream.
	[specification atEnd]	 whileFalse: 
		[char _ specification next.
		char = $%
			ifTrue: [self printOn: aStream specifier: specification next]
			ifFalse: [aStream nextPut: char]]! !

!MDTimestampPrinter methodsFor: 'printing' stamp: 'cwp 4/9/2005 03:42'!
printOn: aStream specifier: aCharacter
	| selector |
	selector _ Map 
				at: aCharacter 
				ifAbsent: [self error: 'Unrecongized specifier: ', aCharacter].
	self perform: selector with: aStream! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:01'!
seconds
	^seconds! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:01'!
seconds: anObject
	seconds := anObject! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:52'!
unpaddedDay: aStream
	day printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:20'!
unpaddedHour12: aStream
	self hour12 printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:47'!
unpaddedMonth: aStream
	month printOn: aStream! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:08'!
weekNumberMonday
	"From the Unix spec: 'If the week containing 1 January has four or more days
	in the new year, then it is considered week 1. Otherwise, it is the last week of
	the previous year, and the next week is week 1.'"

	self error: 'Unimplemented Specifier'! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 04:08'!
weekNumberMonday2
	"From the Unix spec: 'If the week containing 1 January has four or more days in the new year, 
	then it is considered week 1. Otherwise, it is the last week of the previous year, 
	and the next week is week 1.'"

	self error: 'Unimplemented Specifier'! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
year
	^year! !

!MDTimestampPrinter methodsFor: 'specifiers' stamp: 'cwp 4/9/2005 03:53'!
yearLong: aStream
	year printOn: aStream! !

!MDTimestampPrinter methodsFor: 'accessing' stamp: 'cwp 4/9/2005 03:00'!
year: anObject
	year := anObject! !

Object subclass: #MDWorkingCopy
	instanceVariableNames: 'proxy versions slush'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

MDWorkingCopy class
	instanceVariableNames: 'default'!

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'cwp 3/4/2005 15:32'!
default
	^ default ifNil: [default _ self forImageProxy: self defaultImageProxy]! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'cwp 3/4/2005 15:32'!
defaultImageProxy
	^ MDSqueakImageProxy new! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:56'!
forImageProxy: anImageProxy
	^ self basicNew initializeWithImageProxy: anImageProxy! !

!MDWorkingCopy class methodsFor: 'instance creation' stamp: 'cwp 3/11/2005 20:48'!
resetDefault
	default _ nil! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 2/27/2005 22:09'!
createVersionForElement: anElement 
	| snapshot version |
	(proxy hasElement: anElement) ifFalse: [^ MDNullVersion forElement: anElement].
	snapshot _ (MDElementDefinition forElement: anElement) updateFrom: proxy.
	version _ MDElementVersion snapshot: snapshot.
	versions at: anElement put: version.
	^ version! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 5/24/2005 07:59'!
displayVersion: aVersion
	^ proxy display: aVersion snapshot! !

!MDWorkingCopy methodsFor: 'public' stamp: 'avi 3/16/2005 11:59'!
includeVersion: anElementVersion onConflict: twoArgBlock 
	| current successor |
	current := self versionForElement: anElementVersion element.
	successor := current 
					successor: anElementVersion 
					onConflict: [current resolveConflictWith: anElementVersion in: proxy using: twoArgBlock].
	successor == current ifTrue: [^ false].
	self loadVersion: successor.	
	^true! !

!MDWorkingCopy methodsFor: 'initialize-release' stamp: 'cwp 3/10/2005 22:12'!
initializeWithImageProxy: anImageProxy
	proxy _ anImageProxy.
	versions _ Dictionary new.
	slush _ Set new.! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 3/10/2005 22:14'!
loadSlush
	| loading |	
	[loading _ slush.
	slush _ self loadSlush: loading.
	loading size > slush size] whileTrue.
	! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 3/10/2005 22:17'!
loadSlush: loading
	| unloadable |
	unloadable _ Set new.
	loading do: [:ea | (proxy isLoadable: ea snapshot)
						ifTrue: [proxy loadSnapshot: ea snapshot]
						ifFalse: [unloadable add: ea]].
	^ unloadable! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 3/10/2005 22:12'!
loadVersion: anElementVersion

	versions at: anElementVersion element put: anElementVersion.
	slush add: anElementVersion.
	self loadSlush! !

!MDWorkingCopy methodsFor: 'private' stamp: 'cwp 3/2/2005 23:38'!
newVersionForElement: anImageElement
	| oldVersion newSnapshot |
	oldVersion _ versions at: anImageElement.
	newSnapshot _ oldVersion snapshot copy.
	^ versions 
		at: anImageElement
		put: (MDElementVersion
				snapshot: (proxy updateSnapshot: newSnapshot)
				ancestry: oldVersion fullAncestry)! !

!MDWorkingCopy methodsFor: 'public' stamp: 'cwp 2/13/2005 15:29'!
versionForElement: anImageElement
	| old |
	old _ versions 
			at: anImageElement 
			ifAbsent: [^ self createVersionForElement: anImageElement].
	^ (proxy isUpToDate: old snapshot)
		ifTrue: [old]
		ifFalse: [self newVersionForElement: anImageElement]! !

!Object class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:59'!
materializeWith: aMarshal
	^ aMarshal readObject: self basicNew! !

!Object methodsFor: '*monticello2' stamp: 'cwp 3/7/2005 21:23'!
classId
	^ MDMarshal classIdForObject: self! !

!Object methodsFor: '*monticello2' stamp: 'cwp 4/25/2005 04:04'!
displayOn: aStream
	self printOn: aStream! !

!Object methodsFor: '*monticello2' stamp: 'cwp 4/25/2005 04:03'!
displayString
	^ String streamContents: [:stream | self displayOn: stream]! !

!Object methodsFor: '*monticello2' stamp: 'cwp 4/25/2005 04:11'!
printNameOn: aStream during: aBlock
	aStream print: self class.
	aStream nextPut: $<.
	aBlock value.
	aStream nextPut: $>! !

!Object methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:10'!
serializeWith: aMarshal
	aMarshal writeObject: self! !

!SmallInteger class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 21:21'!
materializeWith: aMarshal
	^ aMarshal readSmallInteger! !

!PGConnectionArgs methodsFor: '*monticello2-connecting' stamp: 'cwp 8/21/2005 12:00'!
createConnection
	^ PGConnection new
		connectionArgs: self! !

TestCase subclass: #MDAdaptionTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAdaptionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 22:33'!
isAbstract
	^ self name = #MDAdaptionTest! !

!MDAdaptionTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 22:14'!
adaptorSelectors
	^ #(isPresent isUpToDate: load: remove update:)! !

!MDAdaptionTest methodsFor: 'configuration' stamp: 'cwp 2/6/2005 22:10'!
proxyClass
	^ MDFakeImageProxy! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 2/6/2005 22:37'!
setUp
	proxy := self proxyClass new! !

!MDAdaptionTest methodsFor: 'constructing' stamp: 'cwp 3/15/2005 22:22'!
slice
	^ MDExplicitSlice named: 'Foo'! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/12/2005 13:59'!
testClassComment
	self tryAdapting: (MDClassCommentElement className: #MDBogusA)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:26'!
testClassElement
	self tryAdapting: (MDClassElement className: #MDBogusA)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 14:43'!
testClassInstVarElement
	self tryAdapting: (MDClassInstVarElement className: #MDBogusA name: 'beth')! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:29'!
testClassVarElement
	self tryAdapting: (MDClassVarElement className: #MDBogusA name: 'Beta')! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:27'!
testInstVarElement
	self tryAdapting: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 3/22/2005 22:50'!
testLogElement
	self tryAdapting: (MDLogElement forSlice: self slice)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 3/22/2005 22:51'!
testMetadataElement
	self tryAdapting: (MDMetadataElement forSlice: self slice)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 22:26'!
testMethodElement
	self tryAdapting: (MDMethodElement className: #MDBogusA selector: #method1)! !

!MDAdaptionTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 23:59'!
testPoolImportElement
	self tryAdapting: (MDPoolImportElement className: #MDBogusA poolName: #MDBogusPoolB)! !

!MDAdaptionTest methodsFor: 'running' stamp: 'cwp 2/6/2005 22:26'!
tryAdapting: anElement
	| adaptor |
	adaptor := anElement adaptedFor: proxy.
	self adaptorSelectors do: [:ea | self assert: (adaptor respondsTo: ea)].! !

MDAdaptionTest subclass: #MDFakeAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFakeAdaptionTest methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:32'!
proxyClass
	^ MDFakeImageProxy! !

MDAdaptionTest subclass: #MDSqueakAdaptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakAdaptionTest methodsFor: 'converting' stamp: 'cwp 2/6/2005 22:33'!
proxyClass
	^ MDSqueakImageProxy! !

TestCase subclass: #MDAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/6/2005 11:53'!
isAbstract
	^ self name = #MDAdaptorTest! !

!MDAdaptorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2005 21:40'!
shouldInheritSelectors
	^ true! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:43'!
adaptor
	^ self adaptorForElement: self element! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/15/2005 22:53'!
adaptorClass
	^ MDSqueakLogAdaptor! !

!MDAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:41'!
adaptorForElement: anElement
	^ self adaptorClass forElement: anElement! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
author
	^ self stamp copyUpTo: $ ! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:49'!
bogusClass
	^ MDBogusA! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 3/23/2005 00:03'!
canBeUnloadable
	^ true! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'avi 3/14/2005 18:28'!
hasOptimizedUpToDate
	^ false! !

!MDAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	self subclassResponsibility! !

!MDAdaptorTest methodsFor: 'running' stamp: 'cwp 2/5/2005 20:53'!
tearDown
	self destroyObject! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 00:02'!
testClassMissing
	| adaptor |
	self canBeUnloadable 
		ifTrue: [adaptor := self adaptorForElement: self unloadableElement.
				self deny: (adaptor isLoadable: self properties)]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 14:45'!
testIsLoadable
	self assert: (self adaptor isLoadable: self properties)
! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:42'!
testIsPresent
	self createObject.
	self assert: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 00:10'!
testIsUpToDate
	self createObject.
	self assert: (self adaptor isUpToDate: self properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 15:17'!
testLoad
	self adaptor load: self properties.
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 21:07'!
testNotPresent
	self deny: self adaptor isPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/12/2005 14:41'!
testNotUpToDate
	| properties |
	self propertyToChange ifNil: [^ self].
	self createObject.
	properties := self properties.
	properties at: self propertyToChange put: self changedValue.
	self deny: (self adaptor isUpToDate: properties)! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'avi 3/14/2005 18:29'!
testOptimizedUpToDate
	| method properties time1 time2 |
	self hasOptimizedUpToDate ifTrue:
		[self createObject.
		method _ self adaptor.
		properties _ self properties. 
		self assert: (method isUpToDate: properties).
		time1 _ Time millisecondsToRun: [100 timesRepeat: [method isUpToDate: properties]].
		method load: properties.
		self assert: (method isUpToDate: properties).
		time2 _ Time millisecondsToRun: [100 timesRepeat: [method isUpToDate: properties]].
		self assert: (time2 < time1)]! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 14:08'!
testRemove
	self createObject.
	self adaptor remove.
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 23:54'!
testRemoveNotPresent
	self adaptor remove.
	self deny: self objectIsPresent! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 22:54'!
testUpdate
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: properties = self properties! !

!MDAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 23:03'!
testUpdateSideEffects
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assertObjectHasDefaultProperties! !

!MDAdaptorTest methodsFor: 'properties' stamp: 'cwp 4/9/2005 01:54'!
timeStamp
	^ MDTimestamp fromSqueakMethodStamp: self stamp! !

!MDAdaptorTest methodsFor: 'configuration' stamp: 'cwp 2/15/2005 15:56'!
unloadableElement
	self subclassResponsibility! !

MDAdaptorTest subclass: #MDSqueakClassAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 14:42'!
adaptorClass
	^ MDSqueakClassAdaptor ! !

!MDSqueakClassAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 11:55'!
assertObjectHasDefaultProperties
	| class |
	class := Smalltalk 
			at: self bogusClassName 
			ifAbsent: [self signalFailure: 'Class doesn''t exist'].
	self assert: class superclass name = self superclassName.
	self assert: class category = self category.
	self assert: class typeOfClass = self format! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:02'!
bogusClassName
	^ #MDBogusB! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 12:03'!
category
	^ #'Monticello2-Fakes'! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 15:05'!
changedValue
	^ #temp! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:16'!
classInstVars
	^ 'aleph beth'! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
classVariablesString
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:12'!
classVars
	^ 'Alpha Beta'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:13'!
comment
	^ 'A politician''s comment: it fills the space, while saying nothing.'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:14'!
commentAuthor
	^ self commentStamp copyUpTo: $ ! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:15'!
commentStamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 4/9/2005 04:48'!
commentTimeStamp
	^ MDTimestamp fromSqueakMethodStamp: self commentStamp! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:08'!
createObject
	Object 
		subclass: self bogusClassName
		instanceVariableNames: self instanceVariablesString
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:56'!
destroyObject
	(Smalltalk at: self bogusClassName ifAbsent: [^ self]) removeFromSystem! !

!MDSqueakClassAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 11:58'!
element
	^ MDClassElement className: self bogusClassName! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
format
	^ #normal! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:07'!
instanceVariablesString
	^'one two'! !

!MDSqueakClassAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:06'!
objectIsPresent
	^ Smalltalk hasClassNamed: self bogusClassName asString! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 22:18'!
properties
	^ MDPropertyDictionary new
		category: self category;
		format: self format;
		superclassName: self superclassName;
		yourself! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #category! !

!MDSqueakClassAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 23:52'!
sharedPoolsString
	^ 'MDBogusPoolA'! !

!MDSqueakClassAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 21:36'!
superclassName
	^ #Object! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/15/2005 16:06'!
testClassMissing
	| properties |
	properties _ self properties.
	properties superclassName: #MDNonExistentClass.
	self deny: (self adaptor isLoadable: properties)! !

!MDSqueakClassAdaptorTest methodsFor: 'tests' stamp: 'cwp 2/6/2005 12:05'!
testLoadingPreservesVars
	| class |
	self createObject.
	self adaptor load: self properties.
	class := Smalltalk at: self bogusClassName ifAbsent: [self assert: false].
	self assert: class instanceVariablesString = 'one two'.
	self assert: class classVariablesString = 'Alpha Beta'.
	self assert: class sharedPoolsString = self sharedPoolsString.! !

MDAdaptorTest subclass: #MDSqueakClassCommentAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:39'!
adaptorClass
	^ MDSqueakClassCommentAdaptor! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/12/2005 14:57'!
assertObjectHasDefaultProperties
	self assert: self bogusClass comment = self text.
	self assert: self bogusClass organization commentStamp = self stamp.! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:51'!
changedValue
	^ 'A different comment for MDBogusA.'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:27'!
createObject
	self bogusClass classComment: self text stamp: self stamp
! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 15:00'!
destroyObject
	self bogusClass organization classComment: nil stamp: nil! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:20'!
element
	^ MDClassCommentElement className: self bogusClass name! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/12/2005 14:59'!
objectIsPresent
	^ self bogusClass hasComment! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:36'!
properties
	^ MDPropertyDictionary new
		at: #text put: self text;
		at: #author put: self author;
		at: #timeStamp put: self timeStamp;
		yourself! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/12/2005 14:45'!
propertyToChange
	^ #text! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:18'!
stamp
	^ 'abc 11/29/2004 01:44' ! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 20:54'!
testTextAsString
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: (properties text isKindOf: String)! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:26'!
text
	^ 'A comment for MDBogusA'! !

!MDSqueakClassCommentAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^MDClassCommentElement className: #MDNonExistentClass! !

MDAdaptorTest subclass: #MDSqueakClassVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakClassVarAdaptor! !

!MDSqueakClassVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:04'!
assertObjectHasDefaultProperties
	self assert: self objectIsPresent! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
classVarName
	^ 'Beta'! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 13:31'!
createObject
	self bogusClass addClassVarName: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeClassVarName: self classVarName]! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:46'!
element
	^ MDClassVarElement 
		className: self bogusClass name 
		name: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:04'!
objectIsPresent
	^self bogusClass classVarNames includes: self classVarName! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 13:32'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:46'!
propertyToChange
	"Class variables have no properties and thus can never by out of date."

	^ nil 
	! !

!MDSqueakClassVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:01'!
unloadableElement
	^ MDClassVarElement className: #MDNonExistentClass name: #Foo! !

MDAdaptorTest subclass: #MDSqueakInstVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDSqueakInstVarAdaptorTest subclass: #MDSqueakClassInstVarAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/4/2005 15:05'!
adaptor
	^ MDSqueakClassInstVarAdaptor forElement: self element! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'accessing' stamp: 'cwp 3/4/2005 14:54'!
bogusClass
	^ super bogusClass class! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/4/2005 15:13'!
element
	^ MDClassInstVarElement 
		className: self bogusClass theNonMetaClass name 
		name: self instVarName! !

!MDSqueakClassInstVarAdaptorTest methodsFor: 'constants' stamp: 'cwp 3/4/2005 14:54'!
instVarName
	^ 'beth'! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
adaptorClass
	^ MDSqueakInstVarAdaptor! !

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:56'!
assertObjectHasDefaultProperties
	self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:24'!
createObject
	self bogusClass addInstVarName: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 14:07'!
denyObjectIsPresent
	self deny: self objectIsPresent! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
destroyObject
	self objectIsPresent 
		ifTrue: [self bogusClass removeInstVarName: self instVarName]! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:26'!
element
	^ MDInstVarElement 
		className: self bogusClass name 
		name: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constants' stamp: 'cwp 2/6/2005 12:21'!
instVarName
	^'two'! !

!MDSqueakInstVarAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:05'!
objectIsPresent
	^self bogusClass instVarNames includes: self instVarName! !

!MDSqueakInstVarAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 13:06'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:48'!
propertyToChange
	"An instance variable has no properties, thus it is always up-to-date"

	^ nil! !

!MDSqueakInstVarAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:02'!
unloadableElement
	^ MDInstVarElement 
		className: #MDNonExistentClass
		name: self instVarName! !

MDAdaptorTest subclass: #MDSqueakMetadataAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakMetadataAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/22/2005 23:40'!
adaptor
	^ MDSqueakMetadataAdaptor forElement: self element! !

!MDSqueakMetadataAdaptorTest methodsFor: 'asserting' stamp: 'cwp 3/23/2005 00:16'!
assertObjectHasDefaultProperties
	self assert: (MDSqueakMetadataAdaptor atElement: self element) 
					branch = self properties branch! !

!MDSqueakMetadataAdaptorTest methodsFor: 'accessing' stamp: 'cwp 3/23/2005 00:03'!
canBeUnloadable
	^ false! !

!MDSqueakMetadataAdaptorTest methodsFor: 'accessing' stamp: 'cwp 3/22/2005 23:47'!
changedValue
	^ 'experimental'! !

!MDSqueakMetadataAdaptorTest methodsFor: 'image access' stamp: 'cwp 3/22/2005 23:33'!
createObject
	MDSqueakMetadataAdaptor
		atElement: self element
		putProperties: self properties! !

!MDSqueakMetadataAdaptorTest methodsFor: 'image access' stamp: 'cwp 3/22/2005 23:33'!
destroyObject
	MDSqueakMetadataAdaptor removeElement: self element! !

!MDSqueakMetadataAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/22/2005 23:34'!
element
	^ MDMetadataElement forSlice: (MDExplicitSlice named: 'TestSlice')! !

!MDSqueakMetadataAdaptorTest methodsFor: 'image access' stamp: 'cwp 3/22/2005 23:37'!
objectIsPresent
	^ MDSqueakMetadataAdaptor elementIsPresent: self element! !

!MDSqueakMetadataAdaptorTest methodsFor: 'accessing' stamp: 'cwp 3/23/2005 00:00'!
properties
	^ MDPropertyDictionary new
		versionNumber: 1;
		branch: 'trunk';
		yourself! !

!MDSqueakMetadataAdaptorTest methodsFor: 'accessing' stamp: 'cwp 3/22/2005 23:47'!
propertyToChange
	^ #branch! !

!MDSqueakMetadataAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 22:28'!
testMergeBranch
	| first second |
	first _ MDPropertyDictionary new branch: #foo; versionNumber: 2; yourself.
	second _ MDPropertyDictionary new branch: #bar; versionNumber: 3; yourself.
	self adaptor merge: second into: first onFailure: [^ self].
	self signalFailure: 'Branches should not be automatically merged'! !

!MDSqueakMetadataAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 22:26'!
testMergeNewer
	| first second |
	first _ MDPropertyDictionary new branch: #foo; versionNumber: 2; yourself.
	second _ MDPropertyDictionary new branch: #foo; versionNumber: 3; yourself.
	self adaptor merge: second into: first onFailure: [self assert: false].
	self assert: second versionNumber = 3.! !

!MDSqueakMetadataAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 22:26'!
testMergeOlder
	| first second |
	first _ MDPropertyDictionary new branch: #foo; versionNumber: 2; yourself.
	second _ MDPropertyDictionary new branch: #foo; versionNumber: 3; yourself.
	self adaptor merge: first into: second onFailure: [self assert: false].
	self assert: second versionNumber = 3.! !

!MDSqueakMetadataAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 00:12'!
testVersionNumberAdvancement
	| adaptor properties |
	adaptor _ self adaptor.
	properties _ self properties.
	adaptor load: properties.
	self deny: (adaptor isUpToDate: properties).
	adaptor update: properties.
	self assert: properties versionNumber = 2.! !

MDAdaptorTest subclass: #MDSqueakMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDSqueakMethodAdaptorTest subclass: #MDSqueakClassMethodAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakClassMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:14'!
bogusClass
	^ super bogusClass class! !

!MDSqueakClassMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:21'!
element
	^ MDMethodElement 
		className: super bogusClass name
		selector: self theSelector
		classIsMeta: true! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:00'!
adaptorClass
	^ MDSqueakMethodAdaptor! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 8/20/2005 19:10'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass includesSelector: self theSelector).
	self assert: (self bogusClass organization categoryOfElement: self theSelector) = self category.
	self assert: (self bogusClass sourceCodeAt: self theSelector) = self source.
	self assert: (self bogusClass compiledMethodAt: self theSelector) timeStamp = self stamp.! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:24'!
category
	^ #temporary! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 15:06'!
changedValue
	^ #temp! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 11:52'!
createObject
	self bogusClass
		compile: self source
		classified: self category
		withStamp: self stamp
		notifying: nil
		logSource: true! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 12:15'!
destroyObject
	self bogusClass removeSelector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 12:16'!
element
	^ MDMethodElement className: self bogusClass name selector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'configuration' stamp: 'avi 3/14/2005 18:28'!
hasOptimizedUpToDate
	^ true! !

!MDSqueakMethodAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 14:07'!
objectIsPresent
	^self bogusClass includesSelector: self theSelector! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:39'!
properties
	^ MDPropertyDictionary new
		author: self author;
		category: self category;
		source: self source;
		timeStamp: self timeStamp;
		yourself! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	^ #category! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/5/2005 17:23'!
source
	^ 'method1
	^ 1'! !

!MDSqueakMethodAdaptorTest methodsFor: 'properties' stamp: 'cwp 8/20/2005 19:09'!
stamp
	^ 'abc 11/29/2004 14:44' ! !

!MDSqueakMethodAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 20:43'!
testSourceAsString
	| properties |
	self createObject.
	properties := MDPropertyDictionary new.
	self adaptor update: properties.
	self assert: (properties source isKindOf: String)! !

!MDSqueakMethodAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 12:14'!
theSelector
	^#method1! !

!MDSqueakMethodAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 15:58'!
unloadableElement
	^ MDMethodElement className: #MDNonExistentClass selector: #foo! !

MDAdaptorTest subclass: #MDSqueakPoolImportAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:04'!
adaptorClass
	^ MDSqueakPoolImportAdaptor! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'asserting' stamp: 'cwp 2/6/2005 23:45'!
assertObjectHasDefaultProperties
	self assert: (self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName])! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 22:56'!
createObject
	self bogusClass addSharedPool: self pool! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:09'!
destroyObject
	self bogusClass sharedPools remove: self pool ifAbsent: []! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/6/2005 23:30'!
element
	^ MDPoolImportElement className: self bogusClass name poolName: self poolName! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'image access' stamp: 'cwp 2/6/2005 23:46'!
objectIsPresent
	^ self bogusClass sharedPools anySatisfy: [:ea | ea name = self poolName]! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:57'!
pool
	^ Smalltalk at: self poolName! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'accessing' stamp: 'cwp 2/6/2005 22:59'!
poolName
	^ #MDBogusPoolB! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/6/2005 23:37'!
properties
	^ MDPropertyDictionary new! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'properties' stamp: 'cwp 2/12/2005 14:49'!
propertyToChange
	"A pool import has no properties and is thus always up-to-date."
	^ nil! !

!MDSqueakPoolImportAdaptorTest methodsFor: 'constructing' stamp: 'cwp 2/15/2005 16:06'!
unloadableElement
	^ MDPoolImportElement className: #MDNonExistentClass poolName: #Foo! !

TestCase subclass: #MDByteIndexTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDByteIndexTest methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2005 04:01'!
storeAndRetrieveWithFileSize: aNumber
	|  file stream |
	stream _ RWBinaryOrTextStream on: ByteArray new.
	stream next: aNumber put: 0.
	stream reset.
 
	file _ MDByteIndex stream: stream keySize: 2 valueSize: 4.
	file at: 'aa' asByteArray put: 'abcd' asByteArray.
	file at: 'ab' asByteArray put: 'qxry' asByteArray.
	file at: 'xy' asByteArray put: '1234' asByteArray.
	self assert: file tally = 3.

	self assert: (file at: 'aa' asByteArray) = 'abcd' asByteArray.
	self assert: (file at: 'ab' asByteArray) = 'qxry' asByteArray.
	self assert: (file at: 'xy' asByteArray) = '1234' asByteArray.
	file at: 'ab' asByteArray put: '9876' asByteArray.
	self assert: (file at: 'ab' asByteArray) = '9876' asByteArray.
	self assert: file tally = 3! !

!MDByteIndexTest methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2005 03:58'!
testStoreAndRetrieve
	self storeAndRetrieveWithFileSize: 100.
	self storeAndRetrieveWithFileSize: 24.
	self should: [self storeAndRetrieveWithFileSize: 12] raise: Error! !

TestCase subclass: #MDHashstampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 4/18/2005 13:47'!
testCreation
	| hashstamp |
	hashstamp _ MDHashstamp hashIn: [:stream | stream nextPutAll: 'abc' asByteArray].
	self assert: hashstamp digest digitLength = 20.
	self assert: (MDTimestamp now asInteger - hashstamp timestamp asInteger) < 5.! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 05:02'!
testEqual
	| first second now |
	now _ MDTimestamp now.
	first _ MDHashstamp forObject: 'abc' timestamp: now.
	second _ MDHashstamp forObject: 'abc' timestamp: now.
	self assert: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 20:40'!
testHash
	| first second |
	first _ MDHashstamp hashIn: [:stream | stream nextPutAll: 'abc' asByteArray].
	second _ MDHashstamp hashIn: [:stream | stream nextPutAll: 'bcd' asByteArray].
	self deny: first hash = second hash.
	self deny: first = second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:44'!
testLessThan
	| first second |
	first _ MDHashstamp fromString: 'bjrm0RTKT7KesZu0C1N9d0Dv+-Fez-No'.
	second _ MDHashstamp fromString: 'c0qD0lTwM3oFdWJn9yYiSxGZjuhr9NHe'.
	self assert: first <= second! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 9/13/2005 09:02'!
testPrinting
	| hashstamp |
	hashstamp _ MDHashstamp 
					forObject: 'abc'
					timestamp: (MDTimestamp fromInteger: 30000).
	self assert: hashstamp printString = '++-pA51gCqIOiGslmLJhdpOyQLbyBCg+'! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 20:41'!
testRead
	| hashstamp |
	hashstamp _ MDHashstamp hashIn: [:stream | stream nextPutAll: 'abc' asByteArray].
	self assert: hashstamp = (MDHashstamp fromString: hashstamp asString)
! !

!MDHashstampTest methodsFor: 'tests' stamp: 'cwp 4/18/2005 13:47'!
testTimestamp
	| first second now then |
	now _ MDTimestamp now.
	then _ MDTimestamp fromInteger: (now asInteger - 1).
	first _ MDHashstamp forObject: 'abc' timestamp: then.
	second _ MDHashstamp forObject: 'abc' timestamp: now.
	self assert: first digest = second digest.
	self deny: first = second! !

TestCase subclass: #MDKeyedStreamTest
	instanceVariableNames: 'dataStream baseStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:24'!
append: aSmallInteger
	dataStream 
		appendKey: (self key: aSmallInteger)
		value: (self value: aSmallInteger).
! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:19'!
assert: bytes is: aSmallInteger
	self assert: bytes last = aSmallInteger! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:02'!
bytes: count containing: aSmallInteger
	| key |
	key _ ByteArray new: count.
	key at: key size put: aSmallInteger.
	^ key! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:02'!
key: aSmallInteger
	^ self bytes: dataStream keySize containing: aSmallInteger! !

!MDKeyedStreamTest methodsFor: 'running' stamp: 'avi 4/17/2005 01:19'!
setUp
	baseStream := RWBinaryOrTextStream on: (ByteArray new: 100).
	dataStream := MDKeyedStream on: baseStream! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 16:11'!
testAppend
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p |
		self assert: k is: 1.
		self assert: v is: 1.
		self assert: p >= 0]! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 16:18'!
testKeysValuePositions
	| index position |
	1 to: 3 do: [:i | self append: i].
	index _ 1.
	position _ -1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p |
		self assert: k is: index.
		self assert: v is: index.
		self assert: p > position.
		position _ p.
		index _ index + 1]! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'avi 4/17/2005 01:39'!
testPosition
	| position |
	position _ dataStream nextValuePosition.
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p | self assert: p = position].
! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 17:17'!
testValueAtPosition
	| position |
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p | position _ p].
	self assert: (dataStream valueAtPosition: position) is: 1! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:07'!
value: aSmallInteger
	^ self bytes: dataStream keySize * 2 containing: aSmallInteger! !

TestCase subclass: #MDPackageInfoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDPackageInfoTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2005 16:14'!
testExensionMethods
	| info |
	info _ MDVwExportInfo new.
	self deny: info extensionMethods isEmpty! !

!MDPackageInfoTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2005 16:20'!
testSqueakClasses
	| info classes |
	info _ Monticello2Info new.
	classes _ info classes.
	self assert: (classes includes: MDVwExportInfo).
	self assert: (classes includes: MDVwExporter).
	self assert: (classes includes: Monticello2Info).! !

!MDPackageInfoTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/19/2005 16:19'!
testVwClasses
	| info classes |
	info _ MDVwExportInfo new.
	classes _ info classes.
	self deny: (classes includes: MDVwExportInfo).
	self deny: (classes includes: MDVwExporter).
	self deny: (classes includes: Monticello2Info)! !

TestCase subclass: #MDPropertyDictionaryTest
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:28'!
setUp
	properties _ MDPropertyDictionary new.! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:32'!
testGetNil
	self assert: (properties at: #undefined) isNil! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:29'!
testImplicitGet
	properties at: #one put: 1.
	self assert: properties one = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:28'!
testImplicitPut
	properties one: 1.
	self assert: (properties at: #one) = 1! !

!MDPropertyDictionaryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 20:30'!
testPutNil
	properties at: #undefined put: nil.
	self assert: properties isEmpty! !

TestCase subclass: #MDRepositoryTest
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDRepositoryTest subclass: #MDFileRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 04:28'!
newRepository
	^ MDFileRepository named: self testFileName! !

!MDFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'avi 4/17/2005 01:40'!
tearDown
	FileDirectory default deleteFileNamed: self testFileName! !

!MDFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'avi 4/19/2005 01:35'!
testConcurrentAppend
	| version repository2 get |
	repository2 _ self newRepository.
	version _ self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version.
	get _ repository2 get: version hashstamp.
	self assert: get notNil.
	self assert: get isEquivalentTo: version.
! !

!MDFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'avi 3/14/2005 12:48'!
testFileName
	^ 'test-file-repository'! !

!MDFileRepositoryTest methodsFor: 'as yet unclassified' stamp: 'avi 4/17/2005 01:41'!
testReopen
	| version |
	version _ self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version.
	repository _ self newRepository.
	self assert: (repository get: version hashstamp) isEquivalentTo: version.
! !

MDRepositoryTest subclass: #MDMemoryRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 02:39'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	^ anElementVersion == otherElementVersion! !

!MDMemoryRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:46'!
newRepository
	^ MDMemoryRepository new! !

MDRepositoryTest subclass: #MDPostgresRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDPostgresRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2005 21:07'!
newRepository
	^ MDPostgresRepository connectionArgs: MDMockPgConnection! !

!MDPostgresRepositoryTest methodsFor: 'as yet unclassified' stamp: 'avi 6/20/2005 13:14'!
tearDown
	repository ensureConnection execute: 'DELETE FROM versions'.
	repository close! !

!MDRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2005 00:46'!
isAbstract
	^ self name = #MDRepositoryTest! !

!MDRepositoryTest methodsFor: 'asserting' stamp: 'avi 3/12/2005 02:39'!
assert: anElementVersion isEquivalentTo: otherElementVersion
	^ (MDMarshal serialize: anElementVersion) = (MDMarshal serialize: otherElementVersion)! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:45'!
newRepository
	self subclassResponsibility! !

!MDRepositoryTest methodsFor: 'running' stamp: 'cwp 3/13/2005 00:23'!
setUp
	repository _ self newRepository! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'cwp 3/23/2005 22:53'!
snapshot
	^ MDSnapshot withVersions: (Set with: self version)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'avi 4/17/2005 02:19'!
testSnapshotHashstamps
	| version snapshot snapshotStamps |
	version _ self version.
	snapshot _ self snapshot.

	repository put: version; put: snapshot.

	snapshotStamps _  Array streamContents:
						[:s | repository snapshotHashstampsDo: [:ea | s nextPut: ea]].

	self assert: (snapshotStamps includes: snapshot hashstamp).
	self deny: (snapshotStamps includes: version hashstamp)! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 3/13/2005 00:24'!
testStoreSnapshot
	| snapshot |
	snapshot _ self snapshot.
	repository put: snapshot.
	self assert: (repository get: snapshot hashstamp) isEquivalentTo: snapshot! !

!MDRepositoryTest methodsFor: 'tests' stamp: 'cwp 3/13/2005 00:24'!
testStoreVersion
	| version |
	version _ self version.
	repository put: version.
	self assert: (repository get: version hashstamp) isEquivalentTo: version! !

!MDRepositoryTest methodsFor: 'constructing' stamp: 'avi 3/12/2005 00:45'!
version
	^ MDElementVersion 
		snapshot: (MDElementDefinition 
					forElement: (MDFakeElement 
									named: #Alpha))! !

MDRepositoryTest subclass: #MDStoreTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDStoreTest methodsFor: 'construction' stamp: 'cwp 3/13/2005 00:33'!
newRepository
	^ MDStore new
		addRepository: MDMemoryRepository new;
		addRepository: MDMemoryRepository new;
		yourself! !

!MDStoreTest methodsFor: 'tests' stamp: 'cwp 3/12/2005 22:56'!
testSingleton
	self assert: MDStore default == MDStore default! !

TestCase subclass: #MDSlicePanelTest
	instanceVariableNames: 'model root status messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSlicePanelTest methodsFor: 'running' stamp: 'cwp 9/4/2005 00:48'!
listItems
	^ self listWidget list asSet collect: [:ea | ea asString].! !

!MDSlicePanelTest methodsFor: 'running' stamp: 'cwp 8/24/2005 21:31'!
listWidget
	^ root widgetNamed: 'slices'! !

!MDSlicePanelTest methodsFor: 'callbacks' stamp: 'cwp 9/4/2005 00:31'!
name
	^ 'Gamma'! !

!MDSlicePanelTest methodsFor: 'callbacks' stamp: 'cwp 8/29/2005 21:40'!
save
	messages add: #save! !

!MDSlicePanelTest methodsFor: 'running' stamp: 'cwp 9/4/2005 00:42'!
setUp
	status := MDSliceStatus forSlice: self of: MDWorkingCopy new.
	model _ MDSlicePanel new
		addStatus: (self statusFor: 'Alpha');
		addStatus: (self statusFor: 'Beta');
		addStatus: status;
		yourself.

	root _ SUnitToolBuilder new build: model.
	messages _ OrderedCollection new.! !

!MDSlicePanelTest methodsFor: 'running' stamp: 'cwp 8/24/2005 22:32'!
statusFor: aString
	^ MDSliceStatus
		forSlice: (MDExplicitSlice named: aString)
		of: MDWorkingCopy new.! !

!MDSlicePanelTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:48'!
testList

	self assert: self listItems = #('  Alpha' '  Beta' '  Gamma') asSet.! !

!MDSlicePanelTest methodsFor: 'tests' stamp: 'cwp 8/24/2005 21:32'!
testListSelection
	
	self listWidget clickItemAt: 1.
	self assert: self listWidget selectedIndex = 1.
	! !

!MDSlicePanelTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:33'!
testSaveAction
	
	self listWidget clickItemAt: 3.
	self listWidget menu click: 'save'.
	self assert: messages first = #save.
! !

!MDSlicePanelTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:48'!
testSaveMenuItem
	
	status beDirty.
	model changed: #sliceList.
	self assert: self listItems = #('  Alpha' '  Beta' '* Gamma') asSet.

	self listWidget clickItemAt: 3.
	self listWidget menu click: 'save'.
	self assert: messages first = #save.
	
	self assert: self listItems = #('  Alpha' '  Beta' '  Gamma') asSet.

! !

TestCase subclass: #MDSliceStatusTest
	instanceVariableNames: 'status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceStatusTest methodsFor: 'support' stamp: 'cwp 8/26/2005 18:39'!
inClass
	^MDFakeClass basedOn: MDBogusA! !

!MDSliceStatusTest methodsFor: 'support' stamp: 'cwp 8/26/2005 18:41'!
outClass
	^MDFakeClass basedOn: self class! !

!MDSliceStatusTest methodsFor: 'running' stamp: 'cwp 8/25/2005 20:32'!
setUp
	status := MDSliceStatus
				forSlice: self slice
				of: self! !

!MDSliceStatusTest methodsFor: 'support' stamp: 'cwp 9/5/2005 20:27'!
slice
	| inClassName outClassName |
	inClassName := self inClass name.
	outClassName := self class name.
	^(MDExplicitSlice named: 'Alpha')
		addElement: (MDClassElement className: inClassName);
		addElement: (MDClassCommentElement className: outClassName);
		addElement: (MDMethodElement className: outClassName selector: #method1);
		addElement: (MDMethodElement className: outClassName selector: #a classIsMeta: true);
		addElement: (MDInstVarElement className: outClassName name: 'two');
		addElement: (MDClassVarElement className: outClassName name: 'Beta');
		addElement: (MDClassInstVarElement className: outClassName name: 'bet');
		addElement: (MDPoolImportElement className: outClassName name: #MDBogusPoolB);
		yourself! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/24/2005 23:17'!
testCleanNoStar
	status beDirty.
	status beClean.
	self assert: status displayString = '  Alpha'! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/24/2005 23:17'!
testDefaultsClean
	self assert: status displayString = '  Alpha'! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/24/2005 23:15'!
testDirtyStar
	status beDirty.
	self assert: status displayString = '* Alpha'! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testInClass
	| event |
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: MDBogusA
				to: MDBogusA.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testInClassInstVar
	| event copy original |
	original := self outClass theMetaClass.
	copy := original copy.
	copy addInstVarName: 'bet'.
	status beClean.
	event := ModifiedEvent classDefinitionChangedFrom: original to: copy.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 20:10'!
testInClassMethod
	| event |
	status beClean.
	event := ModifiedEvent
				methodChangedFrom: nil
				to: nil
				selector: #a 
				inClass: self class class.
	status methodModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testInClassVar
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addClassVarName: 'Beta'.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/5/2005 20:30'!
testInComment
	| event |
	status beClean.
	event := CommentedEvent class: self outClass.
	status classCommented: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testInInstVar
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addInstVarName: 'two'.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 20:09'!
testInMethod
	| event |
	status beClean.
	event := ModifiedEvent
				methodChangedFrom: nil
				to: nil
				selector: #method1 
				inClass: MDSliceStatusTest.
	status methodModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testInPoolImport
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addSharedPool: MDBogusPoolB.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self assert: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testOutClass
	| event |
	status beClean.
	event := ModifiedClassDefinitionEvent 
				classDefinitionChangedFrom: self outClass
				to: self outClass.
	status classModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testOutClassInstVar
	| event copy original |
	original := self outClass theMetaClass.
	copy := original copy.
	copy addInstVarName: 'gimmel'.
	status beClean.
	event := ModifiedEvent classDefinitionChangedFrom: original to: copy.
	status classModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 20:11'!
testOutClassMethod
	| event |
	status beClean.
	event := ModifiedEvent 
				methodChangedFrom: nil
				to: nil
				selector: #doesntExist
				inClass: self inClass class.
	status methodModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testOutClassVar
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addClassVarName: 'Gamma'.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/5/2005 20:31'!
testOutComment
	| event |
	status beClean.
	event := CommentedEvent class: self inClass.
	status classCommented: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:40'!
testOutInstVar
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addInstVarName: 'three'.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 8/26/2005 21:42'!
testOutMethod
	| event |
	status beClean.
	event := ModifiedEvent 
				methodChangedFrom: nil
				to: nil
				selector: #doesntExist
				inClass: self inClass.
	status methodModified: event.
	self deny: status isDirty! !

!MDSliceStatusTest methodsFor: 'tests' stamp: 'cwp 9/4/2005 00:41'!
testOutPoolImport
	| event copy original |
	original := self outClass.
	copy := original copy.
	copy addSharedPool: MDBogusPoolA.
	status beClean.
	event := ModifiedClassDefinitionEvent classDefinitionChangedFrom: original
				to: copy.
	status classModified: event.
	self deny: status isDirty! !

TestCase subclass: #MDSliceTest
	instanceVariableNames: 'slice elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceTest commentStamp: 'cwp 8/29/2005 00:40' prior: 0!
This comment needs to be here, or #testComment won't pass.!

MDSliceTest subclass: #MDExplicitSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDExplicitSliceTest methodsFor: 'constucting' stamp: 'cwp 8/29/2005 01:02'!
createSlice
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (MDClassElement className: #MDBogusA);
		addElement: (MDClassElement className: #MDSliceTest);
		addElement: (MDClassCommentElement className: #MDSliceTest);
		addElement: (MDMethodElement className: #MDSliceTest selector: #classes);
		addElement: (MDMethodElement className: #MDSliceTest selector: #methods);
		addElement: (MDMethodElement className: #MDSliceTest selector: #bogusMethodA classIsMeta: true);
		addElement: (MDMethodElement className: #MDSliceTest selector: #bogusMethodB classIsMeta: true);
		addElement: (MDInstVarElement className: #MDBogusA name: 'one');
		addElement: (MDClassVarElement className: #MDBogusA name: 'Alpha');
		addElement: (MDClassInstVarElement className: #MDBogusA name: 'aleph');
		addElement: (MDPoolImportElement className: #MDBogusA poolName: 'MDBogusPoolA');
		yourself! !

MDSliceTest subclass: #MDPackageSliceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDPackageSliceTest commentStamp: 'cwp 3/3/2005 02:10' prior: 0!
This comment needs to be here, or #testComment won't pass.!

!MDPackageSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 02:14'!
bogusMethodA
	"This method needs to be here for #testClassMethods to pass"! !

!MDPackageSliceTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/3/2005 02:14'!
bogusMethodB
	"This method needs to be here for #testClassMethods to pass"! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 00:33'!
classes
	^ Array with: MDBogusA with: MDSliceTest! !

!MDPackageSliceTest methodsFor: 'constructing' stamp: 'cwp 3/16/2005 00:59'!
createSlice
	^MDPackageSlice forPackage: self! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 01:13'!
includesClassNamed: aSymbol
	^ self classes anySatisfy: [:ea | ea name = aSymbol]! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 01:30'!
includesMethodReference: aMethodReference 
	^ self methods includes: aMethodReference! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 8/29/2005 00:43'!
methods
	^ Array
		with: (MethodReference class: MDSliceTest selector: #classes)
		with: (MethodReference class: MDSliceTest selector: #methods)
		with: (MethodReference class: MDSliceTest class selector: #bogusMethodA)
		with: (MethodReference class: MDSliceTest class selector: #bogusMethodB)
! !

!MDPackageSliceTest methodsFor: 'package info' stamp: 'cwp 3/16/2005 01:09'!
packageName
	^ 'TestPackage'! !

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
isAbstract
	^ self name = #MDSliceTest! !

!MDSliceTest class methodsFor: 'testing' stamp: 'cwp 3/16/2005 01:05'!
shouldInheritSelectors
	^ true! !

!MDSliceTest methodsFor: 'asserting' stamp: 'cwp 8/29/2005 01:04'!
assertAll: labels includedAs: aBlock 
	| expected |
	expected := labels collect: aBlock.
	expected do: [:ea | self assert: (slice includes: ea)].
! !

!MDSliceTest methodsFor: 'running' stamp: 'cwp 3/16/2005 01:02'!
setUp
	slice := self createSlice.! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 00:32'!
testClasses
	self
		assertAll: #(MDBogusA MDSliceTest)
		includedAs: [:name | MDClassElement className: name].
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 00:22'!
testClassInstVar
	self 
		assertAll: #('aleph')
		includedAs: [:name | MDClassInstVarElement 
								className: #MDBogusA 
								name: name]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 00:32'!
testClassMethod
	self 
		assertAll: #(bogusMethodA bogusMethodB)
		includedAs: [:sel | MDMethodElement 
							className: #MDSliceTest 
							selector: sel
							classIsMeta: true]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 00:22'!
testClassVar
	self 
		assertAll: #('Alpha')
		includedAs: [:name | MDClassVarElement 
							className: #MDBogusA 
							name: name]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 00:32'!
testComment
	self assert: (slice elements 
				includes: (MDClassCommentElement className: #MDSliceTest))! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 00:23'!
testInstVar
	self 
		assertAll: #('one')
		includedAs: [:name | MDInstVarElement 
								className: #MDBogusA 
								name: name]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 3/22/2005 22:50'!
testLog
	self assert: (slice elements anySatisfy: [:ea | ea isKindOf: MDLogElement])! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 00:32'!
testMethods
	self 
		assertAll: #(classes methods)
		includedAs: [:sel | MDMethodElement 
							className: #MDSliceTest 
							selector: sel]. 
		
! !

!MDSliceTest methodsFor: 'tests' stamp: 'cwp 8/29/2005 00:23'!
testPoolImport
	self 
		assertAll: #('MDBogusPoolA')
		includedAs: [:name | MDPoolImportElement 
							className: #MDBogusA 
							poolName: name]. 
		
! !

TestCase subclass: #MDSqueakLogAdaptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSqueakLogAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/15/2005 23:21'!
adaptor
	^ MDSqueakLogAdaptor forElement: self element! !

!MDSqueakLogAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/22/2005 22:50'!
element
	^ MDLogElement forSlice: self slice! !

!MDSqueakLogAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/15/2005 23:23'!
properties
	^ MDPropertyDictionary new
		author: 'abc';
		comment: 'Fixed some bugs';
		yourself! !

!MDSqueakLogAdaptorTest methodsFor: 'constructing' stamp: 'cwp 3/15/2005 23:21'!
slice
	^ MDExplicitSlice named: 'TestSlice'! !

!MDSqueakLogAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/15/2005 23:47'!
testDefaultUpdate
	| properties savedInitials |
	properties _ MDPropertyDictionary new.
	savedInitials _ Utilities authorInitials.
	[Utilities setAuthorInitials: 'abc'.
	self adaptor update: properties]
		ensure: [Utilities setAuthorInitials: savedInitials].

	self assert: properties author = 'abc'.
! !

!MDSqueakLogAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/15/2005 23:23'!
testIsLoadable
	self assert: (self adaptor isLoadable: self properties)! !

!MDSqueakLogAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/15/2005 23:23'!
testIsUpToDate
	self deny: (self adaptor isUpToDate: self properties)! !

!MDSqueakLogAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/15/2005 23:24'!
testLoad
	self 
		shouldnt: [self adaptor load: self properties]
		raise: Error! !

!MDSqueakLogAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/23/2005 22:07'!
testMerge
	| other result |
	other _ MDPropertyDictionary new author: 'def'; comment: 'No comment'; yourself.
	result _ self adaptor merge: self properties into: other onFailure: [nil].
	self deny: result isNil.
	self assert: result isEmpty! !

!MDSqueakLogAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/15/2005 23:25'!
testRemove
	self
		shouldnt: [self adaptor remove]
		raise: Error! !

!MDSqueakLogAdaptorTest methodsFor: 'tests' stamp: 'cwp 3/15/2005 23:35'!
testUpdate
	| properties |
	properties _ MDPropertyDictionary new.
	[self adaptor update: properties]
		on: MDLogMessageRequest
		do: [:ex | 
			ex properties author: 'def'; comment: 'comment'.
			ex resume].
	self assert: properties author = 'def'.
	self assert: properties comment = 'comment'! !

TestCase subclass: #MDTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDTestCase subclass: #MDAncestryTest
	instanceVariableNames: 'parent child'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 23:15'!
null
	^ MDNullVersion forElement: self element! !

!MDAncestryTest methodsFor: 'running' stamp: 'cwp 3/2/2005 22:46'!
setUp
	parent := self version.
	child := self 
				updateVersion: parent
				property: #foo
				put: 'alpha2'! !

!MDAncestryTest methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:55'!
sibling
	^self 
		updateVersion: parent
		property: #bar
		put: 'bar'! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildConflictsWithParent
	self deny: (child conflictsWith: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testChildConflictsWithSibling
	self assert: (child conflictsWith: self sibling)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildPrecedesParent
	self deny: (child precedes: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:17'!
testChildPreceedsNull
	self deny: (child precedes: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testChildSucceedsNull
	self assert: (child succeeds: self null)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:47'!
testChildSucceedsParent
	self assert: (child succeeds: parent)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testChildSuccessorNull
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testChildSuccessorParent
	self assert: (child successor: parent onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 15:20'!
testChildSuccessorSibling
	| result merged sibling |
	sibling := self sibling.
	merged := child successor: sibling
				onConflict: 
					[result := self definition.
					result properties at: #merged put: true.
					result].
	self assert: (merged succeeds: child).
	self assert: (merged succeeds: sibling).
	self assert: merged snapshot properties merged! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:14'!
testNullPrecedesChild
	self assert: (self null precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:16'!
testNullSucceedsChild
	self deny: (self null succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:18'!
testNullSuccessorChild
	self assert: (child successor: self null onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:46'!
testParentConflictsWithChild
	self deny: (parent conflictsWith: child).! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentPrecedesChild
	self assert: (parent precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:48'!
testParentSucceedsChild
	self deny: (parent succeeds: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:19'!
testParentSuccessorChild
	self assert: (parent successor: child onConflict: [:p | self fail]) == child! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:15'!
testSiblingConflictsWithChild
	self assert: (self sibling conflictsWith: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:59'!
testSiblingPreceedsChild
	self deny: (self sibling precedes: child)! !

!MDAncestryTest methodsFor: 'tests' stamp: 'cwp 3/3/2005 00:00'!
testSiblingSucceedsChild
	self deny: (self sibling succeeds: child)! !

MDTestCase subclass: #MDProxyTest
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDProxyTest subclass: #MDImageProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 18:52'!
testCurrentDefinition
	| snap |
	self atElement: self element property: #one put: 1.
	snap := self definition.
	proxy updateSnapshot: snap.
	self assert: (snap properties at: #one) = 1
! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 19:36'!
testIsLoadable
	| snap |
	snap _ self definition.
	snap properties at: #one put: 1.
	self assert: (proxy isLoadable: snap)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:38'!
testLoadAndUpdate
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	
	retrieved _ proxy updateSnapshot: self definition.
	self assert: original properties = retrieved properties! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:39'!
testLoadAndUpdateRemoval
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	retrieved _ proxy updateSnapshot: self removal.
	self assert: retrieved properties = original properties! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:43'!
testLoadDefinition
	| snap |
	snap _ self definition.
	snap properties 
			at: #one put: 1;
			at: #two put: 2;
			at: #three put: 3.
	proxy loadSnapshot: snap.
	self assert: (self atElement: self element property: #one) = 1.
	self assert: (self atElement: self element property: #two) = 2.
	self assert: (self atElement: self element property: #three) = 3.! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:44'!
testLoadRemoveAndUpdate
	| original retrieved |
	original _ self definition.
	original properties 
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	proxy loadSnapshot: original.
	proxy loadSnapshot: self removal.
	retrieved _ proxy updateSnapshot: self definition.
	self assert: retrieved element = self element.
	self assert: retrieved isRemoval! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/13/2005 19:50'!
testNotLoadable
	| snap |
	snap _ self definition: #'Alpha/Delta'.
	snap properties at: #one put: 1.
	self deny: (proxy isLoadable: snap)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:40'!
testRemoval
	| snap |
	self atElement: self element property: #one put: '1'.
	snap _ self removal.
	proxy loadSnapshot: snap.
	self assert: (self atElement: self element property: #one) isNil! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testRemovalLoadable
	| snap |
	snap _ self removal: #'Alpha/Delta'.
	self assert: (proxy isLoadable: snap)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:41'!
testRemovalUpToDate
	| snap removal |
	snap _ self definition.
	removal _ self removal.
	snap properties one: '1'.
	proxy loadSnapshot: snap.
	self deny: (proxy isUpToDate: removal).
	proxy loadSnapshot: removal.
	self assert: (proxy isUpToDate: removal)! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:47'!
testUpdateDoesntChangeElement
	| snap original |
	snap := self definition.
	original := snap element.
	proxy updateSnapshot: snap.
	self assert: snap element = original! !

!MDImageProxyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 19:47'!
testUpToDate
	| snap |
	snap _ self definition.
	snap properties source: 'one ^ 1'.
	proxy loadSnapshot: snap.
	self assert: (proxy isUpToDate: snap).
	self atElement: self element property: #source put: 'one ^ 11'.
	self deny: (proxy isUpToDate: snap).! !

MDProxyTest subclass: #MDMergeTest
	instanceVariableNames: 'wc merge local remote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMergeTest methodsFor: 'running' stamp: 'cwp 3/25/2005 22:26'!
local: localVersion remote: remoteVersion
	local := localVersion.
	wc loadVersion: local.
	remote := remoteVersion.
	merge := MDMerge toInclude: remote in: wc.
! !

!MDMergeTest methodsFor: 'running' stamp: 'cwp 3/25/2005 21:44'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:43'!
testApply
	self 
		local: (self versionWith: 'local')
		remote: (self versionWith: 'remote').
	merge chooseRemote.
	merge apply.
	self assertElementHasValue: 'remote'! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:05'!
testChooseLocal
	self local: self version remote: self version.
	self assert: merge isConflict.
	merge chooseLocal.
	self assert: merge isLocal.
	self assert: merge resolution == local! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:06'!
testChooseRemote
	self local: self version remote: self version.
	self assert: merge isConflict.
	merge chooseRemote.
	self assert: merge isRemote.
	self assert: merge resolution == remote! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:07'!
testIsConflict
	self local: self version remote: self version.
	self assert: merge isConflict.
	self deny: merge isRemote.
	self deny: merge isLocal.
! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:46'!
testIsLocal
	remote _ self version.
	local _ self updateVersion: remote property: #one put: 'alpha2'.
	self local: local remote: remote.
	self assert: merge isLocal.
	self deny: merge isRemote.
	self deny: merge isConflict.! !

!MDMergeTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:46'!
testIsRemote
	local _ self version.
	remote _ self updateVersion: local property: #one put: 'alpha2'.
	self local: local remote: remote.
	self assert: merge isRemote.
	self deny: merge isLocal.
	self deny: merge isConflict.
! !

MDProxyTest subclass: #MDMergeToolTest
	instanceVariableNames: 'wc model widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 6/3/2005 08:29'!
assertIsBold: aTextOrString 
	self assert: (self isBold: aTextOrString)! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 6/15/2005 08:20'!
assertTextWidgetIsImmutable: aWidget 
	| expected actual |
	expected := aWidget text.
	aWidget accept: 'some text'.
	actual := aWidget text.
	self assert: actual = expected! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 5/30/2005 23:20'!
assertWidgetNamed: name hasText: contents
	^ self assertWidgetNamed: name hasText: contents forElement: 'Alpha'! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 5/30/2005 23:19'!
assertWidgetNamed: name hasText: contents forElement: element
	| text |
	(self widgetNamed: 'elements') click: element.
	text _ (self widgetNamed: name) text.
	self assert: text = contents! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 4/25/2005 03:21'!
buildAlpha
	| alpha |
	alpha := self versionFor: #Alpha with: #alphaRemote.
	wc loadVersion: (self 
				updateVersion: alpha
				property: #one
				put: #alphaLocal).
	^alpha! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 4/25/2005 03:24'!
buildBeta
	| beta element |
	element := self element: #Beta.
	self 
		atElement: element
		property: #one
		put: #betaLocal.
	beta := wc versionForElement: element.
	^self 
		updateVersion: beta
		property: #one
		put: #betaRemote! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 4/25/2005 03:23'!
buildGamma
	| gamma |
	self 
		atElement: (self element: #Gamma)
		property: #one
		put: #gammaLocal.
	gamma := self versionFor: #Gamma with: #gammaRemote.
	^gamma! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 6/3/2005 08:29'!
denyIsBold: aTextOrString 
	self deny: (self isBold: aTextOrString)! !

!MDMergeToolTest methodsFor: 'asserting' stamp: 'cwp 6/3/2005 08:29'!
isBold: aTextOrString 
	^(aTextOrString asText emphasisAt: 1) = 1! !

!MDMergeToolTest methodsFor: 'accessing' stamp: 'cwp 8/6/2005 20:29'!
mergeForListItem: item 
	^model merges detect: [:merge | merge displayString = item asString]! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 4/25/2005 03:23'!
merges
	| alpha beta gamma |
	alpha := self buildAlpha.
	beta := self buildBeta.
	gamma := self buildGamma.
	^Array 
		with: (MDMerge toInclude: alpha in: wc)
		with: (MDMerge toInclude: beta in: wc)
		with: (MDMerge toInclude: gamma in: wc)! !

!MDMergeToolTest methodsFor: 'running' stamp: 'cwp 4/25/2005 03:28'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.
	model _ MDMergeTool on: self merges.
	widget _ SUnitToolBuilder new build: model.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:10'!
testAlphaMenuItems
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Alpha'.
	self deny: (list menu labels includes: 'choose local').
	self assert: (list menu labels includes: 'choose remote').
! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:11'!
testBetaMenuItems
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Beta'.
	self assert: (list menu labels includes: 'choose local').
	self deny: (list menu labels includes: 'choose remote').
! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:01'!
testChooseLocal
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Gamma'.
	list menu click: 'choose local'.
	self denyIsBold: (list list detect: [:ea | ea asString = 'Gamma']).
	self assert: (self widgetNamed: 'resolved') text = 'gammaLocal'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/9/2005 09:00'!
testChooseRemote
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Gamma'.
	list menu click: 'choose remote'.
	self denyIsBold: (list list detect: [:ea | ea asString = 'Gamma']).
	self assert: (self widgetNamed: 'resolved') text = 'gammaRemote'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/30/2005 23:21'!
testConflictResolvedText
	self 
		assertWidgetNamed: 'resolved' 
		hasText: '-- unresolved conflict --' 
		forElement: 'Gamma'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/3/2005 08:25'!
testConflictsBold
	| list |
	list := (self widgetNamed: 'elements') list.
	list do: 	[:item | 
			(self mergeForListItem: item) isConflict 
				ifTrue: [self assertIsBold: item]]! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/3/2005 08:35'!
testConflictsFirst
	| list count |
	count := (self merges select: [:ea | ea isConflict]) size.
	list := (self widgetNamed: 'elements') list.
	(list first: count) do: [:ea | self assertIsBold: ea].
	(list last: list size - count) do: [:ea | self denyIsBold: ea]! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:12'!
testGammaMenuItems
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Gamma'.
	self assert: (list menu labels includes: 'choose local').
	self assert: (list menu labels includes: 'choose remote').
! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 8/6/2005 20:35'!
testList
	| list |
	list := (self widgetNamed: 'elements') list.
	list := list asSet collect: [:ea | ea asString].
	self assert: list = #('Alpha' 'Beta' 'Gamma') asSet.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/27/2005 08:22'!
testListSelection
	widget := self widgetNamed: 'elements'.
	widget clickItemAt: 1.
	self assert: widget selectedIndex = 1.
	! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/30/2005 23:21'!
testLocalResolvedText
	self assertWidgetNamed: 'resolved' hasText: 'alphaLocal'.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/24/2005 08:13'!
testLocalText
	self assertWidgetNamed: 'local' hasText: 'alphaLocal'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/15/2005 08:21'!
testLocalTextIsImmutable
	(self widgetNamed: 'elements') click: 'Alpha'.
	self assertTextWidgetIsImmutable: (self widgetNamed: 'local')! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 17:13'!
testMenuNoSelection
	| list |
	list _ self widgetNamed: 'elements'.
	self assert: list menu labels = #('merge resolved') asSet.
	! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 20:20'!
testMergeAll
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Gamma'.
	list menu click: 'choose local'.
	list menu click: 'merge resolved'.
	self assert: list list isEmpty.
	self assert: (self widgetNamed: 'local') text isEmpty.
	self assert: (self widgetNamed: 'remote') text isEmpty.
	self assert: (self widgetNamed: 'resolved') text isEmpty.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/19/2005 16:34'!
testMergeResolved
	| list |
	list _ self widgetNamed: 'elements'.
	list menu click: 'merge resolved'.
	self assert: list list = #('Gamma')
! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/30/2005 23:22'!
testRemoteResolvedText
	self assertWidgetNamed: 'resolved' hasText: 'betaRemote' forElement: 'Beta'! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/24/2005 08:14'!
testRemoteText
	self assertWidgetNamed: 'remote' hasText: 'alphaRemote'.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/15/2005 08:21'!
testRemoteTextIsImmutable
	(self widgetNamed: 'elements') click: 'Alpha'.
	self assertTextWidgetIsImmutable: (self widgetNamed: 'remote')! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 5/24/2005 08:15'!
testResolvedText
	self assertWidgetNamed: 'resolved' hasText: 'alphaLocal'.! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/15/2005 08:25'!
testResolvedTextIsImmutable
	"This is just temporary. Eventually this should be editable."

	(self widgetNamed: 'elements') click: 'Alpha'.
	self assertTextWidgetIsImmutable: (self widgetNamed: 'resolved')! !

!MDMergeToolTest methodsFor: 'tests' stamp: 'cwp 6/9/2005 08:58'!
testSwitchResolution
	| list |
	list _ self widgetNamed: 'elements'.
	list click: 'Beta'.
	list menu click: 'choose local'.
	self assert: (self widgetNamed: 'resolved') text = 'betaLocal'! !

!MDMergeToolTest methodsFor: 'accessing' stamp: 'cwp 4/25/2005 03:57'!
widgetNamed: aString
	^ widget widgetNamed: aString! !

!MDProxyTest class methodsFor: 'testing' stamp: 'abc 2/13/2005 12:37'!
isAbstract
	^ self name = #MDProxyTest! !

!MDProxyTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:52'!
assertElementHasDefaultValue: aSymbol
	self assertElement: aSymbol property: #one hasValue: aSymbol asLowercase! !

!MDProxyTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:46'!
assertElementHasValue: value
	self assert: (self atElement: self element property: #one) = value! !

!MDProxyTest methodsFor: 'asserting' stamp: 'cwp 3/25/2005 22:37'!
assertElement: elem property: prop hasValue: value
	self assert: (self atElement: (self element: elem) property: prop) = value! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/27/2005 20:58'!
atElement: element property: property
	^ (proxy at: element) at: property ifAbsent: [nil]! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/4/2005 23:54'!
atElement: element property: property put: value
	"This will need to be overriden in tests that use a real image proxy."
	
	(proxy at: element) at: property put: value! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:16'!
atProperty: aSymbol
	^ self atElement: self element property: aSymbol! !

!MDProxyTest methodsFor: 'proxy access' stamp: 'cwp 2/5/2005 20:17'!
atProperty: aSymbol put: aValue
	self atElement: self element property: aSymbol put: aValue
! !

!MDProxyTest methodsFor: 'configuration' stamp: 'cwp 2/4/2005 23:58'!
proxyClass
	^ MDFakeImageProxy! !

!MDProxyTest methodsFor: 'running' stamp: 'avi 11/29/2004 12:49'!
setUp
	proxy _ self proxyClass new! !

MDProxyTest subclass: #MDSliceOpsTest
	instanceVariableNames: 'wc repository snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:26'!
addToBoth: aVersion
	snapshot add: aVersion.
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToRepository: aVersion
	repository add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:25'!
addToSnapshot: aVersion
	snapshot add: aVersion! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:28'!
prepare
	self prepare: 
		[self addToBoth: (self versionFor: #Alpha with: 'alpha').
		self addToBoth: (self versionFor: #Beta with: 'beta')].
! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/23/2005 22:58'!
prepare: aBlock
	| repositoryVersions |
	repository _ Set new.
	snapshot _ Set new.
	aBlock value.
	repositoryVersions _ repository.
	repository _ MDMemoryRepository new.
	repositoryVersions do: [:ea | repository put: ea].
	snapshot _ MDSnapshot withVersions: snapshot
	
	! !

!MDSliceOpsTest methodsFor: 'running' stamp: 'cwp 3/10/2005 23:26'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.
! !

!MDSliceOpsTest methodsFor: 'constructing' stamp: 'cwp 3/16/2005 00:24'!
slice
	^ (MDExplicitSlice named: 'TestSlice')
		addElement: (self element: #Alpha);
		addElement: (self element: #Beta);
		yourself
	! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/14/2005 22:26'!
testAsExplicitSlice
	| original copy |
	original _ self slice.
	copy _ original asExplicitSlice.
	self assert: (copy isKindOf: MDExplicitSlice).
	self assert: copy elements = original elements! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:48'!
testIncludeSnapshot
	self prepare.
	[self slice include: snapshot from: repository in: wc]
		on: MDMergeRequest
		do: [:ex | ex merges do: [:ea | ea apply]].
			
	self assertElementHasDefaultValue: #Alpha.
	self assertElementHasDefaultValue: #Beta.! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:49'!
testLoadEqualSnapshot
	self prepare.
	self slice load: snapshot from: repository to: wc.
	self assertElementHasDefaultValue: #Alpha.
	self assertElementHasDefaultValue: #Beta.
! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:50'!
testLoadLargerSnapshot
	| slice alpha beta |
	self prepare.
	alpha _ self element: #Alpha.
	beta _ self element: #Beta.
	slice _ MDExplicitSlice named: 'TestSlice'.
	slice addElement: alpha.
	slice load: snapshot from: repository to: wc.
	self assert: (self atElement: alpha property: #one) = 'alpha'.
	self assert: (self atElement: beta property: #one) = 'beta'.
	self assert: slice elements size = 2! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:52'!
testLoadSmallerSnapshot
	self prepare: [self addToBoth: (self versionFor: #Alpha with: 'alpha')].
	self slice load: snapshot from: repository to: wc.
	self assertElementHasDefaultValue: #Alpha.
	self assertElement: #Beta property: #one hasValue: nil
! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:55'!
testLoadWithDepenencies
	self prepare:
		[self addToBoth: (self versionFor: #Alpha).
		self addToBoth: (self versionFor: #Beta).
		self addToBoth: (self versionFor: #'Alpha/Delta' with: 'ad')].

	self slice load: snapshot from: repository to: wc.
	self
		assertElementHasDefaultValue: #Alpha;
		assertElementHasDefaultValue: #Beta;
		assertElement: #'Alpha/Delta' property: #one hasValue: 'ad'.! !

!MDSliceOpsTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:35'!
testSnapshot
	| slice versions |
	self prepare: [].
	slice _ self slice.
	snapshot _ slice saveFrom: wc to: repository.
	versions _ snapshot getVersionsFrom: repository.
	slice do: 
		[:element |
		self assert: (versions anySatisfy: [:version | version element = element])].
	self deny: (repository get: snapshot hashstamp) isNil! !

MDProxyTest subclass: #MDWorkingCopyTest
	instanceVariableNames: 'wc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDWorkingCopyTest methodsFor: 'asserting' stamp: 'cwp 3/2/2005 23:49'!
assertConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | ^ self].
	self assert: false! !

!MDWorkingCopyTest methodsFor: 'asserting' stamp: 'cwp 3/2/2005 23:49'!
assertNoConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | self assert: false. ^self]! !

!MDWorkingCopyTest methodsFor: 'running' stamp: 'avi 11/29/2004 12:52'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:58'!
testIncludeAbsentVersion
	| version |
	version _ self version.
	version snapshot properties one: 'bar'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #one) = 'bar'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:12'!
testIncludeConflictingVersion
	| version newVersion newVersion2 |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	newVersion2 _ self updateVersion: version property: #source put: 'three'.
	wc loadVersion: newVersion.
	self assertConflictIncluding: newVersion2! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testIncludeNewVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	self assertNoConflictIncluding: newVersion.
	self assert: (self atProperty: #source) = 'two'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:16'!
testIncludeOldVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	self assertNoConflictIncluding: version.
	self assert: (self atProperty: #source) = 'two'.
! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:59'!
testLoad
	| version |
	version _ self version.
	version snapshot properties one: '1'.
	wc loadVersion: version.
	self assert: (self atProperty: #one) = '1'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:59'!
testLoadAndSave
	| version |
	version _ self version.
	version snapshot properties one: '1'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:40'!
testLoadDeleteAndSave
	| version newVersion |
	version := self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	proxy removeKey: version element.
	newVersion := wc versionForElement: version element.
	wc loadVersion: newVersion.
	self deny: (proxy includesKey: version element)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/28/2005 21:45'!
testLoadModifyAndSave
	| version newVersion |
	version := self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion := wc versionForElement: version element.
	self deny: newVersion == version.
	self assert: (newVersion succeeds: version)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 22:25'!
testLoadModifySaveAndSave
	| version newVersion newVersion2 |
	version := self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version.
	self atProperty: #source put: 'two'.
	newVersion := wc versionForElement: version element.
	newVersion2 := wc versionForElement: version element.
	self assert: newVersion == newVersion2! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:17'!
testLoadOldVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	wc loadVersion: newVersion.
	self assert: (self atProperty: #source) = 'two'.
	wc loadVersion: version.
	self assert: (self atProperty: #source) = 'one'.
! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 2/5/2005 20:18'!
testModifyAndIncludeConflictingVersion
	| version newVersion |
	version _ self version.
	version snapshot properties source: 'one'.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: 'two'.
	self atProperty: #source put: 'three'.
	self assertConflictIncluding: newVersion! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/2/2005 23:51'!
testResolveConflict
	| version newVersion newVersion2 mergedVersion |
	version := self version.
	version snapshot properties source: 'one'.
	newVersion := self 
				updateVersion: version
				property: #source
				put: 'two'.
	newVersion2 := self 
				updateVersion: version
				property: #source
				put: 'three'.
	wc loadVersion: newVersion.
	wc 
		includeVersion: newVersion2 
		onConflict: [:a :b | 
					self assert: a snapshot properties source = 'two'.
					b snapshot].
	self assert: (self atProperty: #source) = 'three'.
	mergedVersion := wc versionForElement: version element.
	self assert: mergedVersion snapshot = newVersion2 snapshot.
	self assert: (mergedVersion succeeds: newVersion).
	self assert: (mergedVersion succeeds: newVersion2)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 22:59'!
testSaveAbsentVersion
	| saved constructed |
	saved := wc versionForElement: self element.
	constructed := self versionFor: #Alpha.
	self assert: saved ancestry isEmpty.
	self assert: (constructed succeeds: saved)! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 23:00'!
testSaveFirstVersion
	| version |
	self atElement: self element property: #one put: 'one'.
	version _ wc versionForElement: self element.
	self assert: version ancestry isEmpty.
	self assert: version snapshot properties one = 'one'! !

!MDWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 15:30'!
testSingleton
	self assert: MDWorkingCopy default == MDWorkingCopy default! !

MDTestCase subclass: #MDSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/4/2005 17:39'!
assertEqualityOf: anObject
	^ self assertEqualityOf: anObject using: [:before :after | self assert: after = before]! !

!MDSerializationTest methodsFor: 'asserting' stamp: 'cwp 3/8/2005 00:22'!
assertEqualityOf: anObject using: aBlock 
	| other buffer |
	buffer := MDMarshal serialize: anObject.
	other := MDMarshal materialize: buffer.
	aBlock value: anObject value: other! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:20'!
testClassCommentElement
	self assertEqualityOf: (MDClassCommentElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:20'!
testClassElement
	self assertEqualityOf: (MDClassElement className: #MDBogusA)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:22'!
testClassInstVarElement
	self assertEqualityOf: (MDClassInstVarElement className: #MDBogusA name: 'beth')! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/9/2005 21:45'!
testClassMethodElement
	self assertEqualityOf: (MDMethodElement 
							className: #MDBogusA 
							selector: #one 
							classIsMeta: true)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:21'!
testClassVarElement
	self assertEqualityOf: (MDClassVarElement className: #MDBogusA name: 'Alpha')! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 17:21'!
testElementDefinition
	self assertEqualityOf: self definition! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 17:04'!
testElementRemoval
	self assertEqualityOf: self removal.! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 15:35'!
testFakeElement
	self assertEqualityOf: self element! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/25/2005 20:41'!
testHashstamp
	self assertEqualityOf: (MDHashstamp hashIn: [:stream | stream nextPutAll: 'abc' asByteArray])! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:21'!
testInstVarElement
	self assertEqualityOf: (MDInstVarElement className: #MDBogusA name: 'one')! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/22/2005 23:53'!
testLogElement
	self assertEqualityOf: (MDLogElement forSlice: (MDExplicitSlice named: 'TestSlice'))! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:45'!
testLongString
	| string |
	string _ String new: 300.
	string atAllPut: $a.
	self assertEqualityOf: string! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/22/2005 23:54'!
testMetadataElement
	self assertEqualityOf: (MDMetadataElement forSlice: (MDExplicitSlice named: 'TestSlice'))! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:23'!
testMethodElement
	self assertEqualityOf: (MDMethodElement className: #MDBogusA selector: #one)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 8/9/2005 20:59'!
testMultiString
	self assertEqualityOf: (WideString fromString: 'abc').! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:27'!
testOneByteInteger
	self assertEqualityOf: 7! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:26'!
testPoolImportElement
	self assertEqualityOf: (MDPoolImportElement className: #MDBogusA poolName: #MDBogusPoolA)! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:58'!
testPropertyDictionary
	| properties |
	properties _ MDPropertyDictionary new.
	properties
		first: 1;
		second: 'two'.
	self assertEqualityOf: properties! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/10/2005 23:41'!
testSnapshot
	self assertEqualityOf: self snapshot ! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/4/2005 17:22'!
testString
	self assertEqualityOf: 'abc'.! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 17:15'!
testSymbol
	self assertEqualityOf: #one using: [:before :after | self assert: before == after]! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 05:26'!
testTimestamp
	| ts buffer |
	ts _ MDTimestamp now.
	buffer _ MDMarshal serialize: ts.
	self assert: buffer size = 5.
	self assert: (MDMarshal materialize: buffer) = ts! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 16:44'!
testTwoByteInteger
	self assertEqualityOf: 355! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/11/2005 21:34'!
testUnrecognizedClass
	self
		should: [MDMarshal serialize: 'abc' asText]
		raise: Error! !

!MDSerializationTest methodsFor: 'tests' stamp: 'cwp 3/7/2005 18:04'!
testVersion
	self 
		assertEqualityOf: self version 
		using: [:before :after |
				self assert: before snapshot = after snapshot.
				self assert: before hashstamp = after hashstamp.
				self assert: before ancestry = after ancestry]! !

!MDTestCase class methodsFor: 'as yet unclassified' stamp: 'cwp 3/2/2005 22:35'!
isAbstract
	^ self name = #MDTestCase! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:32'!
definition
	^ MDElementDefinition forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:30'!
definition: aSymbol
	| definition |
	definition _ MDElementDefinition forElement: (self element: aSymbol).
	definition properties at: #one put: 1.
	^ definition! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element
	^ self element: #Alpha! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
elements
	^ Set
		with: (MDFakeElement named: #Alpha)
		with: (MDFakeElement named: #Beta)! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
element: aSymbol
	^ MDFakeElement named: aSymbol! !

!MDTestCase methodsFor: 'asserting' stamp: 'cwp 3/2/2005 22:51'!
fail
	self signalFailure: 'Assertion failed'! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:32'!
removal
	^ MDElementRemoval forElement: self element! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:32'!
removal: aSymbol
	^ MDElementRemoval forElement: (self element: aSymbol)! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/10/2005 23:09'!
snapshot
	^ self snapshot: [:versions | ].
! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/23/2005 22:59'!
snapshot: aBlock
	| versions |
	versions _ Set new.	
	versions 
		add: (self versionFor: #Alpha with: 'alpha');
		add: (self versionFor: #Beta with: 'beta')	.
	aBlock value: versions.
	^ MDSnapshot withVersions: versions! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:31'!
updateVersion: anElementVersion property: aSymbol put: anObject
	| newSnapshot |
	newSnapshot _ anElementVersion snapshot copy.
	newSnapshot properties at: aSymbol put: anObject.
	^ MDElementVersion
		snapshot: newSnapshot
		ancestry: anElementVersion fullAncestry! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/2/2005 22:32'!
version
	^ MDElementVersion snapshot: self definition! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:55'!
versionFor: elementName
	^ self versionFor: elementName with: elementName asLowercase! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:50'!
versionFor: elementName with: value
	| element snapshot |
	element _ MDFakeElement named: elementName.
	snapshot _ MDElementDefinition forElement: element.
	snapshot properties at: #one put: value.
	^ MDElementVersion snapshot: snapshot! !

!MDTestCase methodsFor: 'constructing' stamp: 'cwp 3/25/2005 22:57'!
versionWith: value
	| snapshot |
	snapshot _ MDElementDefinition forElement: self element.
	snapshot properties at: #one put: value.
	^ MDElementVersion snapshot: snapshot! !

TestCase subclass: #MDTimestampPrinterTest
	instanceVariableNames: 'ts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/9/2005 02:50'!
assert: format prints: expected
	| actual |
	actual _ ts printFormat: format.
	self assert: expected = actual! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2005 19:23'!
testNativePrintOn
	ts _ MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 3
			minute: 2
			second: 1.
	self assert: '%e %B %Y %i:%M:%S %p' prints: '4 May 2006 3:02:01 am'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2005 19:29'!
testSqueakMethodStampAm
	ts _ MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 1
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 01:02'! !

!MDTimestampPrinterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2005 19:29'!
testSqueakMethodStampPm
	ts _ MDTimestamp
			year: 2006
			month: 5
			day: 4
			hour: 15
			minute: 2
			second: 1.
	self assert: '%l/%e/%Y %H:%M' prints: '5/4/2006 15:02'! !

TestCase subclass: #MDTimestampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 9/11/2005 18:22'!
intWithBytes: anArray
	| int |
	int _ 0.
	1 to: 4 do: [:i | int _ (int bitShift: 8) + (anArray at: i)].
	^ int! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 4/7/2005 22:26'!
recompose: units
	| int |
	int _ MDTimestamp compose: units.
	^ (MDTimestamp fromInteger: int) decompose! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:24'!
testAsInteger
	| int ts |
	int _ self intWithBytes: #(1 2 3 4).
	ts _ MDTimestamp fromInteger: int.
	self assert: ts asInteger = int.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:24'!
testByteOrder
	| ts |
	ts _ self tsWithBytes: #(1 2 3 4).
	self assert: (ts byteAt: 1) = 1.
	self assert: (ts byteAt: 2) = 2.
	self assert: (ts byteAt: 3) = 3.
	self assert: (ts byteAt: 4) = 4.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/24/2005 23:00'!
testComposition1
	| units |
	units _ #(1 2 3 4 5 6 7).
	self assert: (self recompose: units) = units! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/7/2005 22:55'!
testComposition2
	| before after |
	before _ #(7 3 5 4 3 2 1).
	after _ self recompose: before.
	self assert: before = after! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/16/2005 16:50'!
testDays
	self assert: (self ts: #(2001 02 23 00 00 00)) day = 23.
	self assert: (self ts: #(2001 02 23 00 00 01)) day = 23.
	self assert: (self ts: #(2001 02 23 23 59 59)) day = 23.
	self assert: (self ts: #(2005 02 23 12 00 00)) day = 23.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 01:38'!
testEndOfEpoch
	self 
	should: [MDTimestamp fromInteger: MDTimestamp last asInteger + 1]
	raise: Error! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 05:09'!
testEpoch
	| ts |
	ts _ MDTimestamp epoch.
	self assert: ts byteSize <= 4.
	self assert: ts asInteger = 0! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 04:54'!
testEquality
	| left right |
	left _ MDTimestamp now.
	right _ left copy.
	self deny: left == right.
	self assert: left = right.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/7/2005 23:35'!
testFromSqueakMethodStamp
	| ts |
	ts _ MDTimestamp fromSqueakMethodStamp: 'cwp 4/7/2005 01:30'.
	self assert: ts printString = '7 April 2005 1:30:00 am'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour01
	self assert: (self ts: #(2001 02 23 00 00 00)) hour = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour02
	self assert: (self ts: #(2001 02 23 01 00 01)) hour = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testHour03
	self assert: (self ts: #(2001 02 23 23 59 59)) hour = 23.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:20'!
testHour04
	self assert: (self ts: #(2005 04 07 01 30 00)) hour = 1.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 23:02'!
testLeapYear
	| ts |
	ts := self ts: #(2004 02 29 01 00 00).
	self assert: ts day = 29.
	self assert: ts month = 2! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:28'!
testMagnitude01
	| a b |
	a _ self tsWithBytes: #(1 2 3 4).
	b _ self tsWithBytes: #(1 2 3 5).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:29'!
testMagnitude02
	| a b |
	a _ self tsWithBytes: #(1 2 3 4).
	b _ self tsWithBytes: #(1 2 3 4).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:29'!
testMagnitude03
	| a b |
	a _ self tsWithBytes: #(1 2 3 4).
	b _ self tsWithBytes: #(1 2 3 3).
	self deny: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/11/2005 18:31'!
testMagnitude04
	| a b |
	a _ self tsWithBytes: #(1 2 3 4).
	b _ self tsWithBytes: #(1 2 4 4).
	self assert: a < b! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute01
	self assert: (self ts: #(2001 02 23 00 00 00)) minute = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute02
	self assert: (self ts: #(2001 02 23 01 01 01)) minute = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:19'!
testMinute03
	self assert: (self ts: #(2001 02 23 23 59 59)) minute = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 01:21'!
testMonths
	| base increment ts |
	base _  24969600. 			"Value of Dec 15, the year of the epoch"
	increment _ 86400 * 30.		"Number of seconds in 30 days"
	
	"Start at Jan 15, and add 30 days at a time, to test each month."
	1 to: 12 do: 
		[:i | 
		ts _ MDTimestamp fromInteger: i * increment + base.
		self assert: ts month = i]! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/5/2005 21:49'!
testNow
	| ts |
	ts _ MDTimestamp now.
	self assert: ts size <= 4.
	self assert: ts asInteger positive! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting1
	| ts |
	ts := self ts: #(2000 03 01 00 00 00).
	self assert: ts printString = '1 March 2000 12:00:00 am'.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting2
	| ts |
	ts := self ts: #(2005 04 07 23 28 31).
	self assert: ts printString = '7 April 2005 11:28:31 pm'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 6/18/2005 16:04'!
testPrinting3
	| ts |
	ts := self ts: #(2005 04 07 03 28 31).
	self assert: ts printString = '7 April 2005 3:28:31 am'! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 4/9/2005 01:48'!
testRange
	| begin end |
	begin _ MDTimestamp epoch.
	end _ MDTimestamp last.
	self assert: MDTimestamp range = (end asInteger - begin asInteger)! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond01
	self assert: (self ts: #(2001 02 23 00 00 00)) second = 0.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond02
	self assert: (self ts: #(2001 02 23 01 01 01)) second = 1.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 9/10/2005 23:18'!
testSecond03
	self assert: (self ts: #(2001 02 23 23 59 59)) second = 59.! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear01
	self assert: (self ts: #(1984 02 28 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear02
	self assert: (self ts: #(1984 02 29 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear03
	self assert: (self ts: #(1984 03 01 00 01 00)) year = 1984.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear04
	self assert: (self ts: #(2001 02 23 00 01 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:28'!
testYear05
	self assert: (self ts: #(2001 02 28 23 59 59)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear06
	self assert: (self ts: #(2001 03 01 00 00 00)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear07
	self assert: (self ts: #(2001 03 01 00 00 01)) year = 2001.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:29'!
testYear08
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:30'!
testYear09
	self assert: (self ts: #(2003 02 23 00 01 00)) year = 2003.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:38'!
testYear10
	self assert: (self ts: #(2004 02 23 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:33'!
testYear11
	self assert: (self ts: #(2004 02 29 00 01 00)) year = 2004.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear12
	self assert: (self ts: #(2004 04 29 00 01 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 21:34'!
testYear13
	self assert: (self ts: #(2005 02 23 00 01 00)) year = 2005.
	! !

!MDTimestampTest methodsFor: 'tests' stamp: 'cwp 8/20/2005 20:30'!
testYear14
	self assert: (self ts: #(2004 01 07 09 11 00)) year = 2004.
! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 9/11/2005 18:25'!
tsWithBytes: anArray
	^ MDTimestamp fromInteger: (self intWithBytes: anArray)! !

!MDTimestampTest methodsFor: 'support' stamp: 'cwp 6/18/2005 16:04'!
ts: anArray
	| parts |
	parts := Array new: 6.
	parts atAllPut: 0.
	anArray withIndexDo: [:ea :i | parts at: i put: ea].
	^ MDTimestamp
		year: (parts at: 1)
		month: (parts at: 2)
		day: (parts at: 3)
		hour: (parts at: 4)
		minute: (parts at: 5)
		second: (parts at: 6)! !

Magnitude variableByteSubclass: #MDHashstamp
	instanceVariableNames: ''
	classVariableNames: 'CharMap'
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDHashstamp class methodsFor: 'serializing' stamp: 'cwp 3/11/2005 23:30'!
decodeString: aString
	| write read a b c d |
	write _ (ByteArray new: 24) writeStream.
	read _ aString readStream.
	[read atEnd] whileFalse:
		[a _ (CharMap indexOf: read next) - 1.
		b _ (CharMap indexOf: read next) - 1.
		write nextPut: (a bitShift: 2) + (b bitShift: -4).
		b _ b bitAnd: 16rF.
		c _ (CharMap indexOf: read next) - 1.
		write nextPut: (b bitShift: 4) + (c bitShift: -2).
		c _ c bitAnd: 16r3.
		d _ (CharMap indexOf: read next) - 1.
		write nextPut: (c bitShift: 6) + d].
	^ write contents! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 05:02'!
forObject: anObject 
	^ self forObject: anObject timestamp: MDTimestamp now! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 3/25/2005 20:37'!
forObject: anObject timestamp: aTimestamp
	^ self 
		hashIn: [:stream | (MDMarshal on: stream) serialize: anObject]
		timestamp: aTimestamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 4/18/2005 13:48'!
fromBytes: aByteArray
	| hashstamp |
	aByteArray size = 24 ifFalse: [self error: 'Incorrect byte size'].
	hashstamp _ self new.
	1 to: 24 do: [:i | hashstamp byteAt: i put: (aByteArray at: i)].
	^ hashstamp! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'avi 3/14/2005 12:46'!
fromString: aString
	^ self fromBytes: (self decodeString: aString)! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 05:01'!
hashIn: aBlock
	^ self hashIn: aBlock timestamp: MDTimestamp now! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 3/25/2005 20:37'!
hashIn: aBlock timestamp: aTimestamp
	| sha stream |
	stream _ RWBinaryOrTextStream on: ByteArray new.
	aBlock value: stream.
	sha _ SecureHashAlgorithm new.
	^ self new setHash: (sha hashMessage: stream contents) timestamp: aTimestamp! !

!MDHashstamp class methodsFor: 'initialize-release' stamp: 'cwp 9/8/2005 07:39'!
initialize
	CharMap _ '+-0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.! !

!MDHashstamp class methodsFor: 'serializing' stamp: 'cwp 4/18/2005 13:42'!
materializeWith: aMarshal
	^ aMarshal readBytes: self new! !

!MDHashstamp class methodsFor: 'instance creation' stamp: 'cwp 4/18/2005 12:58'!
new
	^ self new: 24! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:17'!
byteAt: index
	^ self basicAt: index! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:41'!
byteAt: index put: value
	self basicAt: index put: value! !

!MDHashstamp methodsFor: 'bytes' stamp: 'cwp 4/18/2005 13:46'!
byteSize
	^ self basicSize! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 4/18/2005 13:08'!
bytes
	| bytes |
	bytes _ ByteArray new: self size.
	bytes replaceFrom: 1 to: self size with: self startingAt: 1.
	^ bytes! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 4/18/2005 13:47'!
digest
	| hash |
	hash _ LargePositiveInteger basicNew: 20.
	1 to: 20 do: [:i | hash digitAt: i put: (self at: i + 4)].
	^ hash! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 4/18/2005 13:35'!
hash
	^ByteArray
		hashBytes: self
		startingWith: self species hash! !

!MDHashstamp methodsFor: 'printing' stamp: 'cwp 3/10/2005 00:45'!
printFirst: first second: second third: third on: aStream
	| a b c d |
	a _ first bitShift: -2.
	b _ ((first bitShift: 4) bitOr: (second bitShift: -4)) bitAnd: 16r3F.
	c _ ((second bitShift: 2) bitOr: (third bitShift: -6)) bitAnd: 16r3F.
	d _ third bitAnd: 16r3F.
	
	aStream
		nextPut: (CharMap at: a+1);
		nextPut: (CharMap at: b+1);
		nextPut: (CharMap at: c+1);
		nextPut: (CharMap at: d+1)! !

!MDHashstamp methodsFor: 'printing' stamp: 'avi 3/14/2005 12:43'!
printOn: aStream
	| bytes |
	bytes _ self bytes.
	1 to: 24 by: 3 do: [:i | self 
							printFirst: (bytes at: i) 
							second: (bytes at: i+1)
							third: (bytes at: i+2)
							on: aStream].! !

!MDHashstamp methodsFor: 'private' stamp: 'cwp 4/18/2005 13:32'!
replaceFrom: start to: end with: bytes
	| offset |
	offset _ start - 1.
	1 to: (end - offset) do: [:i | self basicAt: offset + i put: (bytes basicAt: i)]! !

!MDHashstamp methodsFor: 'serializing' stamp: 'cwp 4/18/2005 13:44'!
serializeWith: aMarshal
	aMarshal writeBytes: self! !

!MDHashstamp methodsFor: 'initialize-release' stamp: 'cwp 4/18/2005 13:33'!
setHash: aLargeInteger timestamp: aTimestamp
	self replaceFrom: 1 to: 4 with: aTimestamp.
	self replaceFrom: 5 to: 24 with: (aLargeInteger withAtLeastNDigits: 20)! !

!MDHashstamp methodsFor: 'accessing' stamp: 'cwp 4/18/2005 13:15'!
timestamp
	^ MDTimestamp fromHashstamp: self! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 18:50'!
< other
	| selfByte otherByte |
	1 to: self byteSize do: 
		[:i | 
			selfByte _ self byteAt: i.
			otherByte _ other byteAt: i.
			(selfByte == otherByte) ifFalse: [^ selfByte < otherByte]].
	^ false! !

!MDHashstamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:56'!
= other
	self class = other class ifFalse: [^ false].
	1 to: self size do: [:i | (self at: i) = (other at: i) ifFalse: [^ false]].
	^ true! !

Magnitude variableByteSubclass: #MDTimestamp
	instanceVariableNames: ''
	classVariableNames: 'MDDay MDHour MDLeapCycle MDMinute MDMonths MDSecond MDYear'
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

MDTimestamp class
	instanceVariableNames: 'parts'!

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
compose: units
	| int accumulate |
	parts _ units readStream.
	accumulate _ [:ea | int _ parts next * ea + int].
	int _ 0.
	self highConstants do: accumulate.
	(MDMonths first: parts next) do: [:ea | int _ ea + int].
	self lowConstants do: accumulate.
	^ int! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 05:04'!
epoch
	^ self new! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:29'!
epochYear
	^ 1980! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 4/18/2005 13:17'!
fromHashstamp: hashstamp
	| inst |
	inst _ self new.
	1 to: 4 do: [:i | inst byteAt: i put: (hashstamp byteAt: i)].
	^ inst! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 9/10/2005 23:36'!
fromInteger: int	
	| ts |
	int > self range ifTrue: [self error: 'Timestamp out of range'].
	ts _ self new: 4.
	ts byteAt: 1 put: (int bitShift: -24).
	ts byteAt: 2 put: ((int bitShift: -16) bitAnd: 16rFF).
	ts byteAt: 3 put: ((int bitShift: -8) bitAnd: 16rFF).
	ts byteAt: 4 put: (int bitAnd: 16rFF).
	^ ts! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 6/18/2005 16:04'!
fromSqueakMethodStamp: aString
	| stream month day year hour minute |
	stream := ReadStream on: aString.
	[stream peek isDigit] whileFalse: [stream next].
	month := (stream upTo: $/) asNumber.
	day := (stream upTo: $/) asNumber.
	year := (stream upTo: Character space) asNumber.
	hour := (stream upTo: $:) asNumber.
	minute := (stream upTo: Character space) asNumber.
	stream atEnd ifFalse: [(stream next: 2) = 'pm' ifTrue: [hour := hour + 12]].
	^ self year: year month: month day: day hour: hour minute: minute second: 0! !

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:16'!
highConstants
	^ Array
		with: MDLeapCycle
		with: MDYear! !

!MDTimestamp class methodsFor: 'initializing' stamp: 'cwp 4/7/2005 22:50'!
initialize
	MDSecond _ 1.
	MDMinute _ 60 * MDSecond.
	MDHour _ 60 * MDMinute.
	MDDay _ 24 * MDHour.
	MDYear _ MDDay * 365.
	MDLeapCycle _ MDYear * 4 + MDDay.
	self initializeMonths.
	! !

!MDTimestamp class methodsFor: 'initializing' stamp: 'cwp 4/9/2005 04:14'!
initializeMonths
	MDMonths _ #(31 30 31 30 31 31 30 31 30 31 31) collect: [:ea | ea * MDDay].
! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:40'!
last
	^ self fromInteger: self range! !

!MDTimestamp class methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
lowConstants
	^ Array
		with: MDDay
		with: MDHour
		with: MDMinute
		with: MDSecond! !

!MDTimestamp class methodsFor: 'serialization' stamp: 'cwp 4/18/2005 13:41'!
materializeWith: aMarshal
	^ aMarshal readBytes: self new! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 4/9/2005 05:04'!
new
	^ self new: 4! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 6/18/2005 16:04'!
now
	| platform |
	platform := MDPlatform current.
	^ self fromInteger: platform secondClock + platform clockOffset.! !

!MDTimestamp class methodsFor: 'accessing' stamp: 'cwp 4/9/2005 01:43'!
range
	^ 3786825599! !

!MDTimestamp class methodsFor: 'instance creation' stamp: 'cwp 4/16/2005 17:03'!
year: aYear month: aMonth day: day hour: hour minute: minute second: second
	| year month units |
	aMonth < 3 
		ifTrue: [year _ aYear - self epochYear - 1. month _ aMonth + 10]
		ifFalse: [year _ aYear - self epochYear. month _ aMonth - 2].
	units _ Array new: 7.
	units at: 1 put: year // 4.
	units at: 2 put: year \\ 4.
	units at: 3 put: month - 1.
	units at: 4 put: day - 1.
	units at: 5 put: hour.
	units at: 6 put: minute.
	units at: 7 put: second.
	^ self fromInteger: (self compose: units)! !

!MDTimestamp methodsFor: 'converting' stamp: 'cwp 9/10/2005 23:30'!
asInteger
	| integer |
	integer := 0.
	1 to: self size do: [:i | integer := (integer bitShift: 8) + (self byteAt: i)].
	^ integer! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/5/2005 21:19'!
byteAt: index
	^ self basicAt: index! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/5/2005 21:20'!
byteAt: index put: byte
	^ self basicAt: index put: byte! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:59'!
byteSize
	^ self basicSize! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
day
	^ (self decompose at: 4) + 1! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/21/2005 02:21'!
decompose
	| results int reduce |
	results _ (Array new: 7) writeStream.
	int _ self asInteger.
	reduce _ [:unit | results nextPut: int // unit. int _ int \\ unit].
	reduce value: MDLeapCycle.
	int _ self reduceYearsIn: int on: results.
	int _ self reduceMonthsIn: int on: results.
	self lowConstants do: reduce.
	^ results contents! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/9/2005 01:14'!
epochYear
	^ self class epochYear! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 18:28'!
hash
	^ self asInteger hash! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/16/2005 16:17'!
highConstants
	^ self class highConstants! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
hour
	^ self decompose at: 5! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 4/16/2005 16:18'!
lowConstants
	^ self class lowConstants! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
minute
	^ self decompose at: 6! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:27'!
month
	^ self monthFrom: self decompose! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 6/18/2005 16:04'!
monthFrom: anArray
	^ (anArray at: 3) + 2 \\ 12 + 1! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 6/18/2005 16:04'!
printer
	| units |
	units := self decompose.
	^ MDTimestampPrinter
		year: (self yearFrom: units)
		month: (self monthFrom: units)
		day: (units at: 4) + 1
		hours: (units at: 5)
		minutes: (units at: 6)
		seconds: (units at: 7)! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/9/2005 02:55'!
printFormat: aString
	^ self printer printFormat: aString! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/9/2005 04:23'!
printOn: aStream
	self printer printOn: aStream format: '%e %B %Y %i:%M:%S %p' ! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 6/18/2005 16:04'!
reduceMonthsIn: anInteger on: aStream
	| months int |
	months := 0.
	int := anInteger.
	MDMonths do: [:ea | 
				int < ea
					ifTrue: [aStream nextPut: months. ^ int]
					ifFalse: [int := int - ea].
				months := months + 1].
	aStream nextPut: months.
	^ int! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/21/2005 02:37'!
reduceYearsIn: anInteger on: aStream
	| years |
	years := anInteger // MDYear min: 3.
	aStream nextPut: years.
	^ anInteger - (MDYear * years)! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 6/18/2005 16:04'!
second
	^ self decompose at: 6! !

!MDTimestamp methodsFor: 'printing' stamp: 'cwp 4/18/2005 13:45'!
serializeWith: aMarshal
	aMarshal writeBytes: self! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 8/9/2005 21:21'!
timestamp
	^ self! !

!MDTimestamp methodsFor: 'accessing' stamp: 'cwp 4/9/2005 04:29'!
year
	^ self yearFrom: self decompose! !

!MDTimestamp methodsFor: 'private' stamp: 'cwp 8/20/2005 21:48'!
yearFrom: anArray
	| years |
	years := anArray first * 4 + (anArray at: 2).
	years := years + self epochYear.
	^ (anArray at: 3) < 10 ifTrue: [years] ifFalse: [years + 1]! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:25'!
< other
	^ self asInteger < other asInteger! !

!MDTimestamp methodsFor: 'comparing' stamp: 'cwp 9/11/2005 17:25'!
= other
	self class == other class ifFalse: [^ false].
	self byteSize = other byteSize ifFalse: [^ false].
	^ self asInteger = other asInteger! !

!String class methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:56'!
materializeWith: aMarshal
	^ aMarshal readStringOfClass: self! !

!String methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:13'!
serializeWith: aMarshal
	aMarshal writeString: self! !

Dictionary subclass: #MDPropertyDictionary
	instanceVariableNames: 'localReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPropertyDictionary class methodsFor: 'serializing' stamp: 'cwp 3/9/2005 21:17'!
materializeWith: aMarshal
	^ aMarshal readDictionaryOfClass: self! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'cwp 4/3/2005 20:33'!
at: key
	^ self at: key ifAbsent: [nil]! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'cwp 4/3/2005 20:31'!
at: key put: anObject
	anObject ifNotNil: [super at: key put: anObject]! !

!MDPropertyDictionary methodsFor: 'convenience' stamp: 'cwp 4/3/2005 20:36'!
doesNotUnderstand: aMessage
	aMessage selector isUnary ifTrue: [^ self at: aMessage selector].
	(aMessage selector isKeyword
		and: [aMessage arguments size = 1])
			ifTrue: [^ self
						at: aMessage selector allButLast asSymbol
						put: aMessage arguments first].
	super doesNotUnderstand: aMessage.! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'avi 3/14/2005 18:08'!
localReference
	^ localReference! !

!MDPropertyDictionary methodsFor: 'accessing' stamp: 'avi 3/14/2005 18:08'!
localReference: anObject
	localReference _ anObject! !

!MDPropertyDictionary methodsFor: 'serializing' stamp: 'cwp 4/24/2005 22:59'!
serializeWith: aMarshal
	aMarshal writeDictionary: self! !

!Collection methodsFor: '*monticello2' stamp: 'cwp 8/26/2005 21:58'!
disjoin: aCollection
	^ (self union: aCollection) difference: (self intersection: aCollection)! !

!Integer methodsFor: '*monticello2' stamp: 'cwp 3/9/2005 20:14'!
serializeWith: aMarshal
	aMarshal writeSmallInteger: self! !

Notification subclass: #MDLogMessageRequest
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDLogMessageRequest class methodsFor: 'signalling' stamp: 'cwp 3/15/2005 23:41'!
update: aPropertyDictionary
	^ (self new properties: aPropertyDictionary) signal! !

!MDLogMessageRequest methodsFor: 'accessing' stamp: 'cwp 3/15/2005 23:44'!
defaultAction
	self properties author: Utilities authorInitials.
	self resume! !

!MDLogMessageRequest methodsFor: 'accessing' stamp: 'cwp 3/15/2005 23:41'!
properties
	^ properties! !

!MDLogMessageRequest methodsFor: 'accessing' stamp: 'cwp 3/15/2005 23:41'!
properties: aPropertyDictionary
	properties _ aPropertyDictionary! !

Notification subclass: #MDMergeRequest
	instanceVariableNames: 'merges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Utilities'!

!MDMergeRequest class methodsFor: 'signalling' stamp: 'cwp 3/25/2005 22:25'!
includeAll: versions in: aWorkingCopy
	| instance |
	instance _ self new.
	instance merges: (versions collect: [:ea | MDMerge toInclude: ea in: aWorkingCopy]).
	^ instance signal! !

!MDMergeRequest methodsFor: 'exceptionDescription' stamp: 'cwp 4/25/2005 04:35'!
defaultAction
	MDMergeTool openOn: merges! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 3/25/2005 21:23'!
merges
	^ merges! !

!MDMergeRequest methodsFor: 'accessing' stamp: 'cwp 3/25/2005 21:23'!
merges: aCollection
	merges _ aCollection! !

PackageInfo subclass: #MDVwExportInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Info'!

!MDVwExportInfo class methodsFor: 'exporting' stamp: 'cwp 3/19/2005 00:49'!
export
	self new export! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 3/20/2005 01:11'!
classes
	^ super classes reject: [:ea | ea category endsWith: '-Info']! !

!MDVwExportInfo methodsFor: 'exporting' stamp: 'cwp 3/19/2005 01:43'!
export
	MDVwExporter fileOutPackage: self! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 3/19/2005 00:42'!
externalName
	^ 'Monticello'! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 6/18/2005 20:52'!
methodCategoryPrefix
	^ '*monticello2'! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 6/18/2005 20:52'!
methods
	^ super methods! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 3/19/2005 22:04'!
packageName
	^ 'Monticello2VwExport'! !

!MDVwExportInfo methodsFor: 'registering' stamp: 'cwp 3/19/2005 22:01'!
register
! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 3/19/2005 22:06'!
systemCategoryPrefix
	^ 'Monticello2'! !

PackageInfo subclass: #Monticello2Info
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Info'!

!Monticello2Info class methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 22:00'!
initialize
	self new register! !

SharedPool subclass: #MDBogusPoolA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

Object subclass: #MDBogusA
	instanceVariableNames: 'one'
	classVariableNames: 'Alpha'
	poolDictionaries: 'MDBogusPoolA'
	category: 'Monticello2-Fakes'!

MDBogusA class
	instanceVariableNames: 'aleph'!

SharedPool subclass: #MDBogusPoolB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Fakes'!

VW5PackageExporter subclass: #MDVwExporter
	instanceVariableNames: ''
	classVariableNames: 'QualifiedClassNames'
	poolDictionaries: ''
	category: 'Monticello2-Info'!

!MDVwExporter class methodsFor: 'intialize-release' stamp: 'cwp 4/9/2005 05:20'!
initialize
	QualifiedClassNames _ Dictionary new.
	QualifiedClassNames
		at: TestCase put: 'XProgramming.SUnit.TestCase';
		at: AbstractString put: 'String';
		at: String put: 'ByteString';
		at: MethodReference put: 'Smalltalk.Store.MethodDescriptor'.! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/20/2005 01:24'!
fileOut
	stream nextPutAll: '<?xml version="1.0"?>'; cr; cr.
	
	self tag: 'st-source' do: [
		self fileOutTimeStamp.
		self fileOutClassDefinitions.
		self fileOutMethods.
		self fileOutInitializers.
	]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 22:26'!
fileOutClassDefinitions
	(ChangeSet superclassOrder: package classes)
		do: [:ea | self fileOutClass: ea]
		displayingProgress: 'Filing out classes...'
		! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:07'!
fileOutClassVariable: aSymbol class: aClass
	self
		fileOutSharedVariable: aSymbol
		environment: (self fullyQualifiedClassNameFor: aClass)
		category: 'class variables'
		package: (self packageNameForClass: aClass)! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 02:58'!
fileOutClass: aClass
	aClass superclass == SharedPool
		ifTrue: [self fileOutSharedPool: aClass]
		ifFalse: [self fileOutClassDefinition: aClass]
! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 22:10'!
fileOutInitializers		
	(package classes select: [:c | c class includesSelector: #initialize])
		do: [:class | self fileOutInitializerForClass: class].! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:25'!
fileOutNameSpace
	self tag: 'name-space' do: [
		self tag: 'name' with: self environment.
		self tag: 'environment' with: 'Smalltalk'.
		self tag: 'private' with: 'false'.
		self tag: 'imports' do: [
			stream nextPutAll: 'private Smalltalk.*'; cr.
			stream nextPutAll: 'private Smalltalk.Squeak.*'; cr.
		].
		self tag: 'category' with: self environment.
		self tag: 'attributes' do: [
			self tag: 'package' with: self environment, '-Core'.
		].
	]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:07'!
fileOutSharedPool: aClass
	self 
		fileOutSharedVariable: aClass name
		environment: self environment
		category: 'shared pools'
		package: (self packageNameForClass: aClass)! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:07'!
fileOutSharedVariable: name environment: namespace category: category package: packageName
	stream cr; cr.
	
	self tag: 'shared-variable' do: [
		self tag: 'name' with: name.
		self tag: 'environment' with: namespace.
		self tag: 'private' with: 'false'.
		self tag: 'constant' with: 'false'.
		self tag: 'category' with: category.
		self tag: 'initializer' with: 'nil'.
		self tag: 'attributes' do: [
			self tag: 'package' with: packageName
		]
	]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 02:19'!
foreignClassNameFor: aClass
	| name |
	name _ QualifiedClassNames at: aClass theNonMetaClass ifAbsent: [^ aClass name].
	^ aClass isMeta
		ifTrue: [name, ' class']
		ifFalse: [name]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 01:26'!
fullyQualifiedClassNameFor: aClass
	^ (package includesClass: aClass)
		ifTrue: [self environment, '.', aClass name]
		ifFalse: [self foreignClassNameFor: aClass]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:12'!
packageNameForClass: aClass
	^ (#('Tests' 'Fakes') anySatisfy: [:ea | aClass theNonMetaClass category endsWith: ea])
		ifFalse: [self environment, '-Core']
		ifTrue: [self environment, '-Tests']! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 22:47'!
packageNameForMethod: aMethodReference
	^ self packageNameForClass: aMethodReference actualClass! !
MDMarshal initialize!
MDSqueakMetadataAdaptor initialize!
MDTimestampPrinter initialize!
MDHashstamp initialize!
MDTimestamp initialize!
Monticello2Info initialize!
MDVwExporter initialize!
